
-- Mission My Balloon

function Initialise()
    bronzetime = (60 * 1000) * 9999
    silvertime = 255000
    goldtime = (60 * 1000) * 4
   
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SetData("TurnTime", 45000)
    SetData("RoundTime", 600000)
    SetData("Jetpack.MaxAltitude", 5500)
    SendMessage("EFMV.Start")
    
    SendMessage("GameLogic.PlaceObjects")
    SetData("Crate.Spawn", "fuel1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 0)
    SetData("Crate.Pushable", 0)
    SetData("Crate.Contents", "kWeaponPetrolBomb")
    SetData("Crate.Index", 1)
    SetData("Trigger.TeamDestroy",10)
    SendMessage("GameLogic.CreateCrate")
   
    SetData("Camera.StartOfTurnCamera","Default")
    
    camdone = 0
    water = 0
    deadcpu = 0
    deadhuman = 0
    CrateCamRunning = 0
    Switch = 0

    SendStringMessage("Camera.Disable", "Track")
    SetupWormsAndTeams()
    SetupInventories()
    trigger()
    prop()
    prop2()
    First()
end

function First()    
    SetData("CommentaryPanel.Comment", "Miss.balloon.extra1")
    SetData("CommentaryPanel.Delay",4000)
    SendMessage("CommentaryPanel.TimedText")
    SetData("CommentaryPanel.Comment", "Miss.balloon.extra2")
    SetData("CommentaryPanel.Delay",2000)
    SendMessage("CommentaryPanel.TimedText")

    SetData("Camera.Path.Knots.Position", "cam1,cam2,cam3,cam4,cam5,cam6,cam7")
    SetData("Camera.Path.Knots.LookAt", "look1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",200)  
    SetData("Camera.Path.Steps.LookAt",790)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Second", 7000)
end

function Second()
    SetData("Camera.Path.Knots.Position", "SecondCam,SecondCam2")
    SetData("Camera.Path.Knots.LookAt", "SecondLook")
    SetData("Camera.Path.Steps.Position",450)  
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")
    
    AnimLoop = StartTimer("SecondAnim", 1500)
    AnimLoopRunning = 1
    CamLoop = StartTimer("Third", 3000)
end

function SecondAnim()
    AnimLoopRunning = 0
    SendIntMessage("Worm.ResetAnim", 4)
    SetData("Worm.ScriptAnim", "Salute")
    SendIntMessage("Worm.QueueAnim", 4)
end

function Third()
    SetData("CommentaryPanel.Comment", "Miss.balloon.extra3")
    SetData("CommentaryPanel.Delay",2500)
    SendMessage("CommentaryPanel.TimedText")

    SetData("Camera.Path.Knots.Position", "ThirdCam")
    SetData("Camera.Path.Knots.LookAt", "ThirdLook")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")
    
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 4)
    
    CamLoop = StartTimer("Fourth", 2700)
end

function Fourth()
    SetData("CommentaryPanel.Comment", "Miss.balloon.extra4")
    SetData("CommentaryPanel.Delay",2000)
    SendMessage("CommentaryPanel.TimedText")
    
    SetData("CommentaryPanel.Comment", "Miss.balloon.extra5")
    SetData("CommentaryPanel.Delay",2000)
    SendMessage("CommentaryPanel.TimedText")
    
    SetData("Camera.Path.Knots.Position", "FourthCam,FourthCam2")
    SetData("Camera.Path.Knots.LookAt", "FourthLook")
    SetData("Camera.Path.Steps.Position",650)  
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")
        
    CamLoop = StartTimer("Fifth", 5500)
end

function Fifth()    
    SetData("CommentaryPanel.Comment", "Miss.balloon.extra7")
    SetData("CommentaryPanel.Delay",4000)
    SendMessage("CommentaryPanel.TimedText")
    
    SetData("Camera.Path.Knots.Position", "Crate1Cam")
    SetData("Camera.Path.Knots.LookAt", "Crate1Look")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("Sixth", 2500)
end

function Sixth()
    SetData("Camera.Path.Knots.Position", "Crate2Cam")
    SetData("Camera.Path.Knots.LookAt", "Crate2Look")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("Seventh", 2500)
end

function Seventh()
    SetData("Camera.Path.Knots.Position", "BucketCam")
    SetData("Camera.Path.Knots.LookAt", "BucketLook")
    SetData("Camera.Path.Steps.Position",0)  
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")
    
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Salute")
    SendIntMessage("Worm.QueueAnim", 3)
    
    SetData("CommentaryPanel.Comment", "Miss.Apple.game6")
    SendMessage("CommentaryPanel.ScriptText")
    
    CamLoop = StartTimer("CameraFinished", 3000)
end

function CameraFinished()
    SendStringMessage("Camera.Enable", "Track")
    camdone = 1
    SendMessage("EFMV.End")
    StartFirstTurn()
end

function Camera_Path_Stopped()
    if camdone == 0 then
        SendMessage("Commentary.Clear")
        if AnimLoopRunning == 1 then
            CancelTimer(AnimLoop)
        end
        CancelTimer(CamLoop)
        camdone = 1
        SendMessage("EFMV.End")
        SendStringMessage("Camera.Enable", "Track")
        StartFirstTurn()
    end
end
-- cameras end here

--after crate is collected balloon will rise.
function Crate_Collected()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.balloon.extra8")
    SendMessage("CommentaryPanel.ScriptText")
    morefuel()
    
    CrateIndex = GetData("Crate.Index")
    if CrateIndex == 1 then
        SetData("Crate.Spawn", "fuel2")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Pushable", 0)
        SetData("Trigger.TeamDestroy",10)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 2)
        SendMessage("GameLogic.CreateCrate")
        SendMessage("EFMV.Start")
        PauseGame()
        if CrateCamRunning == 0 then
            CrateCam2()
        end
    elseif CrateIndex == 2 then
        SendMessage("GameLogic.PlaceObjects")
        SetData("Crate.Spawn", "fuel1a")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Pushable", 0)
        SetData("Trigger.TeamDestroy",10)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 3)
        SendMessage("GameLogic.CreateCrate")
        SendMessage("EFMV.Start")
        PauseGame()
        if CrateCamRunning == 0 then
            CrateCam1()
        end
    elseif CrateIndex == 3 then
        SendMessage("GameLogic.PlaceObjects")
        SetData("Crate.Spawn", "fuel2a")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Pushable", 0)
        SetData("Trigger.TeamDestroy",10)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 4)
        SendMessage("GameLogic.CreateCrate")
        SendMessage("EFMV.Start")
        PauseGame()
        if CrateCamRunning == 0 then
            CrateCam2()
        end
    elseif CrateIndex == 4 then
        SendMessage("GameLogic.PlaceObjects")
        SetData("Crate.Spawn", "fuel1b")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Pushable", 0)
        SetData("Trigger.TeamDestroy",10)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 5)
        SendMessage("GameLogic.CreateCrate")
        SendMessage("EFMV.Start")
        PauseGame()
        if CrateCamRunning == 0 then
            CrateCam1()
        end
    elseif CrateIndex == 5 then
        SendMessage("GameLogic.PlaceObjects")
        SetData("Crate.Spawn", "fuel2b")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Pushable", 0)
        SetData("Trigger.TeamDestroy",10)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 6)
        SendMessage("GameLogic.CreateCrate")
        SendMessage("EFMV.Start")
        PauseGame()
        if CrateCamRunning == 0 then
            CrateCam2()
        end
    elseif CrateIndex == 6 then
        SendMessage("GameLogic.PlaceObjects")
        SetData("Crate.Spawn", "fuel1")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Pushable", 0)
        SetData("Trigger.TeamDestroy",10)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Index", 1)
        SendMessage("GameLogic.CreateCrate")
        SendMessage("EFMV.Start")
        PauseGame()
        if CrateCamRunning == 0 then
            CrateCam1()
        end
    end
end 

function CrateCam2()
    CrateCamRunning = 1
    SetData("Camera.Path.Knots.Position", "BCrate2Cam,BCrate2Cam2")
    SetData("Camera.Path.Knots.LookAt", "BCrate2Look")
    SetData("Camera.Path.Steps.Position",550)
    SetData("Camera.Path.IgnoreInput", 1)
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")
    StartTimer("CrateCamEnd", 3000)
end

function CrateCam1()
    CrateCamRunning = 1
    SetData("Camera.Path.Knots.Position", "BCrate1Cam,BCrate1Cam2")
    SetData("Camera.Path.Knots.LookAt", "BCrate1Look")
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.IgnoreInput", 1)
    SetData("Camera.Path.Steps.LookAt",0)
    SendMessage("Camera.Path.Start")
    StartTimer("CrateCamEnd", 3000)
end

function CrateCamEnd()
    CrateCamRunning = 0
    SendMessage("EFMV.End")
    ResumeGame()
    SendMessage("Camera.SetDefault")
end

function morefuel()
    if water > -1 then
        water = water - 150
        SetData("Water.Level", water)
    end
end

function PauseGame()
    SendMessage("GameLogic.RoundTime.Pause")
    SendMessage("GameLogic.TurnTime.Pause")
    SendMessage("GameLogic.PauseGame")
    SendStringMessage("Camera.Disable", "Track")
    SetData("GameLogic.ArtilleryMode", 1)
end

function ResumeGame()
    SendMessage("GameLogic.RoundTime.Resume")
    SendMessage("GameLogic.TurnTime.Resume")
    SendMessage("GameLogic.ResumeGame")
    SendStringMessage("Camera.Enable", "Track")
    SetData("GameLogic.ArtilleryMode", 0)
end

function DoOncePerTurnFunctions()
    water = water + 60
    SetData("Water.Level", water)
end

function TurnEnded()    
    Team = GetData("CurrentTeamIndex")
    if Team == 1 and deadhuman < 4 and deadcpu < 5 then
        PauseGame()
        SendMessage("EFMV.Start")
        WaterRiseCamera()
    else
        CheckOneTeamVictory()
    end
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end
end



function FailureMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function SuccessMessages()
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function WaterRiseCamera()
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 3) + 1

    if MyRandomNumber == 1 then
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Miss.Boldly.NEW.game5")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Miss.Ball.game1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Miss.leek.extra6")
        SendMessage("CommentaryPanel.ScriptText")
    end

    if water < 480 then
        SetData("Camera.Path.Knots.Position", "SideShotCam")
        SetData("Camera.Path.Knots.LookAt", "SideShotLook")
        SetData("Camera.Path.Steps.Position",0)
        SetData("Camera.Path.Steps.LookAt",0)
        SetData("Camera.Path.IgnoreInput", 1)
        SendMessage("Camera.Path.Start")
    elseif water == 480 or water > 480 then
        SetData("Camera.Path.Knots.Position", "SideShotCam2")
        SetData("Camera.Path.Knots.LookAt", "SideShotLook2")
        SetData("Camera.Path.Steps.Position",0)
        SetData("Camera.Path.Steps.LookAt",0)
        SetData("Camera.Path.IgnoreInput", 1)
        SendMessage("Camera.Path.Start")
    end
    
    StartTimer("WaterRiseCameraEnd", 4000)
end

function WaterRiseCameraEnd()
    ResumeGame()
    SendMessage("EFMV.End")
    CheckOneTeamVictory()
end

function CheckOneTeamVictory()
    TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")
    
    if TeamCount == 0 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 0 then
        Switch = 1
        SuccessMessages()
        WhichAward()
    else
        StartTurn()
    end
end

function WhichAward()
    Result()
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
 
        if timetook < silvertime then
            Movie = 2
            
            if timetook < goldtime then
                Movie = 3

                Key,Lock = EditContainer("L.P.Donkey")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.P.Donkey")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function SelectRandomWind()
    -- First the speed
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    MaxWind = GetData("Wind.MaxSpeed")
    SetData("Wind.Speed", 0.9*MaxWind)

    -- Now a direction
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    Direction = RandomNumber * 2 * 3.14
    SetData("Wind.Direction", 3.3) 
end

-- sets up all the propellors
function prop()
    SetData("Particle.DetailObject", "zprop1")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")
    zaprop1 = GetData("Particle.Handle") 

    SetData("Particle.DetailObject", "zprop3")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")
    zaprop3 = GetData("Particle.Handle") 
        
    SetData("Particle.DetailObject", "zprop5")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")     
    zaprop5 = GetData("Particle.Handle") 

    SetData("Particle.DetailObject", "zprop7")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")
    zaprop7 = GetData("Particle.Handle") 

    SetData("Particle.DetailObject", "Mzprop9")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Kzprop9")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")       
end

--more props but set off at a different time so the look different
function prop2()
    SetData("Particle.DetailObject", "zprop2")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")
    zaprop2 = GetData("Particle.Handle")     

    SetData("Particle.DetailObject", "zprop4")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")
    zaprop4 = GetData("Particle.Handle") 
        
    SetData("Particle.DetailObject", "zprop6")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")
    zaprop6 = GetData("Particle.Handle") 
        
    SetData("Particle.DetailObject", "zprop8")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")
    zaprop8 = GetData("Particle.Handle") 
        
    SetData("Particle.DetailObject", "Mzprop10")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")
        
    SetData("Particle.DetailObject", "Kzprop10")
    SetData("Particle.Name", "Part_Propellor")
    SendMessage("Particle.NewEmitter")
end

function trigger()
    SetData("Trigger.Spawn", "bombert")
    SetData("Trigger.Radius", 110)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamDestroy", 0)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
        
    SetData("Trigger.Spawn", "stukat")
    SetData("Trigger.Radius", 90)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "fighter1t")
    SetData("Trigger.Radius", 90)
    SetData("Trigger.Index", 3)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "fighter2t")
    SetData("Trigger.Radius", 70)
    SetData("Trigger.Index", 4)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")    
    
    SetData("Trigger.Spawn", "fighter3t")
    SetData("Trigger.Radius", 90)
    SetData("Trigger.Index", 5)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")       
end

--when a trigger is destroyed it will blow up the plane
function Trigger_Destroyed()
    TriggerIndex = GetData("Trigger.Index")
	
    if TriggerIndex == 1 then
        CreateExplosion("bomberex1", 50, 0.35, 50, 80, 50)
        SetData("Particle.DetailObject", "bomberex1a")
	SetData("Particle.Name", "Part_LowExplosion")
	SendMessage("Particle.NewEmitter")
        BomberSmoke1 = GetData("Particle.Handle") 
        --bm1
    	--SendIntMessage("Particle.DeleteEmitter",zaprop2)
        --SendIntMessage("Particle.DeleteEmitter",zaprop3)
	--SendIntMessage("Particle.DeleteEmitter",zaprop4)
        --SendIntMessage("Particle.DeleteEmitter",zaprop5)
        StartTimer("Bgone", 100)
    elseif TriggerIndex == 2 then
        CreateExplosion("stukaex1", 50, 0.35, 50, 85, 50)
        SetData("Particle.DetailObject", "stukaex1a")
	SetData("Particle.Name", "Part_LowExplosion")
	SendMessage("Particle.NewEmitter")
        Stuka1Smoke1 = GetData("Particle.Handle")
        
        SetData("Particle.DetailObject", "stukaex1a")
	SetData("Particle.Name", "Part_Campfire")
	SendMessage("Particle.NewEmitter")
        ssmoke = GetData("Particle.Handle")
        
        StartTimer("Sgone", 400)
    elseif TriggerIndex == 3 then
        CreateExplosion("fighter1ex1", 50, 0.35, 50, 99, 50)
        SetData("Particle.DetailObject", "fighter1ex1a")
	SetData("Particle.Name", "Part_LowExplosion")
	SendMessage("Particle.NewEmitter")
        Fighter1Smoke1 = GetData("Particle.Handle")

        SetData("Particle.DetailObject", "fighter1ex1a")
	SetData("Particle.Name", "Part_Campfire")
	SendMessage("Particle.NewEmitter")
        fsmoke1 = GetData("Particle.Handle")
        
        StartTimer("F1gone", 400)
    elseif TriggerIndex == 4 then
        CreateExplosion("fighter2ex1", 50, 0.35, 50, 110, 50)
        SetData("Particle.DetailObject", "fighter2ex1a")
	SetData("Particle.Name", "Part_LowExplosion")
	SendMessage("Particle.NewEmitter")
        Fighter2Smoke1 = GetData("Particle.Handle")

        SetData("Particle.DetailObject", "fighter2ex1a")
	SetData("Particle.Name", "Part_Campfire")
	SendMessage("Particle.NewEmitter")
        fsmoke2 = GetData("Particle.Handle")   

        StartTimer("F2gone", 400)        
    elseif TriggerIndex == 5 then
        CreateExplosion("fighter3ex1", 50, 0.35, 50, 99, 50)
        SetData("Particle.DetailObject", "fighter3ex1a")
	SetData("Particle.Name", "Part_LowExplosion")
	SendMessage("Particle.NewEmitter")  
        Fighter3Smoke1 = GetData("Particle.Handle")        
        
        SetData("Particle.DetailObject", "fighter3ex1a")
	SetData("Particle.Name", "Part_Campfire")
	SendMessage("Particle.NewEmitter")
        fsmoke3 = GetData("Particle.Handle")
        
        StartTimer("F3gone", 400)
    end
end

-- main bomber, particles and deleting smoke particles afterwards
function Bgone()
    StartTimer("Bgone1", 100)
    CreateExplosion("bomberex2", 50, 0.35, 50, 80, 50)

    SetData("Particle.DetailObject", "bomberex2a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    BomberSmoke2 = GetData("Particle.Handle")
end

function Bgone1()
    StartTimer("Bgone2", 100)
    CreateExplosion("bomberex3", 50, 0.35, 50, 80, 50)
    CreateExplosion("bomberex4", 50, 0.35, 50, 80, 50)
    
    SetData("Particle.DetailObject", "bomberex3a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    BomberSmoke3 = GetData("Particle.Handle")
        
    SetData("Particle.DetailObject", "bomberex4a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    BomberSmoke4 = GetData("Particle.Handle")
end

function Bgone2()
    StartTimer("Bgone3", 100)
    CreateExplosion("bomberex5", 50, 0.35, 50, 80, 50)
    CreateExplosion("bomberex6", 50, 0.35, 50, 80, 50)
    
    --SetData("Particle.DetailObject", "bomberex5a")
    --SetData("Particle.Name", "EffectExplosion")
    --SendMessage("Particle.NewEmitter")
    --BomberSmoke5 = GetData("Particle.Handle")
    
    SetData("Particle.DetailObject", "bomberex6a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    BomberSmoke6 = GetData("Particle.Handle")
end

function Bgone3()
    CreateExplosion("bomberex7", 50, 0.35, 50, 80, 50)
    CreateExplosion("bomberex8", 50, 0.35, 50, 80, 50)
    
    SetData("Particle.DetailObject", "bomberex7a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    BomberSmoke7 = GetData("Particle.Handle")
    
    SetData("Particle.DetailObject", "bomberex8a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    BomberSmoke8 = GetData("Particle.Handle")
    
    StartTimer("DeleteBomberSmoke", 2500)
end

function DeleteBomberSmoke()
    SendIntMessage("Particle.DeleteEmitter",BomberSmoke1)
    SendIntMessage("Particle.DeleteEmitter",BomberSmoke2)
    SendIntMessage("Particle.DeleteEmitter",BomberSmoke3)
    SendIntMessage("Particle.DeleteEmitter",BomberSmoke4)
    --SendIntMessage("Particle.DeleteEmitter",BomberSmoke5)
    SendIntMessage("Particle.DeleteEmitter",BomberSmoke6)
    SendIntMessage("Particle.DeleteEmitter",BomberSmoke7)
    SendIntMessage("Particle.DeleteEmitter",BomberSmoke8)
end

--stuka blowing up
function Sgone()
    CreateExplosion("stukaex2", 50, 0.35, 50, 85, 50)

    SetData("Particle.DetailObject", "stukaex2a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    Stuka1Smoke2 = GetData("Particle.Handle")
    
    SendIntMessage("Particle.DeleteEmitter",zaprop1)
    SendIntMessage("Particle.DeleteEmitter",ssmoke)
    StartTimer("Sgone1", 500)
end

function Sgone1()
    CreateExplosion("stukaex3", 50, 0.35, 50, 85, 50)
    CreateExplosion("stukaex4", 50, 0.35, 50, 85, 50)
    
    SetData("Particle.DetailObject", "stukaex3a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    Stuka1Smoke3 = GetData("Particle.Handle")
    
    SetData("Particle.DetailObject", "stukaex4a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    Stuka1Smoke4 = GetData("Particle.Handle")
    
    StartTimer("DeleteStuka1Smoke", 3500)
end

function DeleteStuka1Smoke()
    SendIntMessage("Particle.DeleteEmitter",Stuka1Smoke1)
    SendIntMessage("Particle.DeleteEmitter",Stuka1Smoke2)
    SendIntMessage("Particle.DeleteEmitter",Stuka1Smoke3)
    SendIntMessage("Particle.DeleteEmitter",Stuka1Smoke4)
end

-- fighters blowing up
function F1gone()
    CreateExplosion("fighter1ex2", 50, 0.35, 50, 110, 50)
    CreateExplosion("fighter1ex3", 50, 0.35, 50, 110, 50)
    
    SetData("Particle.DetailObject", "fighter1ex2a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    Fighter1Smoke2 = GetData("Particle.Handle")
        
    SetData("Particle.DetailObject", "fighter1ex3a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    Fighter1Smoke3 = GetData("Particle.Handle")
    
    SendIntMessage("Particle.DeleteEmitter",zaprop8)
    SendIntMessage("Particle.DeleteEmitter",fsmoke1)
    
    StartTimer("DeleteFighter1Smoke", 3000)
end

function DeleteFighter1Smoke()
    SendIntMessage("Particle.DeleteEmitter",Fighter1Smoke1)
    SendIntMessage("Particle.DeleteEmitter",Fighter1Smoke2)
    SendIntMessage("Particle.DeleteEmitter",Fighter1Smoke3)
end

function F2gone()
    CreateExplosion("fighter2ex2", 50, 0.35, 50, 110, 50)
    CreateExplosion("fighter2ex3", 50, 0.35, 50, 110, 50)
    
    SetData("Particle.DetailObject", "fighter2ex2a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    Fighter2Smoke2 = GetData("Particle.Handle")
        
    SetData("Particle.DetailObject", "fighter2ex3a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    Fighter2Smoke3 = GetData("Particle.Handle")
    
    SendIntMessage("Particle.DeleteEmitter",zaprop6)
    SendIntMessage("Particle.DeleteEmitter",fsmoke2)
    
    StartTimer("DeleteFighter2Smoke", 3000)
end

function DeleteFighter2Smoke()
    SendIntMessage("Particle.DeleteEmitter",Fighter2Smoke1)
    SendIntMessage("Particle.DeleteEmitter",Fighter2Smoke2)
    SendIntMessage("Particle.DeleteEmitter",Fighter2Smoke3)
end

function F3gone()
    CreateExplosion("fighter3ex2", 50, 0.35, 50, 110, 50)
    CreateExplosion("fighter3ex3", 50, 0.35, 50, 110, 50)
    
    SetData("Particle.DetailObject", "fighter3ex2a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    Fighter3Smoke2 = GetData("Particle.Handle")
        
    SetData("Particle.DetailObject", "fighter3ex3a")
    SetData("Particle.Name", "Part_LowExplosion")
    SendMessage("Particle.NewEmitter")
    Fighter3Smoke3 = GetData("Particle.Handle")
    
    SendIntMessage("Particle.DeleteEmitter",zaprop7)
    SendIntMessage("Particle.DeleteEmitter",fsmoke3)

    StartTimer("DeleteFighter3Smoke", 3000)
end

function DeleteFighter3Smoke()
    SendIntMessage("Particle.DeleteEmitter",Fighter3Smoke1)
    SendIntMessage("Particle.DeleteEmitter",Fighter3Smoke2)
    SendIntMessage("Particle.DeleteEmitter",Fighter3Smoke3)
end

function Worm_Died()
    deadworm = GetData("DeadWorm.Id")
    if deadworm == 0 or deadworm == 1 or deadworm == 2 or deadworm == 3 then
        deadhuman = deadhuman + 1
    elseif deadworm == 4 or deadworm == 5 or deadworm == 6 or deadworm == 7 or deadworm == 8 then
        deadcpu = deadcpu + 1
    end
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Flying Circus"
    team.FlagGfxName = "106"
    team.IsAIControlled = true
    team.TeamColour = 1
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data00")
    lock, worm = EditContainer("Worm.Data00")
    worm.Energy = 80
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm1"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock)
    
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01")
    worm.Spawn = "HumanWorm2"   
    worm.Name = GM.T1_W2_Name
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02")
    worm.Spawn = "HumanWorm3"   
    worm.Name = GM.T1_W3_Name
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03")
    worm.Spawn = "HumanWorm4"   
    worm.Name = GM.T1_W4_Name
    CloseContainer(lock)
    
    lock, worm = EditContainer("Worm.Data04") 
    CopyContainer("AIParams.CPU2", "AIParams.Worm04")
    worm.Active = true
    worm.Name = "Red Leader"
    worm.Spawn = "EnemyCPU1"
    worm.SfxBankName = "Biggles"
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data05")
    CopyContainer("AIParams.Worm04", "AIParams.Worm05")
    lock, worm = EditContainer("Worm.Data05") 
    worm.Name = "Red Two"
    worm.Spawn = "EnemyCPU2"   
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data06")
    CopyContainer("AIParams.Worm04", "AIParams.Worm06")
    lock, worm = EditContainer("Worm.Data06") 
    worm.Name = "Green Five"
    worm.Spawn = "EnemyCPU3"   
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data07")
    CopyContainer("AIParams.Worm04", "AIParams.Worm07")
    lock, worm = EditContainer("Worm.Data07") 
    worm.Name = "Gold Leader"
    worm.Spawn = "EnemyCPU4"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data04", "Worm.Data08")
    CopyContainer("AIParams.Worm04", "AIParams.Worm08")
    lock, worm = EditContainer("Worm.Data08") 
    worm.Name = "Red Five"
    worm.Spawn = "EnemyCPU5"
    CloseContainer(lock)
    
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Bazooka = -1 
    inventory.Parachute = -1
    inventory.ClusterGrenade = 4
    inventory.Girder = 1
    inventory.HomingMissile = 1
    inventory.SkipGo = -1
    inventory.Teleport = 1
    CloseContainer(lock)

    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Grenade = -1
    inventory.ClusterGrenade = 2
    inventory.Prod = -1
    inventory.FirePunch = -1
    inventory.SkipGo = -1
    CloseContainer(lock)

    lock, delays = EditContainer("Inventory.WeaponDelays") 
    delays.HomingMissile = 4
    delays.ClusterGrenade = 2
    CloseContainer(lock)
end
