-- Mission chute challenge deux

function Initialise()
    SendMessage("Commentary.NoDefault")

    camdone = 0
    wsafe = 0
    turnnum = 1
    Level = 1
    SelectRandomWind()
    Time = 6000
    
    SetData("Particle.Snow.Prob", 100)
    SetData("Particle.Rain.Prob", 0)
    
    SetData("RoundTime", 50000)
    SetData("TurnTime", 0)
    SendMessage("HUD.HideTurnTime")
    SetData("Jetpack.InitFuel", 22000)
    SetData("Jetpack.MaxAltitude", 6500)
    SendStringMessage("Camera.Disable", "Track")
    SetData("Camera.StartOfTurnCamera","Default")
    SendMessage("GameLogic.PlaceObjects")
   
    SendMessage("EFMV.Start")
    SetupWormsAndTeams()
    SetupInventories()
   
    lock, worm = EditContainer("Worm.Data00")
    worm.WeaponIndex = 41
    CloseContainer(lock)
    targets()
    camera()
end

function camera()
    CameraFly = 1
    SetData("CommentaryPanel.Comment", "Chall.Chute2.Intro1")
    SetData("CommentaryPanel.Delay",3500)
    SendMessage("CommentaryPanel.TimedText")
    SetData("CommentaryPanel.Comment", "Chall.Chute2.Intro2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2")
    SetData("Camera.Path.Knots.LookAt", "Look1,Look2,Look3")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",900)  
    SetData("Camera.Path.Steps.LookAt",500)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera2", 7500)
end

function camera2()
    SetData("CommentaryPanel.Comment", "Chall.Chute2.Intro3")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
    SetData("Camera.Path.Knots.Position", "Pos3,Pos4")
    SetData("Camera.Path.Knots.LookAt", "Look4")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",300)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera3", 3000)
end

function camera3()
    SetData("CommentaryPanel.Comment", "Chall.Chute2.Intro4")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
    SetData("Camera.Path.Knots.Position", "Pos5,Pos6")
    SetData("Camera.Path.Knots.LookAt", "Look5,Look6")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",600)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera4", 5000)
end

function camera4()
    SetData("Camera.Path.Knots.Position", "Pos7,Pos8")
    SetData("Camera.Path.Knots.LookAt", "Look7")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",400)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera5", 3000)
end

function camera5()
    SetData("Camera.Path.Knots.Position", "Pos9,Pos10")
    SetData("Camera.Path.Knots.LookAt", "Look8")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",400)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera6", 3000)
end

function camera6()
    SetData("Camera.Path.Knots.Position", "Pos11,Pos12")
    SetData("Camera.Path.Knots.LookAt", "Look9")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",500)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera7", 3000)
end

function camera7()
    SetData("CommentaryPanel.Comment", "Chall.Chute2.Intro5")
    SetData("CommentaryPanel.Delay",4000)
    SendMessage("CommentaryPanel.TimedText")
    SetData("Camera.Path.Knots.Position", "Pos13,Pos14,Pos15")
    SetData("Camera.Path.Knots.LookAt", "Look10,Look11,Look12")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",400)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("StartFirstTurn", 7250)
end

function StartTurn()
   done_once_per_turn_functions = false
   SendMessage("Timer.StartHotSeatTimer")
   SendMessage("GameLogic.ActivateNextWorm")
   SendMessage("Weapon.Create")
   SetWind()
   TurnStarted()
   SendMessage("GameLogic.Turn.Started")
   RunAILogic()
   
   turnnum = turnnum + 1
end

function SelectRandomWind()
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.3*MaxWind)

   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", 5.3) 
end

function Timer_GameTimedOut()
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win3")
    SendMessage("CommentaryPanel.ScriptText")

    endturn()
end

function endturn()
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
     timetook = GetData("ElapsedRoundTime")
     goldtime = GetData("MCa.BestGold")
     silvertime = GetData("MCa.BestSilver")
     bronzetime = GetData("MCa.BestBronze")
     if timetook > goldtime then
            SetData("GameOver.AwardMovie","gold")
        elseif timetook > silvertime then
            SetData("GameOver.AwardMovie","silver")
        elseif timetook > bronzetime then
            SetData("GameOver.AwardMovie","bronze")
        end
     SendMessage("GameLogic.Challenge.Result")
end


function Weapon_PoweringUpStart()
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
end

function Crate_Collected()
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    SetData("RoundTimeRemaining", RoundTimeRemaining + Time)

    CrateNumber = GetData("Crate.Index")

    if CrateNumber == 5 then
        SetData("CommentaryPanel.Comment", "Chall.Chute2.Nice1")
        SendMessage("CommentaryPanel.ScriptText")
    end
    
    if CrateNumber == 10 then
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+25000)
        SendIntMessage("Crate.Delete", 1) 
        SendIntMessage("Crate.Delete", 3) 
        SendIntMessage("Crate.Delete", 5) 
        SendIntMessage("Crate.Delete", 6) 
        SendIntMessage("Crate.Delete", 8)
        SendIntMessage("Crate.Delete", 9) 
    
        Level = 2
        SetData("Crate.Spawn", "targ0")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 20)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 5)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")
    end
    
    if CrateNumber == 15 then
    SetData("CommentaryPanel.Comment", "Chall.Chute2.Nice2")
    SendMessage("CommentaryPanel.ScriptText")
    end

    if CrateNumber == 20 then
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+15000)
        SendIntMessage("Crate.Delete", 11) 
        SendIntMessage("Crate.Delete", 13) 
        SendIntMessage("Crate.Delete", 15) 
        SendIntMessage("Crate.Delete", 16) 
        SendIntMessage("Crate.Delete", 18)
        SendIntMessage("Crate.Delete", 19) 
        Level = 1
    
        SetData("Crate.Spawn", "Level2")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 222)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 5)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")
        
        if Time > 1000 then
            Time = Time - 1000
        end
    end
    
    if CrateNumber == 222 then
        targets2()    
    end  
end

function BorderEnd()
    SendMessage("EFMV.End")
end

function targets()
     	SetData("Crate.Spawn", "targ1")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 1)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 6)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")
       
      	SetData("Crate.Spawn", "targ3")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 6)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")       
                
        SetData("Crate.Spawn", "targ5")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 6)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")     
        
      	SetData("Crate.Spawn", "targ6")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 6)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 6)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")
    
      	SetData("Crate.Spawn", "targ8")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 8)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 6)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")       
        
        SetData("Crate.Spawn", "targ9")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 9)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 6)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")      
                
        SetData("Crate.Spawn", "targ10")
        SetData("Crate.Type", "Utility")
	SetData("Crate.Index", 10)
        SetData("Crate.Contents", "kUtilityJetpack")
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Scale", 2)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")     
end

function targets2()
     	SetData("Crate.Spawn", "targ11")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 11)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 5)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")
       
      	SetData("Crate.Spawn", "targ13")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 13)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 5)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")       
                
        SetData("Crate.Spawn", "targ15")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 15)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 5)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")     
        
      	SetData("Crate.Spawn", "targ16")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 16)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 4)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")

      	SetData("Crate.Spawn", "targ18")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 18)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 4)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")       
        
        SetData("Crate.Spawn", "targ19")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 19)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 2)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")      
                
        SetData("Crate.Spawn", "targ20")
        SetData("Crate.Type", "Utility")
	SetData("Crate.Index", 20)
        SetData("Crate.Contents", "kUtilityJetpack")
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Scale", 2)
        SetData("Crate.WaitTillLanded", 0)         
	SendMessage("GameLogic.CreateCrate")     
end

function StartFirstTurn()
    SendMessage("EFMV.End")
    WaitUntilNoActivity = false
    SendMessage("Timer.StartGame")
    StartTurn()
end

function Worm_Died()
    deadWorm = GetData("DeadWorm.Id")
    if deadWorm == 0 then
    SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
    SendMessage("CommentaryPanel.ScriptText") 
    end
    
    endturn()

end

function CheckOneTeamVictory()
end

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
   team.TeamColour = 0
   CloseContainer(lock)

   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
   worm.Energy = 1
   worm.Spawn = "spawn1"
   worm.WeaponFuse = 3
   worm.IsEmotional = false
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 

   SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
   lock, inventory = EditContainer("Inventory.Team.Default") 
   inventory.SuperSheep = 0
   inventory.Parachute = -1
   inventory.NinjaRope = 0
   inventory.Jetpack = 0
   CloseContainer(lock)

   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")

   lock, inventory = EditContainer("Inventory.Team01") 

   inventory.HomingMissile = 0
   inventory.HomingPidgeon = 0
   CloseContainer(lock)

   lock, delays = EditContainer("Inventory.WeaponDelays") 

   CloseContainer(lock)
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end

        StartFirstTurn()
    end
end
