
-- SHEEP CHALLENGE III - Submission
-- needs times in frontend as of 5/8/03

function Initialise()
    SendMessage("Commentary.NoDefault")
    SetData("Camera.StartOfTurnCamera","Default")
    SendStringMessage("Camera.Disable", "Track")
    SendStringMessage("Camera.Disable", "Blimp")

    SetData("PostActivityTime", 0)
    SetData("TurnTime", 0)
    SetData("DefaultRetreatTime", 0)
    --round time used to be 30000
    SetData("RoundTime", 60000)
    SendMessage("HUD.HideTurnTime")    
    SetData("GameLogic.ArtilleryMode", 1)
    SetData("Land.Indestructable", 1)
    
    SendMessage("GameLogic.PlaceObjects")

    SendMessage("EFMV.Start") 

    RoundOverSwitch = 0
    AddTime = 0
    Time = 5000
    Switch = 0
    RoundDone = 0
    EndGame = 0
    NewCrate = 0

    MakeNewCrate()
    SetupWormsAndTeams()
    SetupInventories()
    Camera()
end

function Camera()
    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro1")
    SetData("CommentaryPanel.Delay",2800)
    SendMessage("CommentaryPanel.TimedText")
    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro2")
    SetData("CommentaryPanel.Delay",2800)
    SendMessage("CommentaryPanel.TimedText")
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2,Pos3")
    SetData("Camera.Path.Knots.LookAt", "Look1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",320)  
    SetData("Camera.Path.Steps.LookAt",290)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera2", 5000)
end

function Camera2()
    StartTimer("Intro3Text", 1500)
    SetData("Camera.Path.Knots.Position", "Pos4,Pos5")
    SetData("Camera.Path.Knots.LookAt", "Look2,Look3")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",450)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera3", 4850)
end

function Intro3Text()
    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro3")
    SetData("CommentaryPanel.Delay",2800)
    SendMessage("CommentaryPanel.TimedText")
end

function Camera3()
    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro4")
    SetData("CommentaryPanel.Delay",2800)
    SendMessage("CommentaryPanel.TimedText")
    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro5")
    SetData("CommentaryPanel.Delay",2800)
    SendMessage("CommentaryPanel.TimedText")
    SetData("Camera.Path.Knots.Position", "Pos6,Pos7,Pos8")
    SetData("Camera.Path.Knots.LookAt", "Look4,Look5")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",375)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera4", 8000)
end

function Camera4()
    StartTimer("Intro6", 1750)
    SetData("Camera.Path.Knots.Position", "Pos9,Pos10")
    SetData("Camera.Path.Knots.LookAt", "Look6,Look7")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",375)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera5", 4000)
end

function Intro6()
    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro6")
    SetData("CommentaryPanel.Delay",2800)
    SendMessage("CommentaryPanel.TimedText")
end

function Camera5()
    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro7")
    SetData("CommentaryPanel.Delay",2800)
    SendMessage("CommentaryPanel.TimedText")

    SetData("Camera.Path.Knots.Position", "Pos11,Pos12")
    SetData("Camera.Path.Knots.LookAt", "Look8")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",375)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera6", 5400)
end

function Camera6()
    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro8")
    SetData("CommentaryPanel.Delay",2800)
    SendMessage("CommentaryPanel.TimedText")
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Smile")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Camera.Path.Knots.Position", "Pos13")
    SetData("Camera.Path.Knots.LookAt", "Look9")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",375)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("start", 2000)
end
 
function Camera_Path_Stopped()
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    -- start the game proper if the camera is interupted
    CancelTimer(CamLoop)
    start()
end

function start()
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    SendMessage("EFMV.End")
    StartFirstTurn()
end

function Worm_Died()
    deadWorm = GetData("DeadWorm.Id")
    if deadWorm == 0 then
        Switch = 1
    end
end

function Timer_GameTimedOut()
    EndGame = 1

    if RoundOverSwitch == 0 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText")
        
        RoundDone = 1
        RoundOver()
    end
end

function RoundOver()
    RoundOverSwitch = 1
	
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText")
    
    Result()
end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////

function Result()  
    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")
     
    if timetook > bronzetime then
        Movie = 1
        if timetook > silvertime then
            Movie = 2
            if timetook > goldtime then
                Movie = 3

                Key,Lock = EditContainer("L.W.SSheep")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.W.SSheep")
                end
                CloseContainer(Key)
            end
        end
    end

    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Challenge.Result")
end

-- This will be called when a sheep snuffs it
function TurnEnded()
   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
   
   if TeamCount == 0 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
        -- the worm just died
	if RoundOverSwitch == 0 then
            RoundOverSwitch = 1
            RoundOver()
	end
   else
        -- give him another go 
        StartTurn()
   end
end

function Crate_Collected()
    SetData("CommentaryPanel.Comment", "missrum.game5")
    SendMessage("CommentaryPanel.ScriptText") 
        
    MakeNewCrate()
end

function Crate_Destroyed()
    AddTime = 1
    MakeNewCrate()
end

function MakeNewCrate()
    if EndGame == 0 then
        if AddTime == 0 then
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining + Time)
        end
    end
    --bm1
    if NewCrate == 0 then
	SetData("Crate.Spawn", "Kcrate0")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 1)
        SetData("Crate.Scale", 3.2)
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)
        SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 1 then
	SetData("Crate.Spawn", "crate1")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 1)
        SetData("Crate.Scale", 3.2)
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0)        
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 2 then
	SetData("Crate.Spawn", "crate2")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 2)
        SetData("Crate.Scale", 3.2)
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0) 
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 3 then
	SetData("Crate.Spawn", "crate3")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 3)
        SetData("Crate.Scale", 3.2)
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0) 
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 4 then
	SetData("Crate.Spawn", "crate4")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 4)
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0) 
        SetData("Crate.Scale", 3.2)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 5 then
	SetData("Crate.Spawn", "crate5")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 5)
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0) 
        SetData("Crate.Scale", 3.1)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 6 then
	SetData("Crate.Spawn", "crate6")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 6)
        SetData("Crate.Scale", 3)
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0) 
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 7 then
	SetData("Crate.Spawn", "crate7")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 7)
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.Parachute", 0) 
        SetData("Crate.Scale", 3)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 8 then
	SetData("Crate.Spawn", "crate8")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 8)
        SetData("Crate.Scale", 2.6)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 9 then
	SetData("Crate.Spawn", "crate9")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 9)
        SetData("Crate.Scale", 2.2)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 10 then
	SetData("Crate.Spawn", "crate10")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 11 then
	SetData("Crate.Spawn", "crate11")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 11)
        SetData("Crate.Scale", 2)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 12 then
	SetData("Crate.Spawn", "crate12")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 12)
        SetData("Crate.Scale", 1.9)
	SendMessage("GameLogic.CreateCrate")
        NewCrate = 0
        if Time > 1000 then
            Time = Time - 1000
        end
    end
    
    AddTime = 0
    NewCrate = NewCrate + 1
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 1
    worm.Spawn = "spawn1"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
 
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.SuperSheep = -1
    CloseContainer(lock)
    
    lock, weapon = EditContainer("kWeaponSuperSheep")
    weapon.LifeTime = -1
    CloseContainer(lock)

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
end
