
-- Tutorial 4 Kong 


function Initialise()

    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SendMessage("GameLogic.PlaceObjects")
    
    SendMessage("HUD.HideTurnTime")
    SetData("HUD.Clock.DisplayRoundTime", 0)

    SetData("Land.Indestructable", 1)
    
    SetData("HotSeatTime", 0)
    SetData("RoundTime", 0) 
    SetData("TurnTime", 0)
    SetData("Jetpack.MaxAltitude", 5500)
    SendMessage("Commentary.NoDefault")
    SetData("Camera.StartOfTurnCamera","Default")

    
    SendMessage("EFMV.Start") 
    firsttime = 1
    camdone = 0
    diewhere = 0
    whichbrief = 0
    timer1 = 0
    Switch = 0
    StartTimer("Spawntrigger", 1000)
    
    
-- thes keep count of when a crate respawns    
    cratetimes = 0
    cratetimesj = 0  
    cratetimesp = 0
    cratetimesn = 0 
    cratetimesf = 0    
    
--  WhatCrate variable is used in function SpawnCrawn().    
    WhatCrate = 0

    SetupWormsAndTeams()
    SetupInventories()
    --StartFirstTurn()
    timer1 = StartTimer("anims2", 1000)

    timer = -1
    camera()
    --first crate
    SetData("Crate.Spawn", "Girder")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 1)
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamDestructible", 3)
    SetData("Crate.Contents", "kUtilityGirder")
    
    SendMessage("GameLogic.CreateCrate")
    
end


--////////////////////////////////////////////////////////////////////////////

function SelectRandomWind()

   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.2*MaxWind)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", -0.2)
end



-- Displays text when a crate is collected
-- also sets a camera up so that it looks
-- at where the next crate is.
function Crate_Collected()

    CrateIndex = GetData("Crate.Index")
    
    if CrateIndex == 1 then
    
    
        diewhere = 1
        SetData("CommentaryPanel.Comment", "Tut.Kong.game2")
        SendBriefingMessage() 
        SetData("CommentaryPanel.Comment", "Tut.Kong.game3")
        SendBriefingMessage() 

 
        WhatCrate = 2
        StartTimer("SpawnCrate", 1000)
    
            
        SetData("Camera.Path.IgnoreInput", 1)
    
        -- jetpack crate camera
        SetData("Camera.Path.Knots.Position", "jetcam, jetcam2")
        SetData("Camera.Path.Knots.LookAt", "jetlook")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",370)  
        SetData("Camera.Path.Steps.LookAt",990)
        SetData("Camera.Path.Tension.Position", -0.6) 
        SendMessage("Camera.Path.Start")
        
               
    elseif CrateIndex == 2 then
        -- We collected a Jetpack

        -- lose the old weapon
        lock, inventory = EditContainer("Inventory.Alliance00") 
        inventory.Girder = 0
        CloseContainer(lock)
        

        WhatCrate = 3

        
        diewhere = 2
        

        SetData("CommentaryPanel.Comment", "Tut.Kong.game6")
        SendBriefingMessage() 
        SetData("CommentaryPanel.Comment", "Tut.Kong.game7")
        SendBriefingMessage() 
        StartTimer("SpawnCrate", 1000)
        
        SetData("Camera.Path.IgnoreInput", 1)
        -- para crate camera
        SetData("Camera.Path.Knots.Position", "paracam, paracam2")
        SetData("Camera.Path.Knots.LookAt", "paralook")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",340)  
        SetData("Camera.Path.Steps.LookAt",990)
        SetData("Camera.Path.Tension.Position", -0.6) 
        SendMessage("Camera.Path.Start")
        
        
    
    elseif CrateIndex == 3 then
        -- We collected a Parachute
    
        -- lose the old weapon
        lock, inventory = EditContainer("Inventory.Alliance00") 
        inventory.Jetpack = 0
        CloseContainer(lock)
        SendMessage("Jetpack.Kill") -- Tell the worm to get rid of it
        
        diewhere = 3
        WhatCrate = 4
        -- remove parachute if still active...
        SendIntMessage("Parachute.Kill", 0)
        SetData("CommentaryPanel.Comment", "Tut.Kong.game8")
        SendBriefingMessage() 
        
        StartTimer("SpawnCrate", 1000)
        
        SetData("Camera.Path.IgnoreInput", 1)
        -- ninja crate camera
        SetData("Camera.Path.Knots.Position", "ninjacam, ninjacam2")
        SetData("Camera.Path.Knots.LookAt", "ninjalook")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",490)  
        SetData("Camera.Path.Steps.LookAt",990)
        SetData("Camera.Path.Tension.Position", -0.6) 
        SendMessage("Camera.Path.Start")
        
        
    elseif CrateIndex == 4 then
        -- We collected a Ninja rope    

        -- lose the old weapon
        lock, inventory = EditContainer("Inventory.Alliance00") 
        inventory.Parachute = 0
        CloseContainer(lock)
        SendIntMessage("Parachute.Kill", 0) -- Tell worm 0 to lose his parachute

        diewhere = 4
    
        SetData("CommentaryPanel.Comment", "Tut.Kong.game10")
        SendBriefingMessage() 

    
        SetData("Camera.Path.IgnoreInput", 1)
        -- ninja crate camera
        SetData("Camera.Path.Knots.Position", "firecam, firecam2")
        SetData("Camera.Path.Knots.LookAt", "firelook, firelook2, firelook3")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",690)  
        SetData("Camera.Path.Steps.LookAt",290)
        SetData("Camera.Path.Tension.Position", -0.6) 
        SendMessage("Camera.Path.Start")
    
        
        SetData("Crate.Spawn", "FirePunch")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 5)
        SetData("Crate.Contents", "kWeaponFirePunch")
        SendMessage("GameLogic.CreateCrate")

        
        
    elseif CrateIndex == 5 then
        -- we collected the firepunch

        -- lose the old weapon
        lock, inventory = EditContainer("Inventory.Alliance00")   
        inventory.NinjaRope = 0
        CloseContainer(lock)
        SendMessage("NinjaRope.Kill") -- tell the worm to lose it
        SendMessage("Weapon.Delete")
        SendMessage("Weapon.Create") -- auto select the firepunch

        diewhere = 5
        
        SetData("CommentaryPanel.Comment", "Tut.Kong.game12")
        SendBriefingMessage() 
        
    end    
end

function SpawnCrate()
    if WhatCrate == 1 then

    -- finds out what crate has just been picked up and then spawns in 
    -- the next one.
        
    elseif WhatCrate == 2 then

        SetData("Crate.Spawn", "Jetpack")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 2)
        SetData("Crate.Contents", "kUtilityJetpack")
        SendMessage("GameLogic.CreateCrate")

    elseif WhatCrate == 3 then
    
    
        SetData("Crate.Spawn", "Parachute")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 3)
        SetData("Crate.Contents", "kUtilityParachute")
        SendMessage("GameLogic.CreateCrate")

        
        
    elseif WhatCrate == 4 then
    
        SetData("Crate.Spawn", "NinjaRope")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 4)
        SetData("Crate.Contents", "kUtilityNinjaRope")
        SendMessage("GameLogic.CreateCrate")
    end
    
end






-- complete the tutorial
function endmission_success()



    Key,Lock = EditContainer("L.L.Kong")
    if Lock.Locked == true then
        Lock.Locked = false
        SetData("MCa.LockedName","L.L.Kong")
    end
    CloseContainer(Key)
    SetData("GameOver.AwardMovie","Experiment")
    SendMessage("GameLogic.Tutorial.Success")
end




--################################################################

-- below sorts out if to spawn another crate in if the user dies. 
-- It will spawn an extra crate at least 3 times before
-- it ends the mission with a fail.. phew :)


--girder respawns are below:
function crateagain()

cratetimes = cratetimes + 1

    if cratetimes == 1 then
    
        SetData("CommentaryPanel.Comment", "Miss.BoldlyNEW.game4")
        SendMessage("CommentaryPanel.ScriptText") 
      

        SetData("Crate.Spawn", "Girder")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 99)
        SetData("Crate.Contents", "kUtilityGirder")
        SendMessage("GameLogic.CreateCrate")

    end
    
    
    if cratetimes == 2 then
 
        SetData("CommentaryPanel.Comment", "Miss.Grave.game8")
        SendMessage("CommentaryPanel.ScriptText") 
       
 
        SetData("Crate.Spawn", "Girder")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 98)
        SetData("Crate.Contents", "kUtilityGirder")
        SendMessage("GameLogic.CreateCrate")

    end 
    
    
    if cratetimes == 3 then
 
        SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
        SendMessage("CommentaryPanel.ScriptText") 
      
        SetData("Crate.Spawn", "Girder")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 97)
        SetData("Crate.Contents", "kUtilityGirder")
        SendMessage("GameLogic.CreateCrate")

    end    
  

  
    
end




--jetpack respawns are below:
function crateagainj()

cratetimesj = cratetimesj + 1

    if cratetimesj == 1 then
    
        SetData("CommentaryPanel.Comment", "Miss.BoldlyNEW.game4")
        SendMessage("CommentaryPanel.ScriptText") 
    
        SetData("Crate.Spawn", "Jetpack")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 96)
        SetData("Crate.Contents", "kUtilityJetpack")
        SendMessage("GameLogic.CreateCrate")

    end
    
    
    if cratetimesj == 2 then
 
        SetData("CommentaryPanel.Comment", "Miss.Grave.game8")
        SendMessage("CommentaryPanel.ScriptText") 
       
 
        SetData("Crate.Spawn", "Jetpack")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 95)
        SetData("Crate.Contents", "kUtilityJetpack")
        SendMessage("GameLogic.CreateCrate")

    end 
    
    
    if cratetimesj == 3 then
 
        SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
        SendMessage("CommentaryPanel.ScriptText") 
       
 
        SetData("Crate.Spawn", "Jetpack")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 94)
        SetData("Crate.Contents", "kUtilityJetpack")
        SendMessage("GameLogic.CreateCrate")

        cratetimesj = 0
    end    
      
end    
    
    
--parachute respawns are below:    
function crateagainp()

cratetimesp = cratetimesp + 1

    if cratetimesp == 1 then
    
        SetData("CommentaryPanel.Comment", "Miss.BoldlyNEW.game4")
        SendMessage("CommentaryPanel.ScriptText") 
     
        SetData("Crate.Spawn", "Parachute")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 93)
        SetData("Crate.Contents", "kUtilityParachute")
        SendMessage("GameLogic.CreateCrate")

    end
    
    
    if cratetimesp == 2 then
 
        SetData("CommentaryPanel.Comment", "Miss.Grave.game8")
        SendMessage("CommentaryPanel.ScriptText") 
      
        SetData("Crate.Spawn", "Parachute")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 92)
        SetData("Crate.Contents", "kUtilityParachute")
        SendMessage("GameLogic.CreateCrate")

    end 
    
    
    if cratetimesp == 3 then
 
        SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
        SendMessage("CommentaryPanel.ScriptText") 
   
 
        SetData("Crate.Spawn", "Parachute")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 91)
        SetData("Crate.Contents", "kUtilityParachute")
        SendMessage("GameLogic.CreateCrate")
        
        cratetimesp = 0
    end    
    
end    
    
   
--ninjarope respawns are below:    
function crateagainn()

cratetimesn = cratetimesn + 1

    if cratetimesn == 1 then
    
        SetData("CommentaryPanel.Comment", "Miss.BoldlyNEW.game4")
        SendMessage("CommentaryPanel.ScriptText") 
     
        SetData("Crate.Spawn", "NinjaRope")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 90)
        SetData("Crate.Contents", "kUtilityNinjaRope")
        SendMessage("GameLogic.CreateCrate")

    end
    
    
    if cratetimesn == 2 then
 
        SetData("CommentaryPanel.Comment", "Miss.Grave.game8")
        SendMessage("CommentaryPanel.ScriptText") 
    
 
        SetData("Crate.Spawn", "NinjaRope")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 89)
        SetData("Crate.Contents", "kUtilityNinjaRope")
        SendMessage("GameLogic.CreateCrate")

    end 
    
    
    if cratetimesn == 3 then
 
        SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
        SendMessage("CommentaryPanel.ScriptText") 
      
        SetData("Crate.Spawn", "NinjaRope")
        SetData("Crate.Type", "Utility")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 88)
        SetData("Crate.Contents", "kUtilityNinjaRope")
        SendMessage("GameLogic.CreateCrate")

        cratetimesn = 0
        
    end    

end
    
    
 --firepunch respawns are below:   
function crateagainf()

cratetimesf = cratetimesf + 1

    if cratetimesf == 1 then
    
        SetData("CommentaryPanel.Comment", "Miss.BoldlyNEW.game4")
        SendMessage("CommentaryPanel.ScriptText") 
     
        SetData("Crate.Spawn", "FirePunch")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 87)
        SetData("Crate.Contents", "kWeaponFirePunch")
        SendMessage("GameLogic.CreateCrate")

    end
    
    
    if cratetimesf == 2 then
 
        SetData("CommentaryPanel.Comment", "Miss.Grave.game8")
        SendMessage("CommentaryPanel.ScriptText") 
     
 
        SetData("Crate.Spawn", "FirePunch")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 86)
        SetData("Crate.Contents", "kWeaponFirePunch")
        SendMessage("GameLogic.CreateCrate")

    end 
    
    
    if cratetimesf == 3 then
 
        SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
        SendMessage("CommentaryPanel.ScriptText") 
    
 
        SetData("Crate.Spawn", "FirePunch")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", -1)
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.Pushable", 0)
        SetData("Crate.TeamDestructible", 3)
        SetData("Crate.Index", 85)
        SetData("Crate.Contents", "kWeaponFirePunch")
        SendMessage("GameLogic.CreateCrate")
        cratetimesf = 0
    end    

end


-- below checks if a worm has died and is it's a human worm to respawn it
function TurnEnded()

   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")  
   
   -- if the worm still alive then continue
   if TeamCount == 2 then
      StartTurn()
   end

   if TeamCount == 1 then 
      -- reset inventory to zero after every death
      lock, inventory = EditContainer("Inventory.Alliance00") 
      inventory.Girder = 0
      inventory.Jetpack = 0
      inventory.Parachute = 0
      inventory.NinjaRope = 0
      inventory.FirePunch = 0
      CloseContainer(lock)
   end

   -- Is the ememy dead?
   EnemyWormContainer = QueryContainer("Worm.Data01")
   if EnemyWormContainer.Active == false then 
      SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
      SendMessage("CommentaryPanel.ScriptText")   
      StartTimer("endmission_success", 1000)
   
   elseif TeamCount == 1 and diewhere == 0 then
      -- all the worms have just snuffed it except enemy
        dietext()
       lock, worm = EditContainer("Worm.Data00") 
       worm.Active = true
       worm.Name = GM.T1_W1_Name
       worm.SfxBankName = GM.T1_Speech
       worm.Energy = 1
       worm.Spawn = "HumanWorm1"
       worm.WeaponFuse = 3
       worm.WeaponIsBounceMax = false
       worm.TeamIndex = 0
       CloseContainer(lock) 
       SendIntMessage("Worm.Respawn", 00)
               
        StartTurn()
   
     elseif TeamCount == 1 and diewhere == 1 then
      -- this section deals with respawning after a death during girder placement
      -- if the number of retries is exceeded then do not put up the retry text (it breaks the menu stack) and dont respawn the worm
       if cratetimes < 3 then
          dietext()
          lock, worm = EditContainer("Worm.Data00") 
          worm.Active = true
       worm.Name = GM.T1_W1_Name
       worm.SfxBankName = GM.T1_Speech
          worm.Energy = 1
          worm.Spawn = "HumanWorm1"
          worm.WeaponFuse = 3
          worm.WeaponIsBounceMax = false
          worm.TeamIndex = 0
          CloseContainer(lock) 
          SendIntMessage("Worm.Respawn", 00)
          crateagain()
          StartTurn()
      else
          SetData("CommentaryPanel.Comment", "Chall.Generic.Lose5")
          SendMessage("CommentaryPanel.ScriptText")
          SendMessage("GameLogic.Tutorial.Failure")
      end

    elseif TeamCount == 1 and diewhere == 2 then

        dietext()
       lock, worm = EditContainer("Worm.Data00") 
       worm.Active = true
       worm.Name = GM.T1_W1_Name
       worm.SfxBankName = GM.T1_Speech
       worm.Energy = 1
       worm.Spawn = "HumanWorm2"
       worm.WeaponFuse = 3
       worm.WeaponIsBounceMax = false
       worm.TeamIndex = 0
       CloseContainer(lock) 
      
        SendIntMessage("Worm.Respawn", 00)

      crateagainj()
      
        StartTurn()
   
    elseif TeamCount == 1 and diewhere == 3 then
      -- all the worms have just snuffed it except enemy
        dietext()
       lock, worm = EditContainer("Worm.Data00") 
       worm.Active = true
       worm.Name = GM.T1_W1_Name
       worm.SfxBankName = GM.T1_Speech
       worm.Energy = 1
       worm.Spawn = "HumanWorm3"
       worm.WeaponFuse = 3
       worm.WeaponIsBounceMax = false
       worm.TeamIndex = 0
       CloseContainer(lock) 
       
        SendIntMessage("Worm.Respawn", 00)
 
       
        crateagainp()
      
        StartTurn()

    elseif TeamCount == 1 and diewhere == 4 then
      -- all the worms have just snuffed it except enemy
        dietext()
       lock, worm = EditContainer("Worm.Data00") 
       worm.Active = true
       worm.Name = GM.T1_W1_Name
       worm.SfxBankName = GM.T1_Speech
       worm.Energy = 1
       worm.Spawn = "HumanWorm4"
       worm.WeaponFuse = 4
       worm.WeaponIsBounceMax = false
       worm.TeamIndex = 0
       CloseContainer(lock) 
      
        SendIntMessage("Worm.Respawn", 00)
  
        crateagainn()

        StartTurn()
        
    elseif TeamCount == 1 and diewhere == 5 then
      -- all the worms have just snuffed it except enemy
        dietext()
       lock, worm = EditContainer("Worm.Data00") 
       worm.Active = true
       worm.Name = GM.T1_W1_Name
       worm.SfxBankName = GM.T1_Speech
       worm.Energy = 1
       worm.Spawn = "HumanWorm5"
       worm.WeaponFuse = 3
       worm.WeaponIsBounceMax = false
       worm.TeamIndex = 0
       CloseContainer(lock) 
      
        SendIntMessage("Worm.Respawn", 00)

     
       crateagainf()
      
        StartTurn()

   
   elseif TeamCount == 0 then
      -- all the worms have just snuffed it including enemy
       dietext()
       lock, worm = EditContainer("Worm.Data00") 
       worm.Active = true
       worm.Name = GM.T1_W1_Name
       worm.SfxBankName = GM.T1_Speech
       worm.Energy = 1
       worm.Spawn = "HumanWorm5"
       worm.WeaponFuse = 3
       worm.WeaponIsBounceMax = false
       worm.TeamIndex = 0
       CloseContainer(lock) 
      
      
        SendIntMessage("Worm.Respawn", 00)
        StartTurn()    
        
   else
      -- still at least some worms left
      StartTurn()
   end
end



-- what text to display when a human worm dies 
function dietext()

    if diewhere == 0 then
    
       SetData("CommentaryPanel.Comment", "Miss.Schools.OhNo")
       SendBriefingMessage()

    elseif diewhere == 1 then
    
       SetData("CommentaryPanel.Comment", "Tut.Kong.retrygirder")
       SendBriefingMessage()

    elseif diewhere == 2 then
    
       SetData("CommentaryPanel.Comment", "Tut.Kong.retryjetpack")
       SendBriefingMessage()
    
    elseif diewhere == 3 then
    
       SetData("CommentaryPanel.Comment", "Tut.Kong.retrychute")
       SendBriefingMessage()  
    
    elseif diewhere == 4 then
    
       SetData("CommentaryPanel.Comment", "Tut.Kong.retryrope")
       SendBriefingMessage()    
    
    
    elseif diewhere == 5 then
    
       SetData("CommentaryPanel.Comment", "Tut.Kong.retrypunch")
       SendBriefingMessage()        
    
    end
end



function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
   
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.TeamColour = 0
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Cheeky Monkeys"
    team.TeamColour = 1
    team.FlagGfxName = "65"
    
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 1
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "HumanWorm1"
    CloseContainer(lock) 

    lock, worm = EditContainer("Worm.Data01") 
    worm.Active = true
    worm.Name = "Cheeky"
    worm.Energy = 1
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    worm.SfxBankName = "Classic"
    worm.Spawn = "CPUWorm1"
    worm.IsAllowedToTakeTurn = false
    CloseContainer(lock) 
    SendMessage("WormManager.Reinitialise")
    
end

function SetupInventories()

    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Grenade = 0
    inventory.FirePunch = 0
    inventory.SkipGo = 0
    --inventory.Surrender = -1
    CloseContainer(lock)

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
    CopyContainer("Inventory.Team.Default", "Inventory.Team01")
    
end

   

-- intro camera is below
function camera()

    timer1 = StartTimer("anims", 9000)
    SetData("Camera.Path.Knots.Position", "cam1,cam2,cam3,cam4,cam5")
    SetData("Camera.Path.Knots.LookAt", "look1,look2")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",299)  
    SetData("Camera.Path.Steps.LookAt",1190)
    SetData("Camera.Path.Tension.Position", -0.6) 
    SendMessage("Camera.Path.Start")

    
end



function Camera_Path_Reached_Knot()
   knot = GetData("Camera.Path.Knot")
      
   if knot == "cam5" then 
   
    timer = StartTimer("camera2", 2400)
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Smile")
    SendIntMessage("Worm.QueueAnim", 0)
  
   end

   if knot == "jetcam2" then  
   
        SetData("Camera.Path.IgnoreInput", 0)
        SetData("GameLogic.ArtilleryMode", 0)
        SendMessage("GameLogic.ResumeGame") 
        StartTurn()
        SendMessage("Camera.SetDefault")
   end
   
   
    if knot == "paracam2" then  
   


        
        
        SetData("Camera.Path.IgnoreInput", 0)
        SetData("GameLogic.ArtilleryMode", 0)
        SendMessage("GameLogic.ResumeGame") 
        StartTurn()
        SendMessage("Camera.SetDefault")
   end
   
   
    if knot == "ninjacam2" then  
   
        SetData("Camera.Path.IgnoreInput", 0)
        SetData("GameLogic.ArtilleryMode", 0)
        SendMessage("GameLogic.ResumeGame") 
        SetData("CommentaryPanel.Comment", "Tut.Kong.game9")
        SendBriefingMessage() 
        
        StartTurn()
        SendMessage("Camera.SetDefault")
   end
   
    if knot == "firecam2" then  
   
           SetData("CommentaryPanel.Comment", "Tut.Kong.game11")
        SendBriefingMessage() 
   
        SetData("Camera.Path.IgnoreInput", 0)
        SetData("GameLogic.ArtilleryMode", 0)
        SendMessage("GameLogic.ResumeGame") 
        StartTurn()
        SendMessage("Camera.SetDefault")
   end
   
   
    if knot == "introcam2" then  
    
        SetData("Camera.Path.IgnoreInput", 0)
        SetData("GameLogic.ArtilleryMode", 0)
        SendMessage("GameLogic.ResumeGame")
        whichbrief = 0
        SetData("CommentaryPanel.Comment", "Tut.Kong.game5")
        SendBriefingMessage()
        
        StartTurn()
            
    end
   
   
end


function camera2()

    SetData("Camera.Path.Knots.Position", "cam1")
    SetData("Camera.Path.Knots.LookAt", "look1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",350)  
    SetData("Camera.Path.Steps.LookAt",990)
    SetData("Camera.Path.Tension.Position", -0.6) 
    SendMessage("Camera.Path.Start")
    timer = StartTimer("camera5", 1500)
    
end


function camera5()

    SetData("Camera.Path.Knots.Position", "cam6")
    SetData("Camera.Path.Knots.LookAt", "look3")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",350)  
    SetData("Camera.Path.Steps.LookAt",990)
    SetData("Camera.Path.Tension.Position", -0.6) 
    SendMessage("Camera.Path.Start")
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "WTF")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Worm.ScriptAnim", "Bored1")
    SendIntMessage("Worm.QueueAnim", 0)   

    timer = StartTimer("finish", 4500)

end


function SendBriefingMessage()

    SendStringMessage("FE.QueuePopUpLight","Game.BriefDialog")

end





function Input_SomeInput()

    if camdone == 0 then
        SendIntMessage("Worm.ResetAnim", 0)
        camdone =  1
        finish()
    end
    
end


function Game_BriefingDialogOkPressed()

    -- test where in the script we were so we know what to do here..
    if whichbrief == 1 then
        -- ok, we were at the briefing text for briefing 1, so lets go to
        SetData("Camera.Path.IgnoreInput", 1) 
        
    SetData("Camera.Path.IgnoreInput", 1)
        
    SetData("Camera.Path.Knots.Position", "introcam, introcam2")
    SetData("Camera.Path.Knots.LookAt", "introlook")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",399)  
    SetData("Camera.Path.Steps.LookAt",190)
    SetData("Camera.Path.Tension.Position", -0.6) 
    SendMessage("Camera.Path.Start")
        
        
    end
    
end




function finish()
    camdone = 1
    CancelTimer(timer1)
    CancelTimer(timer)

    SendMessage("EFMV.End") 
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("CommentaryPanel.Comment", "Tut.Kong.game1")
    SendBriefingMessage()
    whichbrief = 1
end

function anims()

    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Wave_Left")
    SendIntMessage("Worm.QueueAnim", 0)
    
end

function anims2()

    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Wave_Left")
    SendIntMessage("Worm.QueueAnim", 0)
    
end



