
-- Mission AI TEST

function Initialise()
-- Sets up mines and turn time
--    SetData("Mine.DudProbabilty", 0.1)
--    SetData("Mine.MinFuse", 1000)
--    SetData("Mine.MaxFuse", 5000)
--
----*** BELOW SETS THE CRATE UP ALONG WITH ANY VALUES ***    
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 25)
    	SetData("Crate.Spawn", "crate1")
        --SendMessage("GameLogic.CreateCrate")
    	SetData("Crate.Spawn", "crate2")
        --SendMessage("GameLogic.CreateCrate")
    	SetData("Crate.Spawn", "crate3")
        --SendMessage("GameLogic.CreateCrate")
    	SetData("Crate.Spawn", "crate4")
        --SendMessage("GameLogic.CreateCrate")
    	SetData("Crate.Spawn", "crate5")
        --SendMessage("GameLogic.CreateCrate")
    	SetData("Crate.Spawn", "crate6")
        --SendMessage("GameLogic.CreateCrate")
    	SetData("Crate.Spawn", "crate7")
        --SendMessage("GameLogic.CreateCrate")
    	SetData("Crate.Spawn", "crate8")
        --SendMessage("GameLogic.CreateCrate")
----*** BELOW SETS THE WORMS TO ARTILLERY MODE ***
--        
--    --SetData("GameLogic.ArtilleryMode", 1)
--    SetData("GameLogic.ArtilleryMode", 0)
--   
--    --SetData("AI.WeaponsDontEndTurn", 1 )
--   

    --SetupTeleportIn()
    SendMessage("GameLogic.PlaceObjects")
    SetupWormsAndTeams()
    SetupInventories()
    StartFirstTurn()
    
end

-- stops weapons from ending turns
--function Weapon_PoweringUpStart()
--end
--function Weapon_Fired_Start()
--end
--function Weapon_Fired_End()
--end


function SetupTeleportIn()
    --for worm placement
   local WormIndex = 0
   local DataId = GetWormContainerName(WormIndex)
   while DataId ~= "" do
    
      lock, worm = EditContainer(DataId)
      worm.TeleportIn = true
      CloseContainer(lock)
    
      WormIndex = WormIndex + 1
      DataId = GetWormContainerName(WormIndex)
   end
end

function TurnStarted()
   TeleportIn()
end

function TeleportIn()
   local CurrentWorm = GetData("ActiveWormIndex")
   if CurrentWorm ~= -1 then
      local DataId = GetWormContainerName(CurrentWorm)
      local worm = QueryContainer(DataId)
      if worm.TeleportIn == true then
         SendMessage("WormManager.TeleportIn")
      end
   end
end


function SelectRandomWind()
-- First the speed
    --SendMessage("RandomNumber.Get")
    --RandomNumber = GetData("RandomNumber.Float")
    MaxWind = GetData("Wind.MaxSpeed")
---- The line below controls the strength in this case it will be no more than 6
--    --SetData("Wind.Speed", RandomNumber*MaxWind * 6 /10)
--    --SetData("Wind.Speed", 1 )
    --SetData("Wind.Speed", MaxWind * 5 / 10 )
---- Now a direction
--    --SendMessage("RandomNumber.Get")
--    --RandomNumber = GetData("RandomNumber.Float")
--    --Direction = RandomNumber * 2 * 3.14
    SetData("Wind.Direction", - 3.14 / 2 )
    --1.8 )  --Direction)   
end

function SetupWormsAndTeams()
-- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = "TARGETWORMS"
    team.TeamColour = 1
    team.IsAIControlled = true
    --team.AlliedGroup = 1
    CloseContainer(lock)
--    
---- Activate Team 1
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "SHOOTER"
    team.TeamColour = 1
    team.IsAIControlled = true
    team.AlliedGroup = 1
    CloseContainer(lock) -- must close the container ASAP
--    
-- Activate Team 2
--    lock, team = EditContainer("Team.Data02") 
--    team.Active = true
--    team.Name = "HUMAN"
--    team.TeamColour = 2
--    team.IsAIControlled = true
--    --team.AlliedGroup = 1
--    CloseContainer(lock) -- must close the container ASAP
--   
    
-- *********** BELOW ARE THE SHOOTING WORMS ENTER THE 'SPAWN' NUMBER AND TAKE OFF THE COMMENT CHARACTERS TO ENABLE *****     

    -- Worm 0, Team 1
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = "Mr.SHOOTER"
    worm.Energy = 500
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    worm.SfxBankName = "French Lover"
    worm.Spawn = "spawn16" --"patherblock1"
    CloseContainer(lock) 
    
    CopyContainer("AIParams.CPU5", "AIParams.Worm00")
--    lock, AIParams = EditContainer("AIParams.Worm00")
--    --AIParams.AttractorDetailObject = "imaginary_crate";
--    --AIParams.MovementJumpBackflipAllowed = false
--    --AIParams.ShotErrorDirect = 0.3
--    --AIParams.TargetDetailObject = "target_object"
--    --AIParams.ProjectileSweetSpotDistance = 0.0
--    --AIParams.WeightingExplosiveSecondaryDamage = -0.1
--    --AIParams.PrefShotgun = 6.0
--      CloseContainer(lock) 

    
----   -- Worm 1, Team 1
--    CopyContainer("Worm.Data00", "Worm.Data01")
--    lock, worm = EditContainer("Worm.Data01") 
--    worm.Name = "spawn11"
--    worm.Spawn = "spawn11"
--    CloseContainer(lock)
--    --CopyContainer("AIParams.Worm00", "AIParams.Worm01")
----   
    
---- Worm 2, Team 1
--    CopyContainer("Worm.Data00", "Worm.Data02")
--    lock, worm = EditContainer("Worm.Data02") 
--    worm.Name = "spawn15"
--    worm.Spawn = "spawn15"
--    CloseContainer(lock)
--    CopyContainer("AIParams.Worm00", "AIParams.Worm02")
----
---- Worm 3, Team 1
--    CopyContainer("Worm.Data00", "Worm.Data03")
--    lock, worm = EditContainer("Worm.Data03") 
--    worm.Name = "spawn17"
--    worm.Spawn = "spawn17"
--    CloseContainer(lock)
--    CopyContainer("AIParams.CPU5", "AIParams.Worm03")
----
-- *********** BELOW ARE THE TARGET WORMS ENTER THE 'SPAWN' NUMBER AND TAKE OFF THE COMMENT CHARACTERS TO ENABLE ***** 

---- Worm 4, Team 0
    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Name = "spawn11"
    worm.TeamIndex = 0
    worm.SfxBankName = "Classic"
    worm.Spawn = "spawn11"
    worm.Energy = 100
    CloseContainer(lock)
    
    CopyContainer("AIParams.CPU5", "AIParams.Worm04")
    CopyContainer("AIParams.CPU5", "AIParams.Worm05")
----    lock, AIParams = EditContainer("AIParams.Worm04")
--    --AIParams.AttractorDetailObject = "imaginary_crate";
--    --AIParams.MovementJumpForwardAllowed = false
--    --AIParams.MovementJumpError = 1.0
--    CloseContainer(lock) 
--
---- Worm 5, Team 0
--    CopyContainer("Worm.Data00", "Worm.Data05")
--    lock, worm = EditContainer("Worm.Data05")
--    worm.TeamIndex = 0
--    worm.Name = "spawn13"
--    worm.Spawn = "spawn13"
--    CloseContainer(lock)
----    --CopyContainer("AIParams.Worm04", "AIParams.Worm05")
----
-------- Worm 6, Team 0
--    CopyContainer("Worm.Data04", "Worm.Data06")
--    lock, worm = EditContainer("Worm.Data06")
--    worm.Name = "spawn17"
--    --worm.Spawn = "spawn6"
--    worm.Spawn = "spawn17"
--    CloseContainer(lock)
--    CopyContainer("AIParams.Worm04", "AIParams.Worm06")
----
------ Worm 7, Team 0
--   CopyContainer("Worm.Data04", "Worm.Data07")
--    lock, worm = EditContainer("Worm.Data07")
--    worm.Name = "spawn19"
--    worm.Spawn = "spawn19"
--    CloseContainer(lock)
----    
------ Worm 8, Team 0
--    CopyContainer("Worm.Data04", "Worm.Data08")
--    lock, worm = EditContainer("Worm.Data08")
--    worm.Name = "spawn19"
--    worm.Spawn = "spawn19"
--    CloseContainer(lock)
------ Worm 9, Team 0
--    CopyContainer("Worm.Data04", "Worm.Data09")
--    lock, worm = EditContainer("Worm.Data09")
--    worm.Energy = 110
--    worm.Name = "spawn20"
--    worm.Spawn = "spawn20"
--    CloseContainer(lock)
------ Worm 10, Team 0
--    CopyContainer("Worm.Data04", "Worm.Data10")
--    lock, worm = EditContainer("Worm.Data10")
--    worm.Name = "spawn21"
--    worm.Spawn = "spawn21"
--    CloseContainer(lock)
---- Worm 11, Team 0
--    CopyContainer("Worm.Data04", "Worm.Data11")
--    lock, worm = EditContainer("Worm.Data11")
--    worm.TeamIndex = 2
--    worm.Name = "human worm"
--    worm.Spawn = "spawn16"
--    CloseContainer(lock)

-- Worm 12, Team 2
--    CopyContainer("Worm.Data00", "Worm.Data12")
--    lock, worm = EditContainer("Worm.Data12")
--    worm.Name = "spawn10"
--    worm.TeamIndex = 2
--    worm.Energy = 1000
--    worm.SfxBankName = "Classic"
--    worm.Spawn = "spawn10"
--    CloseContainer(lock)
--    


  SendMessage("WormManager.Reinitialise")
end






-- *********** BELOW ARE THE WEAPONS FOR THE SHOOTIONG TEAM -1 IS INFINITE ***** 


function SetupInventories()
-- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = 0 
    inventory.Mortar = 0
    inventory.Grenade = 0
    inventory.ClusterGrenade = 0
    inventory.Airstrike = 0
    inventory.Dynamite = -1
    inventory.HolyHandGrenade = 0
    inventory.BananaBomb = 0
    inventory.Landmine = 0
    inventory.HomingMissile = 0
    inventory.HomingPidgeon = 0
    inventory.Sheep = 0
    inventory.SuperSheep = 0
    inventory.Parachute = 0
    inventory.Teleport = 0
    inventory.Jetpack = 9
    inventory.SkipGo = -1
    inventory.MadCow = 0
    inventory.OldWoman = 0
    inventory.Girder = 0
    inventory.BridgeKit = 0
    inventory.Shotgun = 0
    inventory.Uzi = 0
    inventory.GasCanister = 0
    inventory.NinjaRope = 9
    inventory.LowGravity = 0
    inventory.Freeze = 0
    inventory.QuickWalk = 0
    inventory.Prod = 0
    inventory.FirePunch = 0
    inventory.BaseballBat = 0
    inventory.BananaBomb = 0
    inventory.MegaMine = -1
    --inventory.StickyBomb = -1
    --inventory.Blowpipe = -1
    --inventory.ScalesOfJustice = -1
    --inventory.Earthquake = -1
    --inventory.NuclearBomb = -1
    inventory.ScalesOfJustice = 0
    
    
    CloseContainer(lock) -- must close the container ASAP

---- Copies this selection into each worm
   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")
   CopyContainer("Inventory.Team.Default", "Inventory.Team02")
   
   
---- *********** BELOW ARE THE WEAPONS FOR THE TARGET TEAM ANY WEAPON LISTED HERE WILL OVERWRITE THE LIST ABOVE FOR THE TARGET TEAM *****  
--    --lock, inventory = EditContainer("Inventory.Team00") 
--    --inventory.Bazooka = 0
    --CloseContainer(lock)
    
--    lock, inventory = EditContainer("Inventory.Worm00")
--    --lock, inventory = EditContainer("Inventory.Worm04")
--    --inventory.HolyHandGrenade = -1
--    --inventory.Minigun = 1
--    --inventory.Bazooka = -1
--    --inventory.Shotgun = 1
--    --inventory.Uzi = 1
--    --inventory.ClusterGrenade = -1
--    --inventory.FlameThrower = -1
--    --inventory.Airstrike = -1
    --inventory.Grenade = -1
    --inventory.SuperBananaBomb = -1
    --inventory.Sheep = -1
    --inventory.MadCow = -1
    --inventory.OldWoman = -1
    --inventory.SuperSheep = -1
    --inventory.Sheep = -1
    --inventory.ConcreteDonkey = 1
    --inventory.HomingMissile = 1
    --inventory.Dragonball = -1
    --inventory.Dynamite = -1
--    --inventory.BaseballBat = 1
--    --inventory.Lasergun = -1
--
--    --inventory.Prod = -1
--
--    --inventory.Landmine = -1
--    --inventory.Teleport = -1
--    CloseContainer(lock)
--   
--   
--    lock, inventory = EditContainer("Inventory.Team02") 
--    inventory.Bazooka = 0
--    CloseContainer(lock)
   
       --lock, delays = EditContainer("Inventory.WeaponDelays") 
       --delays.Airstrike = 4
       --CloseContainer(lock)

   
end


