
-- Mission Hook, Line and Skimmer

function Initialise()
-- Still need QA times....
    bronzetime = (60 * 1000) * 999
    silvertime = 340000
    goldtime = 310000

    SetData("HotSeatTime", 5000) 
    SendMessage("EFMV.Start")
    
    SetData("Particle.DetailObject", "Smoke")
    SetData("Particle.Name", "ParticleSmokePlume")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Bird1")
    SetData("Particle.Name", "Part_BirdSky")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Bird2")
    SetData("Particle.Name", "Part_BirdSky")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Butterfly")
    SetData("Particle.Name", "Part_Butterfly")
    SendMessage("Particle.NewEmitter")

    SetData("TurnTime", 45000)
    SetData("RoundTime", 420000)
    SendMessage("GameLogic.PlaceObjects")
    SendMessage("GameLogic.ChangeWind")

    SetData("Crate.Spawn", "Bazooka_1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 3)
    SetData("Crate.Contents", "kWeaponBazooka")
    SetData("Crate.Index", 1)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Trigger.Spawn", "Trigger")
    SetData("Trigger.Radius", 60)
    SetData("Trigger.Index", 100)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Trigger2")
    SetData("Trigger.Radius", 50)
    SetData("Trigger.Index", 101)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Trigger3")
    SetData("Trigger.Radius", 50)
    SetData("Trigger.Index", 102)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Trigger4")
    SetData("Trigger.Radius", 50)
    SetData("Trigger.Index", 103)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Camera.StartOfTurnCamera","Default")

    IndestOn()
    
    FunLoopRunning = 0
    AnimRunning = 0
    turns = 0
    CameraFly = 1
    Switch = 0
    
    SetupWormsAndTeams()
    SetupInventories()
    Camera()
end

function IndestOn()
    SetData("Land.Indestructable", 1)
end

function IndestOff()
    SetData("Land.Indestructable", 0)
end

function Camera()    
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2,Pos3,Pos4,Pos5")
    SetData("Camera.Path.Knots.LookAt", "Look1,Look2,Look2a,Look3")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",750)  
    SetData("Camera.Path.Steps.LookAt",550)
    SetData("Camera.Path.Tension.Position", -0.5)
    SendMessage("Camera.Path.Start")
        
    FunLoop = StartTimer("StartText", 6000)
    FunLoopRunning = 1
    
    Animm = StartTimer("HelpUs", 8500)
    AnimRunning = 1
    
    CamLoop2 = StartTimer("Whiteout", 12750)
    CamLoop2Running = 1
    
    CamLoop = StartTimer("Camera2", 13000)
    
    StartTimer("Hello", 14500)
end

function HelpUs()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "OverHere")
    SendIntMessage("Worm.QueueAnim", 0)
    StartTimer("HEYY", 1000)
end

function HEYY()
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "NotMe1")
    SendIntMessage("Worm.QueueAnim", 1)
end

function Hello()
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Wave_Left")
    SendIntMessage("Worm.QueueAnim", 3)
end

function Whiteout()
    CamLoop2Running = 0

    SetData("Particle.DetailObject", "white1")
    SetData("Particle.Name", "ParticleWhiteout")
    
    SendMessage("Particle.NewEmitter")
    id2 = GetData("Particle.Handle")
end

function Camera2()
    SetData("CommentaryPanel.Comment", "Miss.Hook.Enemy3")
    SendMessage("CommentaryPanel.ScriptText")
    SendIntMessage("Worm.ResetAnim", 5)
    SetData("Worm.ScriptAnim", "Taunt2")
    SendIntMessage("Worm.QueueAnim", 5)
    SetData("Camera.Path.Knots.Position", "Cam2Pos1")
    SetData("Camera.Path.Knots.LookAt", "Cam2LookAt1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",300)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera3", 2000)
end

function Camera3()
    SetData("CommentaryPanel.Comment", "Miss.Hook.Enemy4")
    SendMessage("CommentaryPanel.ScriptText")
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Scowl3")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("Camera.Path.Knots.Position", "Cam2Pos2")
    SetData("Camera.Path.Knots.LookAt", "Cam2LookAt2")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",300)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera4", 2000)
end

function Camera4()
    SetData("CommentaryPanel.Comment", "Miss.Hook.Enemy3")
    SendMessage("CommentaryPanel.ScriptText")
    SendIntMessage("Worm.ResetAnim", 4)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 4)
    SetData("Camera.Path.Knots.Position", "Cam2Pos3")
    SetData("Camera.Path.Knots.LookAt", "Cam2LookAt3")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",300)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera5", 2000)
end

function Camera5()
    SetData("CommentaryPanel.Comment", "Miss.Hook.Enemy4")
    SendMessage("CommentaryPanel.ScriptText")
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Scowl2")
    SendIntMessage("Worm.QueueAnim", 3)
    SetData("Camera.Path.Knots.Position", "Cam2Pos4")
    SetData("Camera.Path.Knots.LookAt", "Cam2LookAt4")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",300)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("CameraSickOf", 2400)
end

function CameraSickOf()
    SetData("CommentaryPanel.Comment", "Miss.Hook.Enemy4B")
    SendMessage("CommentaryPanel.ScriptText") 
    SetData("CommentaryPanel.Comment", "Miss.Hook.Enemy5")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "SickOfCam,SickOfCam2")
    SetData("Camera.Path.Knots.LookAt", "SickOfLook")
    SetData("Camera.Path.Steps.Position",100)
    SetData("Camera.Path.Steps.LookAt",100)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Smug2")
    SendIntMessage("Worm.QueueAnim", 0)
    
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 1)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 1)
    
    CamLoop = StartTimer("Barrel", 5000)
end

function Barrel()
    SetData("CommentaryPanel.Comment", "Miss.Hook.Remember2")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "BarrelCam")
    SetData("Camera.Path.Knots.LookAt", "BarrelLook")
    SetData("Camera.Path.Steps.Position",0)
    SetData("Camera.Path.Steps.LookAt",0)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("ST", 4000)
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        CancelTimer(CamLoop)
        CameraFly = 0
        
        if CamLoop2Running == 1 then
            CancelTimer(CamLoop2)
        end
        
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        
        if FunLoopRunning == 1 then
            CancelTimer(FunLoop)
        end
        
        if AnimRunning == 1 then
            CancelTimer(Animm)
        end
        
        SendMessage("Commentary.Clear")
        SendMessage("EFMV.End")
        StartFirstTurn()
    end
end

function ST()
    CameraFly = 0
    StartFirstTurn()
end
--cameras end here
function Crate_Collected()
    CrateNumber = GetData("Crate.Index")
    if CrateNumber == 1 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_2")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 2)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate2Cam()
    elseif CrateNumber == 2 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_3")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 3)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate3Cam()
    elseif CrateNumber == 3 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_4")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 4)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate1Cam()
    elseif CrateNumber == 4 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_5")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 5)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate2Cam()
    elseif CrateNumber == 5 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_6")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 6)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate3Cam()
    elseif CrateNumber == 6 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_1")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 1)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate1Cam()
    end
end

function Crate_Destroyed()
    CrateNumber = GetData("Crate.Index")
    if CrateNumber == 1 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_2")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 2)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate2Cam()
    elseif CrateNumber == 2 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_3")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 3)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate3Cam()
    elseif CrateNumber == 3 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_4")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 4)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate1Cam()
    elseif CrateNumber == 4 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_5")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 5)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate2Cam()
    elseif CrateNumber == 5 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_6")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 6)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate3Cam()
    elseif CrateNumber == 6 then
        PauseGame()
        SetData("Crate.Spawn", "Bazooka_1")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 3)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.Index", 1)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
        CrateCamRunning = 1
        Crate1Cam()
    end
end

function PauseGame()
    SendMessage("EFMV.Start")    
    SendMessage("GameLogic.RoundTime.Pause")
    SendMessage("GameLogic.TurnTime.Pause")
    SendMessage("GameLogic.PauseGame")
    --SendStringMessage("Camera.Disable", "Track")
    SetData("GameLogic.ArtilleryMode", 1)
end

function ResumeGame()
    CrateCamRunning = 0
    ExplosionCamRunning = 0
    SendMessage("EFMV.End")
    SendMessage("GameLogic.RoundTime.Resume")
    SendMessage("GameLogic.TurnTime.Resume")
    SendMessage("GameLogic.ResumeGame")
    SetData("GameLogic.ArtilleryMode", 0)
    SendMessage("Camera.SetDefault")
    --SendStringMessage("Camera.Enable", "Track")
end

function Crate1Cam()
    SetData("Camera.Path.Knots.Position", "Crate1Cam,Crate1Cam2")
    SetData("Camera.Path.Knots.LookAt", "Crate1Look")
    SetData("Camera.Path.Steps.Position",450)
    SetData("Camera.Path.Steps.LookAt",450)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("ResumeGame", 3000)
end

function Crate2Cam()
    SetData("Camera.Path.Knots.Position", "Crate2Cam,Crate2Cam2")
    SetData("Camera.Path.Knots.LookAt", "Crate2Look")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("ResumeGame", 3000)
end

function Crate3Cam()
    SetData("Camera.Path.Knots.Position", "Crate3Cam,Crate3Cam2")
    SetData("Camera.Path.Knots.LookAt", "Crate3Look")
    SetData("Camera.Path.Steps.Position",450)
    SetData("Camera.Path.Steps.LookAt",450)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("ResumeGame", 3000)
end

function Trigger_Destroyed()
    TriggerIndex = GetData("Trigger.Index")    
    if TriggerIndex == 100 then
        PauseGame()

        SetData("Particle.DetailObject", "Fuse")
        SetData("Particle.Name", "Part_DynamiteFuse")
        SendMessage("Particle.NewEmitter")

        SetData("Camera.Path.Knots.Position", "MainXCam,MainXCam2")
        SetData("Camera.Path.Knots.LookAt", "MainXLook")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",500)  
        SetData("Camera.Path.Steps.LookAt",0)
        SetData("Camera.Path.Tension.Position", 0) 
        SetData("Camera.Path.IgnoreInput", 1)
        SendMessage("Camera.Path.Start")

        ExplosionCamRunning = 1
        
        StartTimer("HouseExplosion", 3000)
    elseif TriggerIndex == 101 then
        PauseGame()
        
        SetData("Particle.DetailObject", "LFuse")
        SetData("Particle.Name", "Part_DynamiteFuse")
        SendMessage("Particle.NewEmitter")
        LFuse = GetData("Particle.Handle")

        SetData("Camera.Path.Knots.Position", "LeftXCam,LeftXCam2")
        SetData("Camera.Path.Knots.LookAt", "LeftXLook")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",500)  
        SetData("Camera.Path.Steps.LookAt",0)
        SetData("Camera.Path.Tension.Position", 0) 
        SetData("Camera.Path.IgnoreInput", 1)
        SendMessage("Camera.Path.Start")
        
        ExplosionCamRunning = 1
        
        StartTimer("LeftIsleExplode", 3000)
    elseif TriggerIndex == 102 then
        PauseGame()
        
        SetData("Particle.DetailObject", "RFuse")
        SetData("Particle.Name", "Part_DynamiteFuse")
        SendMessage("Particle.NewEmitter")
        RFuse = GetData("Particle.Handle")
        
        SetData("Camera.Path.Knots.Position", "RightXCam,RightXCam2")
        SetData("Camera.Path.Knots.LookAt", "RightXLook")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",500)  
        SetData("Camera.Path.Steps.LookAt",0)
        SetData("Camera.Path.Tension.Position", 0) 
        SetData("Camera.Path.IgnoreInput", 1)
        SendMessage("Camera.Path.Start")
        
        ExplosionCamRunning = 1
        
        StartTimer("RightIsleExplode", 3000)
    elseif TriggerIndex == 103 then
        PauseGame()
        
        SetData("Particle.DetailObject", "HFuse")
        SetData("Particle.Name", "Part_DynamiteFuse")
        SendMessage("Particle.NewEmitter")
        HFuse = GetData("Particle.Handle")
        
        SetData("Camera.Path.Knots.Position", "HumanXCam,HumanXCam2")
        SetData("Camera.Path.Knots.LookAt", "HumanXLook")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",600)  
        SetData("Camera.Path.Steps.LookAt",0)
        SetData("Camera.Path.Tension.Position", 0) 
        SetData("Camera.Path.IgnoreInput", 1)
        SendMessage("Camera.Path.Start")
        
        ExplosionCamRunning = 1
        
        StartTimer("MainIsleExplode", 3000)
    end
end

function LeftIsleExplode()
    SetData("CommentaryPanel.Comment", "Miss.Hook.Explosion")
    SendMessage("CommentaryPanel.ScriptText")

    IndestOff()
    SetData("Camera.Shake.Length",1000)
    SetData("Camera.Shake.Magnitude",0.30)
    SendMessage("Camera.ShakeStart")
    
    SetData("Particle.DetailObject", "LExp1")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "LExp2")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "LExp3")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    CreateExplosion("LExplode", 250, 0.35, 150, 300, 80)
    CreateExplosion("LExplode_b", 250, 0.35, 150, 300, 80)
    SendIntMessage("Particle.DeleteEmitter",LFuse)
    StartTimer("IndestOn", 3000)
    StartTimer("ResumeGame", 3000)
end

function RightIsleExplode()
    SetData("CommentaryPanel.Comment", "Miss.Hook.Explosion")
    SendMessage("CommentaryPanel.ScriptText")

    IndestOff()
    SetData("Camera.Shake.Length",1000)
    SetData("Camera.Shake.Magnitude",0.30)
    SendMessage("Camera.ShakeStart")
    
    SetData("Particle.DetailObject", "RExp1")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "RExp2")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "RExp3")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    CreateExplosion("RExplode", 250, 0.35, 150, 300, 80)
    CreateExplosion("RExplode_b", 250, 0.35, 150, 300, 80)
    SendIntMessage("Particle.DeleteEmitter",RFuse)
    StartTimer("IndestOn", 3000)
    StartTimer("ResumeGame", 3000)
end

function MainIsleExplode()
    IndestOff()
    SetData("Camera.Shake.Length",1000)
    SetData("Camera.Shake.Magnitude",0.30)
    SendMessage("Camera.ShakeStart")
    
    SetData("Particle.DetailObject", "HExp1")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "HExp2")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "HExp3")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    CreateExplosion("HExplode", 250, 0.35, 150, 150, 80)
    SendIntMessage("Particle.DeleteEmitter",HFuse)
    StartTimer("IndestOn", 3000)
    StartTimer("ResumeGame", 3000)
end

function HouseExplosion()
    SetData("CommentaryPanel.Comment", "Miss.Hook.Explosion")
    SendMessage("CommentaryPanel.ScriptText")

    IndestOff()

    SetData("Camera.Shake.Length",1000)
    SetData("Camera.Shake.Magnitude",0.30)
    SendMessage("Camera.ShakeStart")

    SetData("Particle.DetailObject", "ExplosionGfx")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "ExplosionGfx5")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "ExplosionGfx4")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Fireworks1")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
    Fireworks1 = GetData("Particle.Handle") 
    SetData("Particle.DetailObject", "Fireworks2")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
    Fireworks2 = GetData("Particle.Handle") 
    SetData("Particle.DetailObject", "Fireworks3")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
    Fireworks3 = GetData("Particle.Handle") 
    SetData("Particle.DetailObject", "Fireworks4")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
    Fireworks4 = GetData("Particle.Handle") 
    SetData("Particle.DetailObject", "Fireworks5")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
    Fireworks5 = GetData("Particle.Handle") 
    StartTimer("TheBang", 2000)
    StartTimer("IndestOn", 5000)
    StartTimer("ResumeGame", 5000)
end

function TheBang()
    SetData("Particle.DetailObject", "ExplosionGfx2")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "ExplosionGfx3")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "ExplosionGfx6")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "ExplosionGfx7")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "ExplosionGfx8")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "ExplosionGfx9")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    
    CreateExplosion("Explosion", 250, 0.35, 150, 300, 80)
    
    SetData("Camera.Shake.Length",1000)
    SetData("Camera.Shake.Magnitude",0.30)
    SendMessage("Camera.ShakeStart")
    
    CreateExplosion("Explosion2", 250, 0.35, 150, 300, 80)
    
    SendIntMessage("Particle.DeleteEmitter",Fireworks1)
    SendIntMessage("Particle.DeleteEmitter",Fireworks2)
    SendIntMessage("Particle.DeleteEmitter",Fireworks3)
    SendIntMessage("Particle.DeleteEmitter",Fireworks4)
    SendIntMessage("Particle.DeleteEmitter",Fireworks5)
end

function StartText()
    FunLoop = StartTimer("ET", 4000)
    --CamLoop = StartTimer("Fool", 21000)
    FunLoop2 = StartTimer("BossAnim", 20000)
end

function BossAnim()
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Taunt2")
    SendIntMessage("Worm.QueueAnim", 2)
end

function ET()
    SetData("CommentaryPanel.Comment", "Miss.Hook.ExtraText")
    SendMessage("CommentaryPanel.ScriptText")
end

function Fool()--bm1
    SetData("CommentaryPanel.Comment", "Miss.Hook.Remember2")
    SendMessage("CommentaryPanel.ScriptText")
end

function checkturns()
    if turns == 15 then
        SetData("CommentaryPanel.Comment", "Miss.Hook.Reinforcements")
        SendMessage("CommentaryPanel.ScriptText")
    elseif turns == 30 then
        SetData("CommentaryPanel.Comment", "Miss.Hook.Airstrikes")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function StartFirstTurn()   
    SendMessage("EFMV.End")
    CameraFly = 0
    WaitUntilNoActivity = false
    SendMessage("Timer.StartGame")
    StartTurn()
end

function TurnStarted()
    turns = turns + 1
    checkturns()

    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5)

    if MyRandomNumber == 0 then
        MaxWind = GetData("Wind.MaxSpeed")
        SetData("Wind.Speed", 0.8*MaxWind)
        SetData("Wind.Direction", 2)
    elseif MyRandomNumber == 1 then
        MaxWind = GetData("Wind.MaxSpeed")
        SetData("Wind.Speed", 0.7*MaxWind)
        SetData("Wind.Direction", 0.3)
    elseif MyRandomNumber == 2 then
        MaxWind = GetData("Wind.MaxSpeed")
        SetData("Wind.Speed", 0.6*MaxWind)
        SetData("Wind.Direction", 1.3)
    elseif MyRandomNumber == 3 then
        MaxWind = GetData("Wind.MaxSpeed")
        SetData("Wind.Speed", 0.6*MaxWind)
        SetData("Wind.Direction", 1.7)
    elseif MyRandomNumber == 4 then
        MaxWind = GetData("Wind.MaxSpeed")
        SetData("Wind.Speed", 0.5*MaxWind)
        SetData("Wind.Direction", 2.5)
    end
end


function WONWON()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.Hook.Success")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.generic.success")
    SendMessage("CommentaryPanel.ScriptText")
    
    Result()
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        Key,Lock = EditContainer("L.Sch.Sniping")
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName2","L.Sch.Sniping")
        end
        CloseContainer(Key)
        
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3                
                Key,Lock = EditContainer("L.P.Pink")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.P.Pink")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function CheckOneTeamVictory()
    SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")
    SendMessage("WormManager.GetSurvivingTeam")
    WhichTeam = GetData("SurvivingTeamIndex")

    if TeamCount == 0 then
        if Switch == 0 then
            SendMessage("GameLogic.Mission.Failure")
            SetData("CommentaryPanel.Comment", "Miss.Hook.Failure")
            SendMessage("CommentaryPanel.ScriptText")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            SendMessage("GameLogic.Mission.Failure")
            SetData("CommentaryPanel.Comment", "Miss.Hook.Failure")
            SendMessage("CommentaryPanel.ScriptText")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 0 then
        Switch = 1
        WONWON()
    else
        StartTurn()
    end
end


function TurnEnded()

    CheckOneTeamVictory()
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end
end

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Evil Ones"
    team.IsAIControlled = true
    team.FlagGfxName = "94"
    team.TeamColour = 1
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm1"
    worm.Energy = 75
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm2"
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data02")
    worm.Active = true
    worm.Energy = 65 
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.SfxBankName = "Pirate"
    worm.Name = "Pink Beard"
    worm.Spawn = "spawn3"
    worm.TeamIndex = 1
    CloseContainer(lock)
    CopyContainer("AIParams.CPU4", "AIParams.Worm02")

    CopyContainer("Worm.Data02", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03")    
    worm.Energy = 25
    worm.Name = "Henchman"
    worm.SfxBankName = "Pirate"
    worm.Spawn = "spawn4"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm02", "AIParams.Worm03")
    
    CopyContainer("Worm.Data02", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 25  
    worm.Name = "Henchman"
    worm.SfxBankName = "Pirate"
    worm.Spawn = "spawn5"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm02", "AIParams.Worm04")
    
    CopyContainer("Worm.Data02", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.Energy = 10
    worm.Name = "Henchman"
    worm.SfxBankName = "Pirate"
    worm.Spawn = "spawn6"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm02", "AIParams.Worm05")

    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    --inventory.Bazooka = -1
    --inventory.HomingMissile = -1
    inventory.SkipGo = -1
    CloseContainer(lock) 
    
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = -1
    inventory.Airstrike = 3
    inventory.ClusterGrenade = -1
    inventory.SkipGo = -1
    CloseContainer(lock) 
    
    lock, delays = EditContainer("Inventory.WeaponDelays")
    delays.Airstrike = 18
    CloseContainer(lock)
end


--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end

function SuccessMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end

end
