
-- Mission Basic setup 1v1 player

function Initialise()

-- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    --SetData("Mine.StartsMidAir", 0)

   --SendMessage("GameLogic.PlaceObjects")

   local i
      for i = 1,10 do
         SendMessage("GameLogic.CreateRandomMine")
         SendMessage("GameLogic.CreateRandomOildrum")
      end



	SetData("Crate.Spawn", "CrateSpawn2")
	SetData("Crate.Type", "Utility")
   SetData("Crate.Contents", "kUtilityScalesOfJustice")
	SendMessage("GameLogic.CreateCrate")

    SetupWormsAndTeams()
    SetupInventories()

   SetData("Camera.StartOfTurnCamera", "Default")

   crates = 0
   CrateLoop()

    StartFirstTurn()


    
end


function CrateLoop()

   SetData("Crate.GroundSnap", 0)
   SetData("Crate.Parachute", 1)
	SetData("Crate.Type", "Weapon")
   SetData("Crate.Contents", "kWeaponSuperSheep")
   SetData("Crate.RandomSpawnPos", 1)
   SetData("Crate.Gravity", 1)
   SetData("Crate.TrackCam", 0)
   SetData("Crate.WaitTillLanded",  0)
   SetData("Crate.DisableMessage", 1)
	SendMessage("GameLogic.CreateCrate")

   crates = crates + 1
   if crates < 10 then
      StartTimer("CrateLoop", 100)
   end
end


function SetupWormsAndTeams()
-- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GetData("User.HumanTeamName")
    team.TeamColour = 0
-- team.IsAIControlled = true
    CloseContainer(lock) -- must close the container ASAP
-- Activate Team 1
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Darksiders"
    team.TeamColour = 1
-- team.IsAIControlled = true
    CloseContainer(lock)
-- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GetData ("User.HumanWorm1")
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.SfxBankName = "Pirate"
    worm.Spawn = "spawn"
    CloseContainer(lock) 
-- Worm 1, Team 0
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GetData ("User.HumanWorm2")
    worm.Spawn = "spawn"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GetData ("User.HumanWorm3")
    worm.Spawn = "spawn"
    CloseContainer(lock)


    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = GetData ("User.HumanWorm4")
    worm.Spawn = "spawn"
    CloseContainer(lock)

-- Worm 4, Team 1
    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 80 
    worm.Name = "Agent Dennis"
    worm.TeamIndex = 1
    worm.SfxBankName = "Biggles"
    worm.Spawn = "spawn"
    CloseContainer(lock)


    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05") 
    worm.Name = GetData ("User.HumanWorm5")
    worm.Spawn = "spawn"
    CloseContainer(lock)



   SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
-- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade =-1
    inventory.Airstrike = -1
    inventory.Dynamite = -1
    inventory.HolyHandGrenade = -1
    inventory.BananaBomb = -1
    inventory.Landmine = -1
    inventory.HomingMissile = -1
    inventory.HomingPidgeon = 1
    inventory.Sheep = -1
    inventory.SuperSheep = -1
    inventory.Parachute = -1
    inventory.Teleport = -1
    inventory.Jetpack = -1
    inventory.SkipGo = -1
    -- SUPERBANANABOMB: inventory.SuperBananaBomb = -1
    inventory.MadCow = -1
    inventory.OldWoman = -1
    inventory.Girder = -1
    inventory.BridgeKit = -1
    -- MAILSTRIKE: inventory.MailStrike = -1
    inventory.Shotgun = -1
    inventory.Uzi = -1
    -- MINIGUN: inventory.Minigun = -1
    inventory.NuclearBomb = -1
    -- FLAMETHROWER: inventory.FlameThrower = -1
    inventory.GasCanister = -1
    inventory.NinjaRope = -1
    inventory.FirePunch = -1
    inventory.LowGravity = -1
    inventory.Freeze = -1
    -- LASER: inventory.Lasergun = -1
    inventory.QuickWalk = -1
    inventory.Prod = -1
    -- NAPALM: inventory.Napalm = -1
    inventory.PetrolBomb = -1
    inventory.ConcreteDonkey = -1
    inventory.BaseballBat = -1
    inventory.Mortar = -1
    -- VASE: inventory.MingVase = -1
    inventory.Earthquake = -1
  --  inventory.ScalesOfJustice = -1
    -- DRAGONBALL: inventory.Dragonball = -1
    inventory.LotteryStrike = -1
    inventory.DoctorsStrike = -1
    inventory.MegaMine = -1
    inventory.StickyBomb = -1
    inventory.Binoculars = -1
    inventory.Blowpipe = -1
    inventory.VikingAxe = -1
    inventory.Redbull = -1
    
    CloseContainer(lock) -- must close the container ASAP

-- Copies this selection into each worm
   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")
end


function Crate_Collected()
   --currentworm = GetData("ActiveWormIndex")
   --SetupWormsAndTeams()
   --SetData("ActiveWormIndex", currentworm)



    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06") 
    worm.Name = GetData ("User.HumanWorm6")
    worm.Spawn = "spawn"
    CloseContainer(lock)
   SendIntMessage("Worm.Respawn", 6)
end
