
-- Mission Tutorial 5

function Initialise()

    StartedSuddenDeath = false

-- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SetData("HotSeatTime", 10000) 
    SetData("RoundTime", 1200000) 
    SetData("TurnTime", 60000)
    --SendMessage("GameLogic.PlaceObjects")

   camdone = 0
   Switch = 0

   SendMessage("EFMV.Start")

    SetupWormsAndTeams()
    SetupInventories()
    --StartFirstTurn()
    camera()
    
end




function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   -- The line below controls the strength in this case it will be no more than 3
   SetData("Wind.Speed", RandomNumber*MaxWind * 3 /10)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", Direction)   
end

function CheckOneTeamVictory()
   -- SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")
    
        if TeamCount == 0 then
            Switch = 1
            FailureMessages()
            SendMessage("GameLogic.Tutorial.Failure")
    
        elseif TeamCount == 1 and WhichTeam == 1 then
            Switch = 1
            FailureMessages()
            SendMessage("GameLogic.Tutorial.Failure")
    
        elseif TeamCount == 1 and WhichTeam == 0 then
            Switch = 1
            SuccessMessages()
            WhichAward()
        else
    
      -- still at least 2 teams left
     StartTurn()
   end
end


function WhichAward()

    Key,Lock = EditContainer("L.L.Tubes")
    if Lock.Locked == true then
        Lock.Locked = false
        SetData("MCa.LockedName2","L.L.Tubes")
    end
    CloseContainer(Key)
    
    Key,Lock = EditContainer("L.Sch.Pro")
    if Lock.Locked == true then
        Lock.Locked = false
        SetData("MCa.LockedName","L.Sch.Pro")
    end
    CloseContainer(Key)
    
    SetData("GameOver.AwardMovie","GameComplete")
    SendMessage("GameLogic.Tutorial.Success")
end

function SetupWormsAndTeams()


   GM = QueryContainer("GM.GameInitData")
-- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.TeamColour = 0
--  team.IsAIControlled = true
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave

    CloseContainer(lock) -- must close the container ASAP
    
    
    
-- Activate Team 1
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Darksiders"
    team.TeamColour = 1
    team.IsAIControlled = true
    team.FlagGfxName = "65"
    CloseContainer(lock)
    
    
-- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "spawn1"
    CloseContainer(lock) 
-- Worm 1, Team 0
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn2"
    CloseContainer(lock)
-- Worm 2, Team 0
    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GM.T1_W3_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn3"
    CloseContainer(lock)
-- Worm 3, Team 0
    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = GM.T1_W4_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn4"
    CloseContainer(lock)
    
-- Worm 4, Team 1
    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    CopyContainer("AIParams.CPU1", "AIParams.Worm04")
    worm.Energy = 100 
    worm.Name = "Woz"
    worm.TeamIndex = 1
    worm.Spawn = "spawn5"
    worm.SfxBankName = "Classic"
    CloseContainer(lock)
-- Worm 5, Team 1
    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    CopyContainer("AIParams.Worm04", "AIParams.Worm05")
    worm.Energy = 100  
    worm.Name = "Wuz"
    worm.Spawn = "spawn6"
    worm.SfxBankName = "Classic"
    CloseContainer(lock)
    
-- Worm 6, Team 1
    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    CopyContainer("AIParams.Worm04", "AIParams.Worm06")
    worm.Energy = 100  
    worm.Name = "Waz"
    worm.Spawn = "spawn7"
    worm.SfxBankName = "Classic"
    CloseContainer(lock)
    
-- Worm 7, Team 1
    CopyContainer("Worm.Data04", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    CopyContainer("AIParams.Worm04", "AIParams.Worm07")
    worm.Energy = 100  
    worm.Name = "Wiz"
    worm.Spawn = "spawn8"
    worm.SfxBankName = "Classic"
    CloseContainer(lock)
   SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
-- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade = 5
    inventory.Airstrike = 1
    inventory.Dynamite = 1
    inventory.HolyHandGrenade = 1
    inventory.BananaBomb = 1
    inventory.Landmine = 3
    inventory.HomingMissile = 1
    inventory.HomingPidgeon = 1
    inventory.Sheep = 1
    inventory.SuperSheep = 1
    inventory.Parachute = 3
    inventory.Teleport = 2
    inventory.Jetpack = 2
    inventory.MadCow = 1
    inventory.Girder = 1
    inventory.Shotgun = 2
    inventory.Uzi = 2
    inventory.NinjaRope = 1
    inventory.FirePunch = 3
    inventory.Prod = -1
    inventory.PetrolBomb = 2
    inventory.BaseballBat = 1
    inventory.Mortar = 4
    inventory.SkipGo = -1

    
    
    CloseContainer(lock) -- must close the container ASAP

-- Copies this selection into each worm
   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")
   
   
   
    lock, delays = EditContainer("Inventory.WeaponDelays") 
   delays.Airstrike = 4
   delays.HomingMissile = 0
   delays.HomingPidgeon = 4   
   delays.MadCow = 6
   delays.HolyHandGrenade = 6   
   CloseContainer(lock)
   
      lock, inventory = EditContainer("Inventory.Team01") 
   inventory.Airstrike = 0
   inventory.HomingMissile = 0
   inventory.HomingPidgeon = 0
   inventory.Dynamite = 0
   inventory.HolyHandGrenade = 0
   inventory.BananaBomb = 0
   inventory.MadCow = 0
   
   CloseContainer(lock)
       
end

function StartFirstTurn()


    SetData("CommentaryPanel.Comment", "Tut TestTube.game1a")
    SendBriefingMessage()
        
   WaitUntilNoActivity = false
   SendMessage("Timer.StartGame")
   StartTurn()
end

function camera()
    SetData("Camera.Path.Knots.Position", "cam1,cam2,cam3,cam4,cam6,cam7,OrbitStart")
    SetData("Camera.Path.Knots.LookAt", "look1,look2,look3,look4,OrbitCentre")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",465)  
    SetData("Camera.Path.Steps.LookAt",480)
    SetData("Camera.Path.Tension.Position", -0.06) 
    SendMessage("Camera.Path.Start")
end


function Camera_Path_Reached_Knot()
   knot = GetData("Camera.Path.Knot")

    if knot == "cam4" then
       
        SendIntMessage("Worm.ResetAnim", 1)
        SetData("Worm.ScriptAnim", "Evil")
        SendIntMessage("Worm.QueueAnim", 1)
        SetData("Worm.ScriptAnim", "Smile3")
        SendIntMessage("Worm.QueueAnim", 1)
        SetData("Worm.ScriptAnim", "Evil")
        SendIntMessage("Worm.QueueAnim", 1)
        SetData("Worm.ScriptAnim", "Smile3")
        SendIntMessage("Worm.QueueAnim", 1)            
        
        SendIntMessage("Worm.ResetAnim", 2)
        SetData("Worm.ScriptAnim", "Smile2")
        SendIntMessage("Worm.QueueAnim", 2)
        SetData("Worm.ScriptAnim", "Smile3")
        SendIntMessage("Worm.QueueAnim", 2)
        SetData("Worm.ScriptAnim", "Smile3")
        SendIntMessage("Worm.QueueAnim", 2)
        SetData("Worm.ScriptAnim", "Smile3")
        SendIntMessage("Worm.QueueAnim", 2)        
        
        SendIntMessage("Worm.ResetAnim", 3)
        SetData("Worm.ScriptAnim", "Smile")
        SendIntMessage("Worm.QueueAnim", 3)
        SetData("Worm.ScriptAnim", "Smile3")
        SendIntMessage("Worm.QueueAnim", 3)
        SetData("Worm.ScriptAnim", "Smile2")
        SendIntMessage("Worm.QueueAnim", 3)
        SetData("Worm.ScriptAnim", "Smug1")
        SendIntMessage("Worm.QueueAnim", 3)          
        
        SetData("Camera.Path.Tension.Position", -0.3)
        
    end   

    if knot == "OrbitStart" then
    
      SetData("Camera.Orbit.Speed",0.2)
       startt()
       camdone = 1
       
    end
end

function startt()
    StartFirstTurn()
    SendMessage("EFMV.End")    
    
end

function Camera_Path_Stopped()

    if camdone == 0 then
        camdone =  1
        StartFirstTurn()
        SendMessage("EFMV.End")        
        
    end

end

function SendBriefingMessage()
    SendStringMessage("FE.QueuePopUpLight","Game.BriefDialog")
end



function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")

    SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
    SendMessage("CommentaryPanel.ScriptText")

end

function SuccessMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
    SendMessage("CommentaryPanel.ScriptText")


end


function TurnEnded()

    if Switch == 0 then
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        if (RoundTimeRemaining == 0 or RoundTimeRemaining < 0) and StartedSuddenDeath == false then
            StartedSuddenDeath = true
            SetAllWormsEnergy(1)
        end
    
        CheckOneTeamVictory()
    end
end


function SetAllWormsEnergy(energy)
    SuddenDeathMessages()

    local WormIndex = 0
    local DataId = GetWormContainerName(WormIndex)
    while DataId ~= "" do
        lock, worm = EditContainer(DataId)
        worm.Energy = energy
        CloseContainer(lock)
        WormIndex = WormIndex + 1
        DataId = GetWormContainerName(WormIndex)
    end
end


function SuddenDeathMessages()
    SendMessage("Commentary.Clear")

    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 6) + 1

    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.3")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.5")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 6 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.6")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

