
-- Mission Basic setup 1v1cpu player

function Initialise()


-- Sets up mines and turn time
   SetData("Mine.DudProbabilty", 0.1)
   SetData("Mine.MinFuse", 1000)
   SetData("Mine.MaxFuse", 5000)


   SendMessage("GameLogic.PlaceObjects")


   SelectRandomWind()

   SetupWormsAndTeams()
   SetupInventories()

   StartFirstTurn()


end

function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   -- The line below controls the strength in this case it will be no more than 6
   SetData("Wind.Speed", RandomNumber*MaxWind * 3 /10)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", Direction)   
end


function SetupWormsAndTeams()

   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = "Good Guys"
   team.TeamColour = 0
   CloseContainer(lock) -- must close the container ASAP

   -- Activate Team 1
   lock, team = EditContainer("Team.Data01") 
   team.Active = true
   team.Name = "Bad Guys"
   team.TeamColour = 1
   CloseContainer(lock)
   
      -- Activate Team 2
   lock, team = EditContainer("Team.Data02") 
   team.Active = true
   team.Name = "Axis"
   team.TeamColour = 2
   CloseContainer(lock)

   
         -- Activate Team 3
   lock, team = EditContainer("Team.Data03") 
   team.Active = true
   team.Name = "Allied"
   team.TeamColour = 3
   CloseContainer(lock)
   
   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = "Jegg"
   worm.Spawn = "spawn"
   worm.Energy = 100
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 

   -- Worm 1, Team 0
   CopyContainer("Worm.Data00", "Worm.Data01")
   lock, worm = EditContainer("Worm.Data01") 
   worm.Name = "Chesh"
   CloseContainer(lock)

   -- Worm 2, Team 0
   CopyContainer("Worm.Data00", "Worm.Data02")
   lock, worm = EditContainer("Worm.Data02") 
   worm.Name = "Bruce"
   CloseContainer(lock)

   -- Worm 3, Team 0
   CopyContainer("Worm.Data00", "Worm.Data03")
   lock, worm = EditContainer("Worm.Data03") 
   worm.Name = "Kel"
   CloseContainer(lock)

   -- Worm 4, Team 1
   CopyContainer("Worm.Data00", "Worm.Data04")
   lock, worm = EditContainer("Worm.Data04") 
   worm.Name = "Spadge"
   worm.TeamIndex = 1
   CloseContainer(lock)

   -- Worm 5, Team 1
   CopyContainer("Worm.Data04", "Worm.Data05")
   lock, worm = EditContainer("Worm.Data05") 
   worm.Name = "Kilburn"
   worm.Energy = 1
   CloseContainer(lock)

   -- Worm 6, Team 1
   CopyContainer("Worm.Data04", "Worm.Data06")
   lock, worm = EditContainer("Worm.Data06") 
   worm.Name = "Dennis"
   CloseContainer(lock)

   -- Worm 7, Team 1
   CopyContainer("Worm.Data04", "Worm.Data07")
   lock, worm = EditContainer("Worm.Data07") 
   worm.Name = "Dunstan"
   CloseContainer(lock)

   
   
      -- Worm 8, Team 2
   CopyContainer("Worm.Data00", "Worm.Data08")
   lock, worm = EditContainer("Worm.Data08") 
   worm.Name = "Fritz"
   worm.TeamIndex = 2
   CloseContainer(lock)
   
   
      -- Worm 9, Team 2
   CopyContainer("Worm.Data08", "Worm.Data09")
   lock, worm = EditContainer("Worm.Data09") 
   worm.Name = "Heinz"
   CloseContainer(lock)
   
   
         -- Worm 10, Team 2
   CopyContainer("Worm.Data08", "Worm.Data10")
   lock, worm = EditContainer("Worm.Data10") 
   worm.Name = "Whittman"
   CloseContainer(lock)
   
           -- Worm 11, Team 2
   CopyContainer("Worm.Data08", "Worm.Data11")
   lock, worm = EditContainer("Worm.Data11") 
   worm.Name = "Hun"
   CloseContainer(lock)
   
   
       -- Worm 12, Team 3
   CopyContainer("Worm.Data00", "Worm.Data12")
   lock, worm = EditContainer("Worm.Data12") 
   worm.Name = "Monty"
   worm.TeamIndex = 3
   CloseContainer(lock)
   
   
      -- Worm 13, Team 3
   CopyContainer("Worm.Data12", "Worm.Data13")
   lock, worm = EditContainer("Worm.Data13") 
   worm.Name = "Tommy"
   CloseContainer(lock)
   
   
         -- Worm 14, Team 3
   CopyContainer("Worm.Data12", "Worm.Data14")
   lock, worm = EditContainer("Worm.Data14") 
   worm.Name = "Private"
   CloseContainer(lock)
   
           -- Worm 15, Team 3
   CopyContainer("Worm.Data12", "Worm.Data15")
   lock, worm = EditContainer("Worm.Data15") 
   worm.Name = "Winston"
   CloseContainer(lock)
   
   SendMessage("WormManager.Reinitialise")

end



function SetupInventories()
   -- sets up a default container and adds our selection to it
   lock, inventory = EditContainer("Inventory.Team.Default") 
 inventory.Bazooka = -1
   inventory.Grenade = -1
   inventory.ClusterGrenade = 5
   inventory.Airstrike = 1
   inventory.Dynamite = 1
   inventory.HolyHandGrenade = 1
   inventory.BananaBomb = 1
   inventory.Landmine = 3
   inventory.Shotgun = -1
   inventory.Uzi = 3
   inventory.Minigun = 2
   inventory.HomingMissile = 1
   inventory.HomingPidgeon = 1
   inventory.Sheep = 2
   inventory.SuperSheep = 1
   inventory.Parachute = 3
   inventory.Teleport = 2
   inventory.Jetpack = 1
   inventory.SkipGo = -1
   inventory.SuperBananaBomb = 1
   CloseContainer(lock) -- must close the container ASAP


 

   -- Copies this selection into each worm


   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")
   CopyContainer("Inventory.Team.Default", "Inventory.Team02")
   CopyContainer("Inventory.Team.Default", "Inventory.Team03")
   

end



function Payload_Deleted()
  PayloadId = GetData("Payload.Deleted.Id")
  if PayloadId == MineId then
      SetData("CommentaryPanel.Comment", "Text.TestComment")
      SendMessage("CommentaryPanel.ScriptText")
  end
end
