
-- Mission The Crocketeer!

--The NEW idea is that the player takes control of The Crocketeer  - a weak worm who's got caught up
--in a bloody battle between 2 powerful teams. Staying alive is the aim of the game.

function Initialise()

    
    SendMessage("Commentary.NoDefault")
-- Still need QA times...
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 12
    goldtime = (60 * 1000) * 9

    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SetData("TurnTime", 30000)
    SetData("RoundTime", 1800000) 
    
    SetData("Trigger.Spawn", "Burn")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 999)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Particle.DetailObject", "Sparks1")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")

    SetData("Particle.DetailObject", "Sparks2")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
        
    SetData("Particle.DetailObject", "JET")
    SetData("Particle.Name", "Part_CrockJet")
    SendMessage("Particle.NewEmitter")
    
    SendMessage("GameLogic.PlaceObjects")
    MaxWind = GetData("Wind.MaxSpeed")
    SetData("Wind.Speed", 1*MaxWind)
    SetData("Wind.Direction", 5.3)
    
    SetData("Crate.Spawn", "Health1")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 10)
    SetData("Trigger.TeamCollect", 0)
    SetData("Crate.Index", 5)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
   
    SetData("Crate.Spawn", "crate1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponDynamite")
    SetData("Crate.Index", 1)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "crate2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponHolyHandGrenade")
    SetData("Crate.Index", 2) 
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "crate3")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 75 )
    SetData("Crate.Index", 3) 
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SendIntMessage("Crate.RadarHide", 3)
    SendIntMessage("Crate.RadarHide", 1)  
    SendIntMessage("Crate.RadarHide", 2)  

    SetupWormsAndTeams()
    SetupInventories()
    Camera()
    SendMessage("EFMV.Start")
end

function Camera()    
    SetData("CommentaryPanel.Comment", "Miss.Crocketeer.Nice")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Crocketeer.Nice2")
    SendMessage("CommentaryPanel.ScriptText")
    CameraFly = 1
    SetData("Camera.Path.Knots.Position", "Pos1")
    SetData("Camera.Path.Knots.LookAt", "LookAt1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",525)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera2", 4000)
end

function Camera2()
    CameraFly = 1
    Shake()
    StartTimer("ExplosionOne", 5000)
    StartTimer("ExplosionOne", 1500)
    StartTimer("ExplosionTwo", 3000)
    StartTimer("Shake", 3000)
    StartTimer("Sturt", 1500)
    StartTimer("Wurning", 4500)
    SetData("Camera.Path.Knots.Position", "Pos2,Pos3,Pos4")
    SetData("Camera.Path.Knots.LookAt", "LookAt2")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",525)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("GUUR", 6500)
end

function ExplosionOne()
    SetData("Particle.DetailObject", "Explosion1")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
end

function ExplosionTwo()
    SetData("Particle.DetailObject", "Explosion2")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
end

function Shake()
    SetData("Particle.DetailObject", "Explosion3")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    SetData("Camera.Shake.Length",2000)
    SetData("Camera.Shake.Magnitude",0.10)
    SendMessage("Camera.ShakeStart")
        
    StartTimer("Shake2", 15000)
end

function Sturt()
    SetData("CommentaryPanel.Comment", "Miss.Crocketeer.Start")
    SendMessage("CommentaryPanel.ScriptText")
end

function Wurning()
    SetData("CommentaryPanel.Comment", "Miss.Crocketeer.Warning")
    SendMessage("CommentaryPanel.ScriptText")
end
function TurnEnded()
    SendMessage("Worm.PendPoison")
    CheckOneTeamVictory()      
end

function StartTurn()
    checkteam()
    done_once_per_turn_functions = false
    SendMessage("Timer.StartHotSeatTimer")
    SendMessage("GameLogic.ActivateNextWorm")
    SendMessage("Weapon.Create")
    SetWind()
    SendMessage("GameLogic.Turn.Started")
    TurnStarted()
    RunAILogic()
end

function checkteam()
-- PC: the current team value is now called CurrentTeamIndex
    Team = GetData("CurrentTeamIndex")
    if Team == 0 then
    SetData("Worm.Poison.Default", 2)
    SendIntMessage("Worm.Poison", 8)
   end
end

function GUUR()
    StartFirstTurn()
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        StartFirstTurn()
    end
end

function StartTurnStartedCamera()
  -- SendMessage("Camera.Orbit.Start")
end

function Worm_Died()
    deadWorm = GetData("DeadWorm.Id")
    if deadWorm == 8 then
        endmissionfail()
    end
end

function endmissionsuccess()
        timetook = GetData("ElapsedRoundTime")
    if timetook < goldtime then
    Key,Lock = EditContainer("L.L.Crocketeer")
    if Lock.Locked == true then
        Lock.Locked = false
        SetData("MCa.LockedName","L.L.Crocketeer")
    end
    CloseContainer(Key)
        SetData("MCa.LastGameTime", 3)
	SetData("GameOver.AwardMovie","gold")
    elseif timetook < silvertime then
        SetData("MCa.LastGameTime", 2)
	SetData("GameOver.AwardMovie","silver")
    else
    Key,Lock = EditContainer("L.P.Bright")
    if Lock.Locked == true then
        Lock.Locked = false
        SetData("MCa.LockedName","L.P.Bright")
    end
    CloseContainer(Key)
        SetData("MCa.LastGameTime", 1)
	SetData("GameOver.AwardMovie","bronze")
    end
    
    SendMessage("GameLogic.Mission.Success")
end

function endmissionfail()
    SendMessage("GameLogic.Mission.Failure")
end

function CheckOneTeamVictory()
   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")
   if TeamCount == 0 then
      endmissionfail()
   elseif TeamCount == 1 and WhichTeam == 0 then
       endmissionsuccess()
   else
      StartTurn()
   end
end

function StartFirstTurn()
    SetData("CommentaryPanel.Comment", "Miss.Crocketeer.Health1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Crocketeer.Health2")
    SendMessage("CommentaryPanel.ScriptText")
    SendMessage("EFMV.End")
    WaitUntilNoActivity = false
    SendMessage("Timer.StartGame")
    StartTurn()
    --StartTimer("Ill", 2000)
    StartTimer("Shake2", 10000)
end

function Shake3()
        SetData("Particle.DetailObject", "ExplosionA")
	SetData("Particle.Name", "EffectExplosion")
        SendMessage("Particle.NewEmitter")
        SetData("Camera.Shake.Length",800)
	SetData("Camera.Shake.Magnitude",0.02)
	SendMessage("Camera.ShakeStart")
        
        StartTimer("Shake4", 15000)
end

function Shake4()
        SetData("Particle.DetailObject", "ExplosionB")
	SetData("Particle.Name", "EffectExplosion")
        SendMessage("Particle.NewEmitter")
        SetData("Camera.Shake.Length",1000)
	SetData("Camera.Shake.Magnitude",0.05)
	SendMessage("Camera.ShakeStart")
        
        StartTimer("Shake5", 5000)
end

function Shake5()
        SetData("Particle.DetailObject", "ExplosionC")
	SetData("Particle.Name", "EffectExplosion")
        SendMessage("Particle.NewEmitter")
        SetData("Camera.Shake.Length",1000)
	SetData("Camera.Shake.Magnitude",0.09)
	SendMessage("Camera.ShakeStart")
        
        StartTimer("Shake2", 30000)
end

function Shake2()
        SetData("Particle.DetailObject", "Explosion3")
	SetData("Particle.Name", "EffectExplosion")
        SendMessage("Particle.NewEmitter")
        SetData("Camera.Shake.Length",1250)
	SetData("Camera.Shake.Magnitude",0.10)
	SendMessage("Camera.ShakeStart")
        
        SetData("Particle.DetailObject", "Explosion1")
	SetData("Particle.Name", "EffectExplosion")
        SendMessage("Particle.NewEmitter")
        
        StartTimer("Shake3", 40000)
end

function Crate_Collected()
    CrateNumber = GetData("Crate.Index")
    if CrateNumber == 5 then
        SetData("Crate.Spawn", "Health2")
        SetData("Crate.Type", "Health")
        SetData("Crate.NumContents", 10)
        SetData("Trigger.TeamCollect", 0)
        SetData("Crate.Index", 6)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
    elseif CrateNumber == 6 then
        SetData("Crate.Spawn", "Health3")
        SetData("Crate.Type", "Health")
        SetData("Trigger.TeamCollect", 0)
        SetData("Crate.NumContents", 10)
        SetData("Crate.Index", 7)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
    elseif CrateNumber == 7 then
        SetData("Crate.Spawn", "Health1")
        SetData("Crate.Type", "Health")
        SetData("Crate.NumContents", 10)
        SetData("Trigger.TeamCollect", 0)
        SetData("Crate.Index", 5)
        SetData("Crate.GroundSnap", 1)
        SendMessage("GameLogic.CreateCrate")
    end
end

function Trigger_Collected()
    TriggerIndex = GetData("Trigger.Index")
    if TriggerIndex == 999 then
        SetData("Camera.Shake.Length",12000)
        SetData("Camera.Shake.Magnitude",0.10)
        SendMessage("Camera.ShakeStart")
        SetData("CommentaryPanel.Comment", "Miss.Trial.Dead1")
        SendMessage("CommentaryPanel.ScriptText")
        CreateExplosion("KillExplosion", 150, 0, 100, 0, 0)
    end
end

function Timer_GameTimedOut()
   SendMessage("GameLogic.Mission.Success")
end

function SetupWormsAndTeams()

   GM = QueryContainer("GM.GameInitData")
   
    lock, team = EditContainer("Team.Data02") 
    team.Active = true
    team.Name = "The Alphas"
    team.IsAIControlled = true
    team.TeamColour = 2
    CloseContainer(lock) 

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Betas"
    team.IsAIControlled = true
    team.TeamColour = 1
    CloseContainer(lock)
    
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = "Alpha Captain"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn1"
    worm.Energy = 250
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 2
    CloseContainer(lock) 

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = "Alpha Joe"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn2"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = "Alpha Alan"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn3"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = "Alpha Ken"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn4"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 250 
    worm.Name = "Beta Captain"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn5"
    worm.TeamIndex = 1
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.Energy = 250  
    worm.Name = "Beta Ben"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn6"
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    worm.Energy = 250  
    worm.Name = "Beta Borris"
    worm.SfxBankName = "Alien"
    worm.Spawn = "spawn7"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data04", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    worm.Energy = 250  
    worm.SfxBankName = "Alien"
    worm.Name = "Beta Bertie"
    worm.Spawn = "spawn8"
    CloseContainer(lock)
  
    lock, worm = EditContainer("Worm.Data08") 
    worm.Active = true
    worm.Name = "THE CROCKETEER"
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn9"
    worm.Energy = 20
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
    
    lock, AIParams = EditContainer("AIParams.Worm00") 

    WeightingPreferAttackHumans = 1.1
        
    CopyContainer("AIParams.Worm00", "AIParams.Worm01")
    CopyContainer("AIParams.Worm00", "AIParams.Worm02")
    CopyContainer("AIParams.Worm00", "AIParams.Worm03")
    CopyContainer("AIParams.Worm00", "AIParams.Worm04")
    CopyContainer("AIParams.Worm00", "AIParams.Worm05")
    CopyContainer("AIParams.Worm00", "AIParams.Worm06")
    CopyContainer("AIParams.Worm00", "AIParams.Worm07")

    CloseContainer(lock)

    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = 12
    inventory.Grenade = 12
    inventory.ClusterGrenade = 8
    inventory.Dynamite = 1
   -- inventory.BananaBomb = 3
    inventory.Landmine = 3
    inventory.Shotgun = 3
    inventory.Uzi = 3
    inventory.Prod = -1
    inventory.Sheep = 1
    inventory.SuperSheep = 1
    inventory.NinjaRope = 5
    inventory.Jetpack = 1
    inventory.BaseballBat = 1
    inventory.VikingAxe = 1
    inventory.Earthquake = 1
  --  inventory.HolyHandGrenade = 3
    inventory.Girder = 10
    inventory.SkipGo = -1
    CloseContainer(lock) 
   
    CopyContainer("Inventory.Team.Default", "Inventory.Team01")
    CopyContainer("Inventory.Team.Default", "Inventory.Team02")
    
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Teleport = 0
    CloseContainer(lock)
    
    lock, inventory = EditContainer("Inventory.Team02") 
    inventory.Teleport = 0
    CloseContainer(lock)
    
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Bazooka = 0
    inventory.Grenade = 0
    inventory.ClusterGrenade = 0
    inventory.Dynamite = 0
    inventory.BananaBomb = 0
    inventory.Landmine = 1
    inventory.Shotgun = 0
    inventory.Uzi = 0
    inventory.Prod = -1
    inventory.Sheep = 0
    inventory.SuperSheep = 0
    inventory.NinjaRope = 0
    inventory.Jetpack = 1
    inventory.BaseballBat = 0
    inventory.VikingAxe = 0
    inventory.Earthquake = 0
    inventory.HolyHandGrenade = 0
    inventory.Girder = 5
    inventory.SkipGo = -1
    --inventory.Surrender = -1
    
    CloseContainer(lock)
end