-- Deathmatch Part Two

function Initialise()
    SetData("Camera.StartOfTurnCamera","Default")
    
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)

    SendMessage("GameLogic.PlaceObjects")

    water = 0
    StartedSuddenDeath = false

    SendMessage("EFMV.Start")
    --SetData("RoundTime", 10000)

    SetupWormsAndTeams()
    SetupInventories()
    Camera()
end

function Camera()
    CameraFly = 1 
    SendIntMessage("Worm.ResetAnim", 7)
    SetData("Worm.ScriptAnim", "OverHere")
    SetData("Worm.ScriptAnim", "OverHere")
    SetData("Worm.ScriptAnim", "OverHere")
    SendIntMessage("Worm.QueueAnim", 7)

    SetData("CommentaryPanel.Comment", "Miss.Trial.Dead1")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "Pos1,Pos2")
    SetData("Camera.Path.Knots.LookAt", "Look1")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",750)  
    SetData("Camera.Path.Steps.LookAt",480)
    SetData("Camera.Path.Tension.Position", -0.06) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("stAnim", 950)
    SetData("Particle.DetailObject", "Fireworks1")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
end

function stAnim()
    SetData("Particle.DetailObject", "Fireworks2")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
    CamLoop = StartTimer("ndAnim", 700)
end

function ndAnim()
    SetData("Particle.DetailObject", "Fireworks3")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
   -- SetData("Particle.DetailObject", "Fireworks4")
   -- SetData("Particle.Name", "Part_Firework")
   -- SendMessage("Particle.NewEmitter")
    CamLoop = StartTimer("rdAnim", 700)
end

function rdAnim()
    SetData("Particle.DetailObject", "Fireworks5")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
    CamLoop = StartTimer("fourAnim", 1200)
end

function fourAnim()
    SendIntMessage("Worm.ResetAnim", 8)
    SetData("Worm.ScriptAnim", "OverHere")
    SetData("Worm.ScriptAnim", "OverHere")
    SetData("Worm.ScriptAnim", "OverHere")
    SendIntMessage("Worm.QueueAnim", 8)
    SetData("Particle.DetailObject", "Fireworks2")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
    CamLoop = StartTimer("fiveAnim", 800)
end

function fiveAnim()
    SetData("Particle.DetailObject", "Fireworks5")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
    CamLoop = StartTimer("sixAnim", 1000)
end

function sixAnim()
    SetData("Particle.DetailObject", "Fireworks1")
    SetData("Particle.Name", "Part_Firework")
    SendMessage("Particle.NewEmitter")
    CamLoop = StartTimer("Camera2", 1300)
end

function Camera2()
    CopyContainer("Worm.Data04", "Worm.Data11")
    lock, worm = EditContainer("Worm.Data11")
    CopyContainer("AIParams.Worm04", "AIParams.Worm11")
    worm.Energy = 100  
    worm.Name = "Edward"
    worm.TeamIndex = 2
    worm.Spawn = "DummyWorm3"
    CloseContainer(lock)
    SendIntMessage("Worm.Respawn", 11)
    StartTimer("Death2", 700)
    
    SetData("CommentaryPanel.Comment", "Miss.Trial.Dead2")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "Pos3,Pos4")
    SetData("Camera.Path.Knots.LookAt", "Look2,Look3")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",800)  
    SetData("Camera.Path.Steps.LookAt",800)
    SetData("Camera.Path.Tension.Position", -0.06) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera3", 6000)
end

function Death2()
    CopyContainer("Worm.Data04", "Worm.Data12")
    lock, worm = EditContainer("Worm.Data12")
    CopyContainer("AIParams.Worm04", "AIParams.Worm12")
    worm.Energy = 100  
    worm.Name = "Jake"
    worm.TeamIndex = 2
    worm.Spawn = "DummyWorm4"
    CloseContainer(lock)
    SendIntMessage("Worm.Respawn", 12)
end

function Camera3()
    SetData("Camera.Path.Knots.Position", "Pos5,Pos6")
    SetData("Camera.Path.Knots.LookAt", "Look4,Look5")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",600)  
    SetData("Camera.Path.Steps.LookAt",450)
    SetData("Camera.Path.Tension.Position", -0.06) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera4", 4500)
end

function Camera4()
    StartTimer("Anim1", 1500)

    SetData("Camera.Path.Knots.Position", "Pos7,Pos8")
    SetData("Camera.Path.Knots.LookAt", "Look6,Look7")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",400)
    SetData("Camera.Path.Tension.Position", -0.06) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("startt", 4000)
end

function Anim1()
    SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro8")
    SendMessage("CommentaryPanel.ScriptText")
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 3)
end

function StartFirstTurn()
    SendIntMessage("Worm.DieQuietly",7)
    SendIntMessage("Worm.DieQuietly",8)
    WaitUntilNoActivity = false
    SendMessage("Timer.StartGame")
    StartTurn()
end

function startt()
    CameraFly = 0
    StartFirstTurn()
    SendMessage("EFMV.End")        
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        SendMessage("Commentary.Clear")
        CameraFly = 0
        CancelTimer(CamLoop)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        SendMessage("EFMV.End")
        StartFirstTurn()
    end
end

function SelectRandomWind()
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", RandomNumber*MaxWind * 3/10)

   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", Direction)   
end

function TurnEnded()
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    if (RoundTimeRemaining == 0 or RoundTimeRemaining < 0) and StartedSuddenDeath == false then
        StartedSuddenDeath = true
        SetAllWormsEnergy(1)
    end
    
    CheckOneTeamVictory()
end

function SetAllWormsEnergy(energy)
    SuddenDeathMessages()

    local WormIndex = 0
    local DataId = GetWormContainerName(WormIndex)
    while DataId ~= "" do
        lock, worm = EditContainer(DataId)
        worm.Energy = energy
        CloseContainer(lock)
        WormIndex = WormIndex + 1
        DataId = GetWormContainerName(WormIndex)
    end
end

function SuddenDeathMessages()
    SendMessage("Commentary.Clear")

    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 6) + 1

    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.2")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.3")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.5")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 6 then
        SetData("CommentaryPanel.Comment", "Comment.Sdeath.6")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function FailureMessages()
    SendMessage("Commentary.Clear")

    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1

    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function CheckOneTeamVictory()
    TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")

    if TeamCount == 0 then
        FailureMessages()
        SendMessage("GameLogic.Challenge.Failure")
    elseif TeamCount == 1 and WhichTeam == 1 then
        FailureMessages()
        SendMessage("GameLogic.Challenge.Failure")
    elseif TeamCount == 1 and WhichTeam == 0 then
        Result()
        Key,Lock = EditContainer("L.C.DM3")
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName","L.C.DM3")
        end
        CloseContainer(Key)
        SendMessage("GameLogic.Challenge.Result")
    else
        StartTurn()
    end
end

function Result()
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")
    
    if timetook < bronzetime then
        Movie = 1
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
            end
        end
    end
    
    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")

    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.TeamColour = 0
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Enemy"
    team.TeamColour = 1
    team.AlliedGroup = 1
    team.IsAIControlled = true
    team.FlagGfxName = "73"
    CloseContainer(lock)
    
    lock, team = EditContainer("Team.Data02") 
    team.Active = true
    team.Name = "Passengers"
    team.TeamColour = 1
    team.AlliedGroup = 1
    team.IsAIControlled = true
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "spawn1"
    CloseContainer(lock) 

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn2"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GM.T1_W3_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn3"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    CopyContainer("AIParams.CPU1", "AIParams.Worm04")
    worm.Energy = 100 
    worm.Name = "Nasty Man"
    worm.SfxBankName = "Classic"
    worm.TeamIndex = 1
    worm.Spawn = "spawn5"
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    CopyContainer("AIParams.Worm04", "AIParams.Worm05")
    worm.Energy = 100  
    worm.Name = "Horrible Harry"
    worm.SfxBankName = "Classic"
    worm.TeamIndex = 1
    worm.Spawn = "spawn6"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    CopyContainer("AIParams.Worm04", "AIParams.Worm06")
    worm.Energy = 100  
    worm.Name = "Bertie"
    worm.SfxBankName = "Classic"
    worm.TeamIndex = 1
    worm.Spawn = "spawn7"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data04", "Worm.Data09")
    lock, worm = EditContainer("Worm.Data09")
    CopyContainer("AIParams.Worm04", "AIParams.Worm09")
    worm.Energy = 100  
    worm.Name = "Grenadine"
    worm.SfxBankName = "Classic"
    worm.TeamIndex = 1
    worm.Spawn = "spawn8"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data04", "Worm.Data10")
    lock, worm = EditContainer("Worm.Data10")
    CopyContainer("AIParams.Worm04", "AIParams.Worm10")
    worm.Energy = 100  
    worm.Name = "Ivan the Crude"
    worm.SfxBankName = "Classic"
    worm.TeamIndex = 1
    worm.Spawn = "spawn9"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data04", "Worm.Data13")
    lock, worm = EditContainer("Worm.Data13")
    CopyContainer("AIParams.Worm04", "AIParams.Worm13")
    worm.Energy = 100  
    worm.Name = "John"
    worm.SfxBankName = "Classic"
    worm.TeamIndex = 1
    worm.Spawn = "spawn10"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data04", "Worm.Data14")
    lock, worm = EditContainer("Worm.Data14")
    CopyContainer("AIParams.Worm04", "AIParams.Worm14")
    worm.Energy = 100  
    worm.Name = "Dunstan"
    worm.SfxBankName = "Classic"
    worm.TeamIndex = 1
    worm.Spawn = "spawn11"
    CloseContainer(lock)
    
    --DUMMY WORMS TO DIE
    CopyContainer("Worm.Data04", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    CopyContainer("AIParams.Worm04", "AIParams.Worm07")
    worm.Energy = 100  
    worm.Name = "George"
    worm.SfxBankName = "Classic"
    worm.TeamIndex = 2
    worm.Spawn = "DummyWorm1"
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data08")
    lock, worm = EditContainer("Worm.Data08")
    CopyContainer("AIParams.Worm04", "AIParams.Worm08")
    worm.Energy = 100  
    worm.Name = "Edward"
    worm.SfxBankName = "Classic"
    worm.TeamIndex = 2
    worm.Spawn = "DummyWorm2"
    CloseContainer(lock)

    SendMessage("WormManager.Reinitialise")
end

function DoOncePerTurnFunctions()
    water = water + 5
    SetData("Water.Level", water)
end

function SetupInventories()
-- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Bazooka = 5
    inventory.Grenade = 5
    inventory.ClusterGrenade = -1
    inventory.Airstrike = 1
    inventory.Dynamite = 1
    inventory.Landmine = 1
    inventory.Parachute = 3
    inventory.Jetpack = 1
    inventory.Girder = 2
    inventory.Shotgun = 1
    inventory.Uzi = 1
    inventory.NinjaRope = 6
    inventory.FirePunch = 1
    inventory.Prod = -1
    inventory.PetrolBomb = 2
    inventory.BaseballBat = 1
    inventory.Mortar = 2
    inventory.SkipGo = -1
    inventory.ChangeWorm = 1
    CloseContainer(lock)
    
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = 5
    inventory.Grenade = 5
    inventory.ClusterGrenade = -1
    inventory.Airstrike = 1
    inventory.Dynamite = 1
    inventory.Landmine = 1
    inventory.Parachute = 3
    inventory.Jetpack = 1
    inventory.Girder = 2
    inventory.Shotgun = 1
    inventory.Uzi = 1
    inventory.NinjaRope = 6
    inventory.FirePunch = 1
    inventory.Prod = -1
    inventory.PetrolBomb = 2
    inventory.BaseballBat = 1
    inventory.Mortar = 2
    inventory.SkipGo = -1
    inventory.ChangeWorm = 1
    CloseContainer(lock)
    
    lock, delays = EditContainer("Inventory.WeaponDelays") 
    delays.Airstrike = 6
    CloseContainer(lock)
end
