
-- Mission Falling For You

function Initialise()
    Alive = 0
    GotCrate = 0
    ShowMovie = 0
    GotCrate2 = 0
    ShowMovie2 = 0
        
    SendMessage("Commentary.NoDefault")
    bronzetime = (60 * 1000) * 999
    silvertime = 280000
    goldtime = 230000
    
    SetData("TurnTime", 45000)
    SetData("RoundTime", 480000)
   
    SendMessage("GameLogic.PlaceObjects")
    SendMessage("GameLogic.ChangeWind")
   
    MaxWind = GetData("Wind.MaxSpeed")
    SetData("Wind.Speed", 0.4*MaxWind)
    SetData("Wind.Direction", 1)

    PickUp = 0
    
    SetData("Camera.StartOfTurnCamera","Default")
    
    SetData("Camera.GameOverCamera", "") 
    
    SendMessage("EFMV.Start")
    
    SetData("Particle.DetailObject", "Sparks")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Ripple1")
    SetData("Particle.Name", "Part_IslandRipples")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Ripple2")
    SetData("Particle.Name", "Part_IslandRipples")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Ripple3")
    SetData("Particle.Name", "Part_IslandRipples")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Ripple4")
    SetData("Particle.Name", "Part_IslandRipples")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Ripple5")
    SetData("Particle.Name", "Part_IslandRipples")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Ripple6")
    SetData("Particle.Name", "Part_IslandRipples")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Ripple7")
    SetData("Particle.Name", "Part_IslandRipples")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Ripple8")
    SetData("Particle.Name", "Part_IslandRipples")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Flak")
    SetData("Particle.Name", "Part_Flak")
    SendMessage("Particle.NewEmitter")
        
    SetupWormsAndTeams()
    SetupInventories()
 
    SetData("Particle.DetailObject", "Smoke2")
    SetData("Particle.Name", "Part_OilySmoke")
    SendMessage("Particle.NewEmitter")
 
    NewCrate = 1
    Switch = 0
    MakeNewCrate()
    Camera()
end

function Camera()
    CameraFly = 1
    SetData("CommentaryPanel.Comment", "Miss.Falling.NewIntro1")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("Animation", 500)
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2,Pos3")
    SetData("Camera.Path.Knots.LookAt", "LookAt1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",325)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera2", 4000)
end

function Animation()
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Idle_14_Periscope")
    SendIntMessage("Worm.QueueAnim", 1)
end

function Camera2()
    SetData("CommentaryPanel.Comment", "Miss.Falling.NewIntro2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Falling.NewIntro3")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("WaterSplash", 1500)
    SetData("Camera.Path.Knots.Position", "Posa,Posb,Posc,Posd")
    SetData("Camera.Path.Knots.LookAt", "LookAt2,LookAt3")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",325)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera3B", 7000)
end

function Camera3B()
    SetData("CommentaryPanel.Comment", "MissAnt.game2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "3BPos1,3BPos2")
    SetData("Camera.Path.Knots.LookAt", "LookAt3B")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",325)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera3", 4000)
end

function WaterSplash()
    StartTimer("WaterSplash2", 2000)

    SetData("Particle.DetailObject", "Charge2")
    SetData("Particle.Name", "Part_Depthcharge")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Charge3")
    SetData("Particle.Name", "Part_Depthcharge")
    SendMessage("Particle.NewEmitter")
end

function WaterSplash2()
    SetData("Particle.DetailObject", "Charge1")
    SetData("Particle.Name", "Part_Depthcharge")
    SendMessage("Particle.NewEmitter")
end

function Camera3()
  --  StartTimer("Smoke", 400)
   -- StartTimer("Bang", 10000)    
   -- StartTimer("Flames", 3500)

    SetData("Particle.DetailObject", "Sparks")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    
    SetData("Camera.Path.Knots.Position", "PosA,PosB")
    SetData("Camera.Path.Knots.LookAt", "LookAt4")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",325)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    
    CamLoop = StartTimer("GOGOGO", 4000)
end

function GOGOGO()
    CameraFly = 0
    StartFirstTurn()
end

function StartFirstTurn()
        StartTimer("Smoke", 550)
        StartTimer("Flames", 5500)
        StartTimer("Bang", 21600)
    SetData("CommentaryPanel.Comment", "Miss.Falling.Start")
    SendMessage("CommentaryPanel.ScriptText")
   WaitUntilNoActivity = false
   SendMessage("Timer.StartGame")
    Countdown()
   StartTurn()

    SendMessage("EFMV.End")
end


--- THIS IS TO BE USED IN RETRY MODE ---
function HelpText()
    SetData("CommentaryPanel.Comment", "Miss.Falling.HelpText1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Falling.HelpText2")
    SendMessage("CommentaryPanel.ScriptText")
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end

	SendMessage("Commentary.Clear")
        StartFirstTurn()
    end
end

function Countdown()
    SetData("CommentaryPanel.Comment", "Miss.count10")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("Countdown2", 250)
end

function Countdown2()
    SetData("CommentaryPanel.Comment", "Miss.count9")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("Countdown3", 250)
end

function Countdown3()
    SetData("CommentaryPanel.Comment", "Miss.count8")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("Countdown4", 250)
end

function Countdown4()
    SetData("CommentaryPanel.Comment", "Miss.count7")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("Countdown5", 250)
end

function Countdown5()
    SetData("CommentaryPanel.Comment", "Miss.count6")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("Countdown6", 250)
end

function Countdown6()
    SetData("CommentaryPanel.Comment", "Miss.count5")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("Countdown7", 250)
end

function Countdown7()
    SetData("CommentaryPanel.Comment", "Miss.count4")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("Countdown8", 250)
end

function Countdown8()
    SetData("CommentaryPanel.Comment", "Miss.count3")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("Countdown9", 250)
end

function Countdown9()
    SetData("CommentaryPanel.Comment", "Miss.count2")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("Countdown10", 250)
end

function Countdown10()
    SetData("CommentaryPanel.Comment", "Miss.count1")
    SendMessage("CommentaryPanel.ScriptText")
end

function Smoke()
    SetData("Particle.DetailObject", "Smoke")
    SetData("Particle.Name", "Part_Propsmoke")
    SendMessage("Particle.NewEmitter")
end

function Flames()
    SetData("Particle.DetailObject", "POP")
    SetData("Particle.Name", "Part_ExplosionA")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Fire")
    SetData("Particle.Name", "Part_Smallfire")
    SendMessage("Particle.NewEmitter")
end

function Bang()
        SetData("Particle.DetailObject", "SPARKS1")
	SetData("Particle.Name", "Part_ElectricSpark")
        SendMessage("Particle.NewEmitter")
        SetData("Particle.DetailObject", "SPARKS2")
	SetData("Particle.Name", "Part_ElectricSpark")
        SendMessage("Particle.NewEmitter")
        SetData("Particle.DetailObject", "SPARKS3")
	SetData("Particle.Name", "Part_ElectricSpark")
        SendMessage("Particle.NewEmitter")
    CreateExplosion("Explosion", 50, 0.35, 50, 60, 80)
    SetData("CommentaryPanel.Comment", "Miss.Falling.Boom")
    SendMessage("CommentaryPanel.ScriptText")
        SetData("Camera.Shake.Length",1000)
	SetData("Camera.Shake.Magnitude",0.30)
	SendMessage("Camera.ShakeStart")
        SetData("Particle.DetailObject", "ExplosionGFX")
	SetData("Particle.Name", "EffectExplosion")
        SendMessage("Particle.NewEmitter")
        StartTimer("Bang2", 1500)
end

function Bang2()
    CreateExplosion("Explosion2", 250, 0.35, 150, 300, 80)
        SetData("Camera.Shake.Length",1000)
	SetData("Camera.Shake.Magnitude",0.30)
	SendMessage("Camera.ShakeStart")
        SetData("Particle.DetailObject", "ExplosionGFX2")
	SetData("Particle.Name", "EffectExplosion")
        SendMessage("Particle.NewEmitter")
end

function Crate_Collected()

    CrateNumber = GetData("Crate.Index")
      MakeNewCrate()
   
    if CrateNumber == 1 then
        GotCrate = 1
        ShowMovie = 1
        PickUp = 1
        MaxWind = GetData("Wind.MaxSpeed")
        SetData("Wind.Speed", 0.4*MaxWind)
        SetData("Wind.Direction", 5) 
    
    elseif CrateNumber == 2 then
        GotCrate = 0
        ShowMovie = 0
        GotCrate2 = 1
        ShowMovie2 = 1
        

    elseif CrateNumber == 99 then
        GotCrate2 = 0
        ShowMovie2 = 0
        PickUp = 2
        MaxWind = GetData("Wind.MaxSpeed")
        SetData("Wind.Speed", 0.3*MaxWind)
        SetData("Wind.Direction", 2) 
    end
end

function MakeNewCrate()
    if NewCrate == 1 then
    SetData("Crate.Spawn", "CrateSpawn1")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityParachute")
    SetData("Crate.Index", 1)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Parachute", 0)
    SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 2 then
    SetData("CommentaryPanel.Comment", "Miss.Falling.CrateCollected")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Crate.Spawn", "CrateSpawn3")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Contents", "kUtilityParachute")
    SetData("Crate.Index", 2) 
    SendMessage("GameLogic.CreateCrate")

    elseif NewCrate == 3 then
    SetData("Crate.Spawn", "CrateSpawn2B")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityParachute")
    SetData("Crate.Index", 99) 
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    elseif NewCrate == 4 then
    SetData("Crate.Spawn", "CrateSpawn2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 20)
    SetData("Crate.Contents", "kWeaponBazooka")
    SetData("Crate.Index", 3) 
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    StartTimer("ExtraCrate", 170000)
   
    SetData("Crate.Spawn", "CrateSpawn22")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 4)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 5) 
    SendMessage("GameLogic.CreateCrate")
        
    elseif NewCrate == 5 then
    SetData("CommentaryPanel.Comment", "Miss.Falling.TakeOutEnemy")
    SendMessage("CommentaryPanel.ScriptText")
    end
    
    NewCrate = NewCrate + 1
end

function checkteam()
-- PC: the current team value is now called CurrentTeamIndex
    Team = GetData("CurrentTeamIndex")
    if Team == 1 then
       SetData("GameLogic.ArtilleryMode", 1)
    else
       SetData("GameLogic.ArtilleryMode", 0)
    end
end

function TurnEnded()
    CheckOneTeamVictory()
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif GotCrate == 1 and ShowMovie == 1 then
        MOVIE()
    elseif GotCrate2 == 1 and ShowMovie2 == 1 then
        MOVIE2()
    end
    
    
end 

function Crate_Destroyed()

    if Switch == 0 then
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
    
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
        SendMessage("GameLogic.Mission.Failure")
        Switch = 1
    end
    
end

function ExtraCrate()
    SetData("Crate.Spawn", "CrateSpawn2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", -1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 4) 
    SendMessage("GameLogic.CreateCrate")
end        

function SetWind()
	-- PC: changed this to the new "SurvivingTeamIndex" call. use this data value for getting
	-- the team with a worm left alive on.
   -- SendMessage("WormManager.GetSurvivingTeam")
    WhichTeam = GetData("SurvivingTeamIndex")
    if WhichTeam == 1 then
        MakeWindRandom()
    elseif WhichTeam == 0 and PickUp == 0 then
        MaxWind = GetData("Wind.MaxSpeed")
        SetData("Wind.Speed", 0.4*MaxWind)
        SetData("Wind.Direction", 1)
    elseif WhichTeam == 0 and PickUp == 1 then
        MaxWind = GetData("Wind.MaxSpeed")
        SetData("Wind.Speed", 0.2*MaxWind)
        SetData("Wind.Direction", 5)  
    elseif WhichTeam == 0 and PickUp == 2 then
        MaxWind = GetData("Wind.MaxSpeed")
        SetData("Wind.Speed", 0.3*MaxWind)
        SetData("Wind.Direction", 2) 
    end
end

function TurnStarted()
    checkteam()
    Charge()
    Charge3()
end

function MOVIE()
    if Alive == 0 then
    SendMessage("EFMV.Start")
    StartTimer("JDText", 1000)

    SetData("Camera.Path.Knots.Position", "MoviePos1,MoviePos2")
    SetData("Camera.Path.Knots.LookAt", "MovieLook1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",375)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    GotCrate = 0
    ShowMovie = 0
    StartTimer("EndB", 3500)
    end
end

function MOVIE2()
    if Alive == 0 then
    SendMessage("EFMV.Start")
    StartTimer("JDText", 1000)

    SetData("Camera.Path.Knots.Position", "Movie2Pos1,Movie2Pos2")
    SetData("Camera.Path.Knots.LookAt", "Movie2Look1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",375)  
    SetData("Camera.Path.Steps.LookAt",300)
    SetData("Camera.Path.Tension.Position", 0) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    GotCrate2 = 0
    ShowMovie2 = 0
    StartTimer("EndB", 3500)
    end
end

function JDText()
    SetData("CommentaryPanel.Comment", "Miss.Generic.Hint5")
    SendMessage("CommentaryPanel.ScriptText")
end

function EndB()
    SendMessage("EFMV.End")
    StartTurn()
end

function Weapon_PoweringUpStart()
   SendMessage("Timer.EndTurn")
   StartTimer("Charge", 500)
   StartTimer("Charge2", 1000)
   StartTimer("Charge3", 3000)
end

function Charge()
    SetData("Particle.DetailObject", "Charge")
    SetData("Particle.Name", "Part_Depthcharge")
    SendMessage("Particle.NewEmitter")
end

function Charge2()
    SetData("Particle.DetailObject", "Charge2")
    SetData("Particle.Name", "Part_Depthcharge")
    SendMessage("Particle.NewEmitter")
end

function Charge3()
    SetData("Particle.DetailObject", "Charge3")
    SetData("Particle.Name", "Part_Depthcharge")
    SendMessage("Particle.NewEmitter")
end

function SetWind()
end

function CheckOneTeamVictory()

    SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")

    SendMessage("WormManager.GetSurvivingTeam")
    WhichTeam = GetData("SurvivingTeamIndex")


    if TeamCount == 0 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
        
            SetData("CommentaryPanel.Comment", "Miss.Falling.FailureDraw")
            SendMessage("CommentaryPanel.ScriptText") 
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
        
            SetData("CommentaryPanel.Comment", "Miss.Falling.FailureLose")
            SendMessage("CommentaryPanel.ScriptText") 
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 0 then
    WONYES()
    
    elseif GotCrate == 1 and ShowMovie == 1 then
    
    elseif GotCrate2 == 1 and ShowMovie2 == 1 then
        
    else
    StartTurn()
    end
end

function WONYES()
    Switch = 1
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    SetData("CommentaryPanel.Comment", "Miss.Falling.Success")
    SendMessage("CommentaryPanel.ScriptText") 

    Result()
end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        Key,Lock = EditContainer("L.C.P1") --unlock parachute challenge1 
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName2","L.C.P1")
        end
        CloseContainer(Key)
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.P.Story") --unlock Story WP
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.P.Story")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end


function Worm_Died()

   deadWorm = GetData("DeadWorm.Id")

   if deadWorm == 0 then 
       Alive = 1
   end
   
end

function MakeWindRandom()
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    MaxWind = GetData("Wind.MaxSpeed")
    SetData("Wind.Speed", RandomNumber*MaxWind)

    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    Direction = RandomNumber * 2 * 3.14
    SetData("Wind.Direction", Direction)   
end

function SetupWormsAndTeams()

   GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Enemy"
    team.FlagGfxName = "71"
    team.IsAIControlled = true
    team.TeamColour = 1
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn1"
    worm.Energy = 75
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 

    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01")
    worm.Energy = 10 
    worm.Name = "General Sadist"
    CopyContainer("AIParams.CPU1", "AIParams.Worm01")
    --This bank should be WW2 GENERAL before release.
    worm.SfxBankName = "War General"
    worm.Spawn = "spawn2"
    worm.TeamIndex = 1
    CloseContainer(lock)
    
    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02")
    worm.Energy = 5 
    worm.Name = "Matey"
    CopyContainer("AIParams.CPU1", "AIParams.Worm02")
    worm.SfxBankName = "Classic"
    worm.Spawn = "spawn3"
    worm.TeamIndex = 1
    CloseContainer(lock)
    
    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03")
    worm.Energy = 5 
    worm.Name = "Skip"
    CopyContainer("AIParams.CPU1", "AIParams.Worm03")
    worm.SfxBankName = "Classic"
    worm.Spawn = "spawn4"
    worm.TeamIndex = 1
    CloseContainer(lock)

    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Parachute = 1
    inventory.Uzi = -1
    inventory.ClusterGrenade = 5
    inventory.SkipGo = -1
    CloseContainer(lock) 
    
    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
    CopyContainer("Inventory.Team.Default", "Inventory.Team01")
      
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.ClusterGrenade = 0
    inventory.Uzi = 0
  --  inventory.Bazooka = 0
    CloseContainer(lock)
    
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Parachute = 0
    CloseContainer(lock)
   
    lock, delays = EditContainer("Inventory.WeaponDelays")
    delays.Uzi = 8
   -- delays.Bazooka = 8
    CloseContainer(lock)
 end

--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end

function SuccessMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end

end





