
-- Shotgun Challenge 2

function Initialise()
    SendMessage("Commentary.NoDefault")
-- Preset timers are TBD.
    SetData("Particle.DetailObject", "BFly1")
    SetData("Particle.Name", "Part_Butterfly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "BFly2")
    SetData("Particle.Name", "Part_Butterfly")
    SendMessage("Particle.NewEmitter")
    camdone =  0
    TimeOut = 0
    Switch = 0
    
    SendStringMessage("Camera.Disable", "Track")

    SetData("Camera.StartOfTurnCamera","Default")
    SendMessage("EFMV.Start")
	
    SetData("TurnTime", 70000)
    SetData("RoundTime", 70000)
    SendMessage("GameLogic.PlaceObjects")
    
    SetData("Land.Indestructable", 1)
    SendMessage("HUD.HideTurnTime")
       
    SetupWormsAndTeams()
    SetupInventories()
    StartCam()

    target = 0
    level = 1
    
    SetData("Trigger.Spawn", "Trigger")
    SetData("Trigger.Radius", 100)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
end

function Trigger_Collected()
    TriggerIndex = GetData("Trigger.Index")
    if TriggerIndex == 1 then
        SetData("Crate.Spawn", "target1")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 1)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target2")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 2)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target3")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 3)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    end
end

function Loop()
    if target == 3 then
        SetData("CommentaryPanel.Comment", "Chall.Homing.Move")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Crate.Spawn", "target4")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 4)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target5")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 5)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target6")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 6)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    elseif target == 6 then
        SetData("CommentaryPanel.Comment", "Chall.Homing.Move2")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Crate.Spawn", "target7")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 7)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target8")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 8)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target9")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 9)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    elseif target == 9 then
        SetData("CommentaryPanel.Comment", "Chall.Homing.Move")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Crate.Spawn", "target10")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 10)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target11")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 11)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")

        SetData("Crate.Spawn", "target12")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 12)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")   
        
    elseif target == 12 then
        SetData("CommentaryPanel.Comment", "Chall.Homing.Move2")
        SendMessage("CommentaryPanel.ScriptText")
	 SetData("CommentaryPanel.Comment", "MissCrate.game6")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Crate.Spawn", "target13")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 13)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    

        SetData("Crate.Spawn", "target14")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 14)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target15")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 15)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
	
    elseif target == 15 then
    
        SetData("CommentaryPanel.Comment", "Chall.Homing.Move")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Crate.Spawn", "target16")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 16)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")

        SetData("Crate.Spawn", "target17")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 17)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
        
        SetData("Crate.Spawn", "target18")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 18)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
--  When 18 targets have been destroyed: the level goes up, time is added, text is displayed.
    elseif target == 18 and level == 1 then
        SetData("CommentaryPanel.Comment", "Chall.Homing.WellDone")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Chall.Homing.Move2")
        SendMessage("CommentaryPanel.ScriptText")
        target = 0
        level = level + 1
        
        SetData("Crate.Spawn", "target1")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 1)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target2")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 2)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target3")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 3)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")

--        SendIntMessage("GameLogic.ModifyTurnTime", 50000)
--  When 18 targets have been destroyed on level 2: the level goes up, time is added, text is displayed.
    elseif target == 18 and level == 2 then
        SetData("CommentaryPanel.Comment", "Chall.Homing.WellDone2")
        SendMessage("CommentaryPanel.ScriptText")
	SetData("CommentaryPanel.Comment", "Chall.Assault1.game1")
        SendMessage("CommentaryPanel.ScriptText")
	
        target = 0
        level = level + 1
        
        SetData("Crate.Spawn", "target1")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 1)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target2")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 2)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target3")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 3)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")

      --  SendIntMessage("GameLogic.ModifyTurnTime", 50000)
    elseif target == 18 and level == 3 then
        SetData("CommentaryPanel.Comment", "Chall.Homing.WellDone3")
        SendMessage("CommentaryPanel.ScriptText")
        target = 0
        level = level + 1
        
        SetData("Crate.Spawn", "target1")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 1)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target2")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 2)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "target3")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 3)
        SetData("Crate.Pushable", "0")
        SendMessage("GameLogic.CreateCrate")

--        SendIntMessage("GameLogic.ModifyTurnTime", 50000)
        
-- After level 3 has been completed, the commentary text is 
-- restarted by the fact that the level is set back to 1.
--    elseif level == 3 and target == 18 then
--        SetData("CommentaryPanel.Comment", "Chall.Homing.WellDone4")
--        SendMessage("CommentaryPanel.ScriptText")
--        target = 3
--        level = 1
--    Loop()
   end
end

function Crate_Destroyed()
if level == 1 then
    TurnTimeRemaining = GetData("TurnTimeRemaining")
    SetData("TurnTimeRemaining", TurnTimeRemaining+4000)
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    SetData("RoundTimeRemaining", RoundTimeRemaining+4000)
    target = target + 1
    Loop()
elseif level == 2 then
    TurnTimeRemaining = GetData("TurnTimeRemaining")
    SetData("TurnTimeRemaining", TurnTimeRemaining+2000)
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    SetData("RoundTimeRemaining", RoundTimeRemaining+2000)
    target = target + 1
    Loop()
elseif level == 3 then
    TurnTimeRemaining = GetData("TurnTimeRemaining")
    SetData("TurnTimeRemaining", TurnTimeRemaining+1000)
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    SetData("RoundTimeRemaining", RoundTimeRemaining+1000)
    target = target + 1
    Loop()   
end    
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
end

function Weapon_PoweringUpStart()
end


function Timer_GameTimedOut()
    TimeOut = 1
    
    SendMessage("Weapon.Delete")
    SendMessage("Weapon.DisableWeaponChange")
-- EndTurn()
    
    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText")
    
end

function Worm_Died()
    if TimeOut == 0 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif Switch == 1 then
        TimeOut = 2
    end
end
    
function TurnEnded()

    if TimeOut == 0 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Camera.Path.IgnoreInput", 1)
        Switch = 1
        Result()
    elseif TimeOut == 1 then
        Switch = 1
        Result()
    end
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////

function Result()  
    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")
     
    if timetook > bronzetime then
        Movie = 1
        if timetook > silvertime then
            Movie = 2
            if timetook > goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.W.MadCow")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.W.MadCow")
                end
                CloseContainer(Key)
            end
        end
    end

    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Challenge.Result")
end


function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00")
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "wspawn1"
    worm.Energy = 1
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 

    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Shotgun = -1
    CloseContainer(lock) 
end

function StartCam()
    CameraFly = 1
    
    SetData("CommentaryPanel.Comment", "Chall.Shotgun3.Intro1")
    SendMessage("CommentaryPanel.ScriptText") 
    
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2")
    SetData("Camera.Path.Knots.LookAt", "Look1")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.6)
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera2", 4500)
end

function camera2()
    SetData("CommentaryPanel.Comment", "Chall.Shotgun3.Intro2")
    SendMessage("CommentaryPanel.ScriptText") 
    
    SetData("Camera.Path.Knots.Position", "Pos3,Pos4")
    SetData("Camera.Path.Knots.LookAt", "Look2")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.6)
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera3", 4500)
end

function camera3()
    SetData("CommentaryPanel.Comment", "Chall.Shotgun3.Intro3")
    SendMessage("CommentaryPanel.ScriptText") 
    
    SetData("Camera.Path.Knots.Position", "Pos5,Pos6")
    SetData("Camera.Path.Knots.LookAt", "Look3")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.6)
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera4", 4500)
end

function camera4()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Smile3")
    SendIntMessage("Worm.QueueAnim", 0)
    
    SetData("CommentaryPanel.Comment", "Chall.Shotgun3.Intro4")
    SendMessage("CommentaryPanel.ScriptText") 

    SetData("Camera.Path.Knots.Position", "Pos7")
    SetData("Camera.Path.Knots.LookAt", "Look4")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.6)
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera5", 1500)
end

function camera5()
    StartTimer("AngryText", 6000)
    SetData("Camera.Path.Knots.Position", "Pos8,Pos9,Pos10,Pos11,Pos12")
    SetData("Camera.Path.Knots.LookAt", "Look5,Look6,Look7")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.6)
    SetData("Camera.Path.Steps.Position",300)  
    SetData("Camera.Path.Steps.LookAt",700)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("startt", 12000)
end

function AngryText()
    SetData("CommentaryPanel.Comment", "Chall.Shotgun3.Intro5")
    SendMessage("CommentaryPanel.ScriptText") 
end

function Camera_Path_Reached_Knot()

    knot = GetData("Camera.Path.Knot")

    if knot == "Pos11" then
        SetData("CommentaryPanel.Comment", "Chall.Homing.Start")
        SendMessage("CommentaryPanel.ScriptText")
    end

end


function startt()
    SendMessage("EFMV.End")

camdone =  1

	StartFirstTurn()
end

function Camera_Path_Stopped()

    SendMessage("Commentary.Clear")

    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
    if TimerControl == 1 then
        CancelTimer(TextTime)
        TimerControl = 0
        end
    startt()
    end
end











