-- TRIAL OF THE DAMNED - Single Player Mission

--This mission has only 1 worm but still uses actual turns. This is so the wind has
--the chance to change - certain wind direction is needed for a couple of moves.

--The objective of this mission is to negotiate the landscape in order to collect
--the crate and use the Suicide Bomber that's inside. If the Suicide Bomber is used then
--the mission should award a success. If the player falls into the water however the mission
--will fail them.

--A new addition to this mission is the fact that the islands now blow up once the player
--crosses a certain point. It looks as if the player is being caught up by the islands being 
--blown up but in actual fact they can never really be caught. Well, maybe on the last two  :)

function Initialise()
    SendMessage("Commentary.NoDefault")
    bronzetime = (60 * 1000) * 9999
    silvertime = (60 * 1000) * 4
    goldtime = (60 * 1000) * 3.5

    SetData("TurnTime", 420000)
    SetData("RoundTime", 420000)

    SendMessage("GameLogic.PlaceObjects")
    
    SendMessage("HUD.HideTurnTime")
    SendMessage("EFMV.Start")
    endtrigger = 0
    Switch = 0
    Switch2 = 0
    
    SetData("Particle.DetailObject", "Sink")
    SetData("Particle.Name", "Part_Sinkhole")
    SendMessage("Particle.NewEmitter")
    
    SetData("Jetpack.MaxAltitude", 5500) --bm1
    
    SetData("Trigger.Spawn", "TRIG")
    SetData("Trigger.Radius", 15)
    SetData("Trigger.Index", 999)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead")
    SetData("Trigger.Radius", 275)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead2")
    SetData("Trigger.Radius", 275)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead3")
    SetData("Trigger.Radius", 400)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Trigger.Spawn", "TriggerDead4")
    SetData("Trigger.Radius", 400)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead5")
    SetData("Trigger.Radius", 400)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead6")
    SetData("Trigger.Radius", 400)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead7")
    SetData("Trigger.Radius", 400)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead8")
    SetData("Trigger.Radius", 400)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead9")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead10")
    SetData("Trigger.Radius", 550)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead11")
    SetData("Trigger.Radius", 550)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead12")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
        SetData("Trigger.Spawn", "TriggerDead12")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead13")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead14")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead15")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead16")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead17")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead18")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead19")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead20")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead21")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead22")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead23")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead24")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead25")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead26")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead27")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead28")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead29")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead30")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead30")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead31")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerDead32")
    SetData("Trigger.Radius", 500)
    SetData("Trigger.Index", 666)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerStart")
    SetData("Trigger.Radius", 60)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerSteps")
    SetData("Trigger.Radius", 60)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")

    --This is the trigger which the player needs to destroy in order to complete the mission
    --When they use the Suicide Bomber is sets off the trigger and awards a success.
    SetData("Trigger.Spawn", "TriggerEnd")
    SetData("Trigger.Radius", 120)
    SetData("Trigger.Index", 3)
    SetData("Trigger.TeamCollect", 1)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerIsland3")
    SetData("Trigger.Radius", 120)
    SetData("Trigger.Index", 4)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerIsland5")
    SetData("Trigger.Radius", 120)
    SetData("Trigger.Index", 5)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "TriggerIsland6")
    SetData("Trigger.Radius", 120)
    SetData("Trigger.Index", 6)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    BlackHoleTrig()
    
    SetData("Camera.StartOfTurnCamera","Default")
    
    SendStringMessage("Camera.Disable", "Track")
        
    SetData("Camera.GameOverCamera", "") 
    
    SetupWormsAndTeams()
    SetupInventories()

    SetData("HotSeatTime", 0)
   
   -- StartTimer("FirstMessage", 5000)
  --  StartFirstTurn()
    
    
    SetData("Particle.DetailObject", "Mist")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Mist2")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Mist3")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Mist4")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Mist5")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Mist6")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Mist7")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Mist8")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Mist9")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Mist10")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Mist11")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
   
    SetData("Particle.DetailObject", "Mist12")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
   
    SetData("Particle.DetailObject", "Mist13")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Mist14")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Vortex")
    SetData("Particle.Name", "Part_Vortex")
    SendMessage("Particle.NewEmitter")
       
    SetData("Crate.Spawn", "CrateSpawn1")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityGirder")
    SetData("Crate.Index", 1)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
     
    SendIntMessage("Crate.RadarHide", 1)
         
  --  SetData("Crate.Spawn", "CrateSpawn2")
  --  SetData("Crate.Type", "Utility")
   -- SetData("Crate.NumContents", 1)
   -- SetData("Crate.Contents", "kUtilityGirder")
   -- SetData("Crate.Index", 2)
  --  SetData("Crate.GroundSnap", 1)
   -- SendMessage("GameLogic.CreateCrate")
     
    SendIntMessage("Crate.RadarHide", 2)
     
    --SetData("Crate.Spawn", "CrateSpawn3")
    --SetData("Crate.Type", "Weapon")
    --SetData("Crate.NumContents", 666)
    --SetData("Crate.Contents", "kWeaponSuicideBomber")
    --SetData("Crate.Index", 3)
    --SetData("Crate.GroundSnap", 1)
    --SendMessage("GameLogic.CreateCrate")
    
   --- StartTimer("ExtraC", 60000)
    Camera()
end

function BlackHoleTrig()
    SetData("Trigger.Spawn", "BlackHole")
    SetData("Trigger.Radius", 5)
    SetData("Trigger.Index", 1000)
    SetData("Trigger.TeamCollect", 1)
    SetData("Trigger.Visibility", 1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "BlackHole")
    SetData("Trigger.Index", 1000)
    SetData("Trigger.TeamCollect", 1)
    SetData("Trigger.Visibility", 1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "BlackHole")
    SetData("Trigger.Index", 1000)
    SetData("Trigger.TeamCollect", 1)
    SetData("Trigger.Visibility", 1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "BlackHole")
    SetData("Trigger.Index", 1000)
    SetData("Trigger.TeamCollect", 1)
    SetData("Trigger.Visibility", 1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "BlackHole")
    SetData("Trigger.Index", 1000)
    SetData("Trigger.TeamCollect", 1)
    SetData("Trigger.Visibility", 1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "BlackHole")
    SetData("Trigger.Index", 1000)
    SetData("Trigger.TeamCollect", 1)
    SetData("Trigger.Visibility", 1)
    SendMessage("GameLogic.CreateTrigger")
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
        CancelTimer(FunLoop)
        StartFirstTurn()     
    end
end

function Camera()
    CameraFly = 1

    SetData("Camera.Path.Knots.Position", "Pos1,Pos2")
    SetData("Camera.Path.Knots.LookAt", "LookAt1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position", 1200)  
    SetData("Camera.Path.Steps.LookAt",150)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera2", 9000)
    FunLoop = StartTimer("WormsGo", 3000)
end

function WormsGo()
    SetData("CommentaryPanel.Comment", "Miss.Trial.Start")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")

end

function camera2()
    SetData("Camera.Path.Knots.Position", "Pos3,Pos4,Pos5")
    SetData("Camera.Path.Knots.LookAt", "LookAt2")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",150)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
        
    FunLoop = StartTimer("DONT", 2000)
    CamLoop = StartTimer("GUU", 7000)
end

function StartFirstTurn()
   WaitUntilNoActivity = false
   SendMessage("Timer.StartGame")
   SendMessage("EFMV.End")
   StartTurn()
end

function DONT()
    SetData("CommentaryPanel.Comment", "Miss.Trial.Dont")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
    SetData("CommentaryPanel.Comment", "Miss.Trial.Dont2")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
end

function GUU()
    CameraFly = 0
    StartFirstTurn()
   --SendMessage("EFMV.End")
end

function FUNK1()
    SendMessage("EFMV.Start")
    SendMessage("GameLogic.PauseGame")
    SetData("Camera.Path.Knots.Position", "Explosion1Pos,Explosion1twoPos")
    SetData("Camera.Path.Knots.LookAt", "Explosion1Look")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",800)  
    SetData("Camera.Path.Steps.LookAt",150)
    SetData("Camera.Path.Tension.Position", 0) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("C1", 1000)
end

function FUNK2()
    SendMessage("EFMV.Start")
    SendMessage("GameLogic.PauseGame")
    SetData("Camera.Path.Knots.Position", "Explosion2Pos,Explosion2twoPos")
    SetData("Camera.Path.Knots.LookAt", "Explosion2Look")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",250)  
    SetData("Camera.Path.Steps.LookAt",150)
    SetData("Camera.Path.Tension.Position", 0) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("C2", 1000)
end

--The function below destroys the islands as the user finishes crossing them.
function Trigger_Collected()
    TriggerIndex = GetData("Trigger.Index")
    
    if TriggerIndex == 1 then
        SetData("GameLogic.ArtilleryMode", 1)
        SetData("Camera.Path.IgnoreInput", 1)
        SendMessage("GameLogic.PauseGame")
        StartTimer("FUNK1", 500)
    elseif TriggerIndex == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Trial.Steps")
        SendMessage("CommentaryPanel.ScriptText")
    elseif TriggerIndex ==4 then
        SetData("GameLogic.ArtilleryMode", 1)
        SetData("Camera.Path.IgnoreInput", 1)
        StartTimer("FUNK2", 1500)
    elseif TriggerIndex == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Trial.GetReady")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("GameLogic.ArtilleryMode", 1)
        SetData("Camera.Path.IgnoreInput", 1)
        StartTimer("PreBoom", 2000)
        StartTimer("BOOM", 4000)
    elseif TriggerIndex == 6 then
        SetData("GameLogic.ArtilleryMode", 1)
        SetData("Camera.Path.IgnoreInput", 1)
        SetData("CommentaryPanel.Comment", "Miss.Trial.GetReady2")
        SendMessage("CommentaryPanel.ScriptText")
        StartTimer("BOOM2", 2000)
    elseif TriggerIndex == 666 then
        SendStringMessage("Camera.Disable", "Track")
        SendIntMessage("GameLogic.DestroyTrigger", 666)
        CameraDead()
    elseif TriggerIndex == 999 then
        --SendStringMessage("Camera.Disable", "Track")
        SetData("CommentaryPanel.Comment", "Miss.Trial.Finished")
        SendMessage("CommentaryPanel.ScriptText")
        StartTimer("ENDOR", 100)
    end
end

function ENDOR()

    StartTimer("Result", 2000)
    
    SetData("Camera.Path.Knots.Position", "ComPos1,ComPos2")
    SetData("Camera.Path.Knots.LookAt", "ComLook")
    SetData("Camera.Path.Loop.LookAt", 0)
    --bm1
    SetData("Camera.Path.Steps.Position", 600)  
    SetData("Camera.Path.Steps.LookAt",600)
    SetData("Camera.Path.Tension.Position", -0.1) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    

end



--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()

    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Prod = 0    
    CloseContainer(lock) -- must close the container ASAP
        
    SendMessage("Weapon.Delete")
    SendMessage("Weapon.Create")

    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
 
        if timetook < silvertime then
            Movie = 2

            Key,Lock = EditContainer("L.P.Lightside")
            if Lock.Locked == true then
                Lock.Locked = false
                SetData("MCa.LockedName2","L.P.Lightside")
            end
            CloseContainer(Key)
            
            if timetook < goldtime then
                Movie = 3

                Key,Lock = EditContainer("L.P.Darkside")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.P.Darkside")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function C2()
    CreateExplosion("Explosion2", 150, 0.35, 150, 250, 80)
    
    SetData("Particle.DetailObject", "Explosion2flash")
    SetData("Particle.Name", "Part_Jeggflash")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Explosion2ghost")
    SetData("Particle.Name", "Part_Ghost")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Explosion2ghost2")
    SetData("Particle.Name", "Part_Ghost")
    SendMessage("Particle.NewEmitter")
    SetData("Camera.Shake.Length",750)
    SetData("Camera.Shake.Magnitude",0.30)
    SendMessage("Camera.ShakeStart")
    
    SetData("Particle.DetailObject", "Isle2")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang1 = GetData("Particle.Handle")
    StartTimer("Isle2Bang2", 0400)
    StartTimer("Isle2Bang3", 0800)
    StartTimer("Isle2Bang4", 1400)
    StartTimer("Isle2KillSmoke", 1700)
    
    CreateExplosion("Explosion3", 150, 0.35, 150, 250, 80)
    CreateExplosion("Explosion3a", 150, 0.35, 150, 250, 80)

    SetData("CommentaryPanel.Comment", "Miss.Trial.Boom2")
    SendMessage("CommentaryPanel.ScriptText")

    StartTimer("CarryOn", 3000)
end

function Isle2Bang2()
    SetData("Particle.DetailObject", "Isle2a")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang2 = GetData("Particle.Handle")
end

function Isle2Bang3()
    SetData("Particle.DetailObject", "Isle2b")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang3 = GetData("Particle.Handle")
end

function Isle2Bang4()
    SetData("Particle.DetailObject", "Isle2c")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang4 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "Isle2d")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang5 = GetData("Particle.Handle")
end

function Isle2KillSmoke()
    SendIntMessage("Particle.DeleteEmitter",bang1)
    SendIntMessage("Particle.DeleteEmitter",bang2)
    SendIntMessage("Particle.DeleteEmitter",bang3)
    SendIntMessage("Particle.DeleteEmitter",bang4)
    SendIntMessage("Particle.DeleteEmitter",bang5)
end

function C1()
    SetData("Particle.DetailObject", "Explosion1flash")
    SetData("Particle.Name", "Part_Jeggflash")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Explosion1ghost")
    SetData("Particle.Name", "Part_Ghost")
    SendMessage("Particle.NewEmitter")
        
    SetData("Particle.DetailObject", "Isle1")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang1 = GetData("Particle.Handle")
    StartTimer("Isle1Bang2", 0300)
    StartTimer("Isle1Bang3", 0350)
    StartTimer("Isle1KillSmoke", 1000)
    
    CreateExplosion("Explosion1", 250, 0.35, 150, 300, 80)
    CreateExplosion("Explosion1B", 250, 0.35, 150, 300, 80)
        
    SetData("Camera.Shake.Length",1500)
    SetData("Camera.Shake.Magnitude",0.20)
    SendMessage("Camera.ShakeStart")
    SetData("CommentaryPanel.Comment", "Miss.Trial.Boom1")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("IThink", 4500)
end

function Isle1Bang2()
    SetData("Particle.DetailObject", "Isle1a")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang2 = GetData("Particle.Handle")
end

function Isle1Bang3()
    SetData("Particle.DetailObject", "Isle1b")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang3 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "Isle1c")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang4 = GetData("Particle.Handle")
end

function Isle1KillSmoke()
    SendIntMessage("Particle.DeleteEmitter",bang1)
    SendIntMessage("Particle.DeleteEmitter",bang2)
    SendIntMessage("Particle.DeleteEmitter",bang3)
    SendIntMessage("Particle.DeleteEmitter",bang4)
end

function CarryOn()
    SetData("GameLogic.ArtilleryMode", 0)
    SetData("Camera.Path.IgnoreInput", 0)
    SendMessage("GameLogic.ResumeGame")
    SendMessage("EFMV.End")
    --StartTurn() - KEV2
    SendMessage("Camera.SetDefault") -- KEV2F
end

function CameraDead()
    CameraFly = 2
        
    SetData("CommentaryPanel.Comment", "Miss.Trial.Dead1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Trial.Dead2")
    SendMessage("CommentaryPanel.ScriptText")
            
    SetData("Camera.Path.Knots.Position", "ECP1,ECP2")
    SetData("Camera.Path.Knots.LookAt", "ECL1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position", 580)  
    SetData("Camera.Path.Steps.LookAt", 580)
    SetData("Camera.Path.Tension.Position", -0.1) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    if Switch2 == 0 then
        TheEnd()
        Switch2 = 1
    end
end

function Weapon_Fired_End()
   SendMessage("Weapon.Delete")
   SendMessage("Weapon.Create")
end

function TheEnd()
    SendMessage("GameLogic.Mission.Failure")
end

function PreBoom()
    SendMessage("GameLogic.PauseGame")
    SetData("GameLogic.ArtilleryMode", 1)
    SendMessage("EFMV.Start")
    SetData("Camera.Path.Knots.Position", "ExpPos1,ExpPos2,ExpPos3")
    SetData("Camera.Path.Knots.LookAt", "ExpLook1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position", 350)  
    SetData("Camera.Path.Steps.LookAt",350)
    SetData("Camera.Path.Tension.Position", -0.1) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    BOOM()
end

function BOOM()
    CreateExplosion("Explosion4", 150, 0.35, 150, 250, 80)
    SetData("Particle.DetailObject", "Explosion4flash")
    SetData("Particle.Name", "Part_Jeggflash")
    SendMessage("Particle.NewEmitter")
    SetData("Camera.Shake.Length",750)
    SetData("Camera.Shake.Magnitude",0.30)
    SendMessage("Camera.ShakeStart")
    CreateExplosion("Explosion4a", 150, 0.35, 150, 250, 80)
    CreateExplosion("Explosion4b", 150, 0.35, 150, 250, 80)
    SetData("Particle.DetailObject", "Explosion5flash")
    SetData("Particle.Name", "Part_Jeggflash")
    SendMessage("Particle.NewEmitter")
    CreateExplosion("Explosion5", 150, 0.35, 150, 250, 80)
    StartTimer("CarryOn", 3000)
    
    SetData("Particle.DetailObject", "Isle3")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang1 = GetData("Particle.Handle")--bm1
    StartTimer("Isle3Bang6", 0400)
    StartTimer("Isle3Bang4", 0650)
    StartTimer("Isle3Bang3", 1300)
    StartTimer("Isle3Bang10", 1900)
    StartTimer("Isle3KillSmoke", 2500)
end

function Isle3Bang3()
    SetData("Particle.DetailObject", "Isle3a")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang2 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "Isle3b")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang3 = GetData("Particle.Handle")
end

function Isle3Bang4()
    SetData("Particle.DetailObject", "Isle3c")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang4 = GetData("Particle.Handle")
end

function Isle3Bang6()
    SetData("Particle.DetailObject", "Isle3d")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang5 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "Isle3e")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang6 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "Isle3h")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang9 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "Isle3j")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang10 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "Isle3j")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang11 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "Isle3g")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang8 = GetData("Particle.Handle")
end

function Isle3Bang10()
    SetData("Particle.DetailObject", "Isle3f")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang7 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "Isle3i")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang10 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "Isle3l")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang12 = GetData("Particle.Handle")
    SetData("Particle.DetailObject", "Isle3m")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang13 = GetData("Particle.Handle")
end

function Isle3KillSmoke()
    SendIntMessage("Particle.DeleteEmitter",bang1)
    SendIntMessage("Particle.DeleteEmitter",bang2)
    SendIntMessage("Particle.DeleteEmitter",bang3)
    SendIntMessage("Particle.DeleteEmitter",bang4)
    SendIntMessage("Particle.DeleteEmitter",bang5)
    SendIntMessage("Particle.DeleteEmitter",bang6)
    SendIntMessage("Particle.DeleteEmitter",bang7)
    SendIntMessage("Particle.DeleteEmitter",bang8)
    SendIntMessage("Particle.DeleteEmitter",bang9)
    SendIntMessage("Particle.DeleteEmitter",bang10)
    SendIntMessage("Particle.DeleteEmitter",bang11)
    SendIntMessage("Particle.DeleteEmitter",bang12)
    SendIntMessage("Particle.DeleteEmitter",bang13)
end

function BOOM2()
    SendMessage("EFMV.Start")
    SendMessage("GameLogic.PauseGame")
    SetData("GameLogic.ArtilleryMode", 1)
    SetData("Camera.Path.Knots.Position", "Exp6Pos1,Exp6Pos2")
    SetData("Camera.Path.Knots.LookAt", "Exp6Look1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position", 550)  
    SetData("Camera.Path.Steps.LookAt",350)
    SetData("Camera.Path.Tension.Position", -0.1) 
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    VOOM2()
end

function VOOM2()
    CreateExplosion("Explosion6", 150, 0.35, 150, 230, 80)
    SetData("Particle.DetailObject", "Explosion6flash")
    SetData("Particle.Name", "Part_Jeggflash")
    SendMessage("Particle.NewEmitter")
    SetData("Camera.Shake.Length",750)
    SetData("Camera.Shake.Magnitude",0.30)
    SendMessage("Camera.ShakeStart")
    SetData("CommentaryPanel.Comment", "Miss.Trial.OhNo")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("CarryOn", 3000)
    
    SetData("Particle.DetailObject", "Isle4")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang1 = GetData("Particle.Handle")
    
    StartTimer("Isle4Bang2", 0300)
    StartTimer("Isle4Bang3", 0500)
    StartTimer("Isle4Bang4", 0700)
    StartTimer("Isle4Bang5", 0800)
    StartTimer("Isle4KillSmoke", 1500)
end

function Isle4Bang2()
    SetData("Particle.DetailObject", "Isle4a")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang2 = GetData("Particle.Handle")
end

function Isle4Bang3()
    SetData("Particle.DetailObject", "Isle4b")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang3 = GetData("Particle.Handle")
end

function Isle4Bang4()
    SetData("Particle.DetailObject", "Isle4c")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang4 = GetData("Particle.Handle")
end

function Isle4Bang5()
    SetData("Particle.DetailObject", "Isle4d")
    SetData("Particle.Name", "EffectExplosion")
    SendMessage("Particle.NewEmitter")
    bang5 = GetData("Particle.Handle")
end

function Isle4KillSmoke()
    SendIntMessage("Particle.DeleteEmitter",bang1)
    SendIntMessage("Particle.DeleteEmitter",bang2)
    SendIntMessage("Particle.DeleteEmitter",bang3)
    SendIntMessage("Particle.DeleteEmitter",bang4)
    SendIntMessage("Particle.DeleteEmitter",bang5)
end

function IThink()
    SetData("CommentaryPanel.Comment", "Miss.Trial.IThink")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Trial.IThink2")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("GURD", 4500)
end

function GURD()
    SendMessage("EFMV.End")
    StartTimer("ROPETEXT", 1000)
    
    SetData("Camera.Path.IgnoreInput", 0)
    SetData("GameLogic.ArtilleryMode", 0)
    SendMessage("GameLogic.ResumeGame")
    
    TurnEnded() -- KEV1
        
    SendMessage("Camera.SetDefault") -- KEV1F
end

function ROPETEXT()
           SetData("CommentaryPanel.Comment", "Miss.Trial.Start2")
        SendMessage("CommentaryPanel.ScriptText")
end

function Trigger_Destroyed()
	TriggerIndex = GetData("Trigger.Index")
	if TriggerIndex == 3 then
            endtrigger = 1
        end
end

function TurnEnded()
   -- SendMessage("WormManager.GetActiveWormCount")
  --  WormCount = GetData("WormCount")
  
    SetData("GameLogic.ArtilleryMode", 0)
    CheckOneTeamVictory()
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch2 == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch2 = 1
        end
    else
        StartTurn()
    end
    --if WormCount == 0 then
    --    SendMessage("GameLogic.Mission.Failure")
    --else
    --    StartTurn()
    --end
end

function CheckOneTeamVictory()
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn1"
    worm.Energy = 250
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 

   SendMessage("WormManager.Reinitialise")
end

function TurnStarted()
    SetData("Wind.Speed", 0.1*MaxWind)
    SetData("Wind.Direction", 2.5)
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00")
    inventory.SkipGo = 0
    CloseContainer(lock) 
end



--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end
