
-- driving range

function Initialise()

NewCrate = 1
camdone = 0
diewhere = 1
Timer = 0
Turn = 0
-- Sets up mines and turn time
   SetData("Mine.DudProbabilty", 0.1)
   SetData("Mine.MinFuse", 3000)
   SetData("Mine.MaxFuse", 4000)
   SetData("HotSeatTime", 0) -- no hotseat time
   SetData("RoundTime", 0) -- no Game timer
   SetData("TurnTime", 0) -- no game timer
   SetData("HUD.Clock.DisplayRoundTime", 0)
    SendMessage("HUD.HideTurnTime")
    SendMessage("Commentary.NoDefault")

    SendStringMessage("Camera.Disable", "Track")
    
    SendMessage("EFMV.Start")
    SetData("Camera.StartOfTurnCamera","Default")
    SendMessage("GameLogic.PlaceObjects")

    
    MakeNewCrate()

    SetupWormsAndTeams()
    SetupInventories()
    --StartFirstTurn()
    camera()


 --function stopteam()
   --SendStringMessage("Input.DisableGroup", "WormMoving")
    SetData("GameLogic.ArtilleryMode", 1)
--end
 



end


-- /////////////////////////////////////////////////////////////






function TurnEnded()
   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
   if TeamCount == 0 then
      -- all the worms have just snuffed it
      
        FailureMessages()
        SendMessage("GameLogic.Tutorial.End")
   else
      -- still at least some worms left
      StartTurn()
   end
end







-- //////////////////////////////////////////////////////////////////

function SetupWormsAndTeams()

   -- Activate Team 0
   GM = QueryContainer("GM.GameInitData")
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
    team.Name = GM.T1_Name
   team.TeamColour = 0
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
   CloseContainer(lock) -- must close the container ASAP



   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = GetData ("User.HumanWorm1")
   worm.Energy = 1
   worm.Spawn = "Spawn1"
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 
 

   SendMessage("WormManager.Reinitialise")

end

-- //////////////////////////////////////////////////////////////////

function SetupInventories()
    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    
        inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade =-1
    inventory.Airstrike = -1
    inventory.HolyHandGrenade = -1
    inventory.BananaBomb = -1
    inventory.HomingMissile = -1
    inventory.HomingPidgeon = 1
    inventory.Sheep = -1
    inventory.SuperSheep = -1
    inventory.Parachute = 0
    inventory.Teleport = 0
    inventory.Jetpack = 0
    inventory.SkipGo = 0
    -- SUPERBANANABOMB: inventory.SuperBananaBomb = -1
    inventory.MadCow = -1
    inventory.OldWoman = -1
    -- MAILSTRIKE: inventory.MailStrike = -1
    inventory.Shotgun = -1
    inventory.Uzi = -1
    -- MINIGUN: inventory.Minigun = -1
    -- FLAMETHROWER: inventory.FlameThrower = -1
    inventory.NinjaRope = 0
    inventory.FirePunch = 0
    inventory.LowGravity = 0
    -- LASER: inventory.Lasergun = -1
    -- NAPALM: inventory.Napalm = -1
    inventory.PetrolBomb = -1
    inventory.BaseballBat = 0
    inventory.Mortar = -1
    -- VASE: inventory.MingVase = -1
    -- DRAGONBALL: inventory.Dragonball = -1
    inventory.LotteryStrike = -1
    --inventory.DoctorsStrike = -1
    inventory.StickyBomb = -1
    inventory.Binoculars = -1
    inventory.Blowpipe = 0

   --inventory.Surrender = -1
    CloseContainer(lock) -- must close the container ASAP

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   
end



-- ///////////////////////////////////////////////////////////////////



-- //////////////////////////////////////////////////////////////////////


function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.1*MaxWind)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", 3.3) 

end


function Crate_Collected()
    TargetNumber = GetData("Crate.Index")
    MakeNewCrate2()
end

function Crate_Destroyed()
    TargetNumber = GetData("Crate.Index")
    MakeNewCrate2()
end

-- When MakeNewCrate is called It runs through this below and adds 1 each time so it knows which crate it is on



function MakeNewCrate()


	SetData("Crate.Spawn", "targ1")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 1)
	SetData("Crate.NumContents", 1)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

	SetData("Crate.Spawn", "targ2")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 2)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "targ3")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 3)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
        
	SetData("Crate.Spawn", "targ4")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 4)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

	SetData("Crate.Spawn", "targ5")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 5)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "targ6")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 6)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

	SetData("Crate.Spawn", "targ7")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 7)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")        
        
	SetData("Crate.Spawn", "targ8")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 8)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

	SetData("Crate.Spawn", "targ9")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 9)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "targ10")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

	SetData("Crate.Spawn", "targ11")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 11)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

        
	SetData("Crate.Spawn", "targ12")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 12)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

	SetData("Crate.Spawn", "targ13")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 13)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "targ14")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 14)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

	SetData("Crate.Spawn", "targ15")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 15)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")               
    
end        
        
function MakeNewCrate2()

    if TargetNumber == 1 then
	SetData("Crate.Spawn", "targ1")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.Index", 1)
	SetData("Crate.NumContents", 1)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 2 then
	SetData("Crate.Spawn", "targ2")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 2)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 3 then
	SetData("Crate.Spawn", "targ3")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 3)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 4 then        
	SetData("Crate.Spawn", "targ4")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 4)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 5 then
	SetData("Crate.Spawn", "targ5")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 5)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 6 then
	SetData("Crate.Spawn", "targ6")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 6)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 7 then
	SetData("Crate.Spawn", "targ7")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 7)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")        
    elseif TargetNumber == 8 then        
	SetData("Crate.Spawn", "targ8")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 8)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 9 then
	SetData("Crate.Spawn", "targ9")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 9)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 10 then
	SetData("Crate.Spawn", "targ10")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 11 then
	SetData("Crate.Spawn", "targ11")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 11)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 12 then        
	SetData("Crate.Spawn", "targ12")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 12)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 13 then
	SetData("Crate.Spawn", "targ13")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 13)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 14 then
	SetData("Crate.Spawn", "targ14")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 14)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
    elseif TargetNumber == 15 then
	SetData("Crate.Spawn", "targ15")
	SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 0)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Index", 15)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")               
    end
    
end         
        
        
        
        
function TurnStarted()
    
    Turn = Turn + 1
    
    
    if Turn == 5 then
        SendMessage("RandomNumber.Get")
        RandomNumber = GetData("RandomNumber.Uint")
        MyRandomNumber = math.mod(RandomNumber, 2) + 1
    
        if MyRandomNumber == 1 then
            SetData("CommentaryPanel.Comment", "Chall.DrivingRange.game4")
            SetData("CommentaryPanel.Delay",2500)
            SendMessage("CommentaryPanel.TimedText")
        elseif MyRandomNumber == 2 then
            SetData("CommentaryPanel.Comment", "Chall.DrivingRange.game5")
            SetData("CommentaryPanel.Delay",2500)
            SendMessage("CommentaryPanel.TimedText")
        end
        
        Turn = 0
    end
    
end
        
        
        
        
        
        
        
        
        
        
function anims()

    
    
end






function camera()


SetData("CommentaryPanel.Comment", "Chall.DrivingRange.game1")
SendMessage("CommentaryPanel.ScriptText")

SetData("CommentaryPanel.Comment", "Chall.DrivingRange.game2")
SendMessage("CommentaryPanel.ScriptText")

SetData("CommentaryPanel.Comment", "Chall.DrivingRange.game3")
SendMessage("CommentaryPanel.ScriptText")

SetData("CommentaryPanel.Comment", "Chall.DrivingRange.game4")
SendMessage("CommentaryPanel.ScriptText")

SetData("CommentaryPanel.Comment", "Chall.DrivingRange.game5")
SendMessage("CommentaryPanel.ScriptText")

SetData("CommentaryPanel.Comment", "Chall.DrivingRange.game6")
SendMessage("CommentaryPanel.ScriptText")



    SetData("Camera.Path.Knots.Position", "cam1,cam2,cam3")
    SetData("Camera.Path.Knots.LookAt", "look1,look2,look3")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",615)  
    SetData("Camera.Path.Steps.LookAt",590)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    
end



function Camera_Path_Reached_Knot()
   knot = GetData("Camera.Path.Knot")
   
 
 
-- ends camera   
   
   if knot == "cam3" then 
   
        SetData("Camera.Orbit.Speed",-0.2)
       camdone = 1
       StartFirstTurn()
       SendMessage("EFMV.End") 
       SendMessage("Commentary.Clear")
       
   end
end


function SendBriefingMessage()

SendStringMessage("FE.QueuePopUp","Game.BriefDialog")

end




function Input_SomeInput()

    if camdone == 0 then
        camdone =  1
        StartFirstTurn()
        SendMessage("EFMV.End") 
        SendMessage("Commentary.Clear")    

        
    end

end


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 4) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Helter.game13")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Schools.OhNo")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Chall.Shotgun1.game1")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Beanstalk.game25")
        SendMessage("CommentaryPanel.ScriptText")
    
    end
    
end
