-- ex3
-- demonstrates advanced artillery mode
-- note how these functions override those in turns.lua
-- and the use of a timer callback

function Initialise()
   SendMessage("GameLogic.PlaceObjects")
   StartFirstTurn()
end


function TurnStarted()
   TimerId = StartTimer("TimeOut", 10000)
end


function TurnEnded()
   CancelTimer(TimerId)
   SendStringMessage("Input.EnableGroup", "WormMoving")
   CheckOneTeamVictory()
end


function TimeOut()
   SendStringMessage("Input.DisableGroup", "WormMoving")
end
