
-- ! Needs Hat Worms to work properly.
-- ! EMFV for endings needs working out.

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 4.5
    goldtime = (60 * 1000) * 3.5
    SendMessage("EFMV.Start")
    SetData("Mine.DudProbabilty", 0.0)
    SetData("Mine.MinFuse", 3000)
    SetData("Mine.MaxFuse", 3000)
    SendMessage("GameLogic.PlaceObjects")
    
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
    SendMessage("Commentary.NoDefault")
    
    SetData("TurnTime", 45000)
    SetData("HotSeatTime", 3000)
    SetData("RoundTime", 0)
    SetData("HUD.Clock.DisplayRoundTime", 0)
    
    GroundPhase = 1
    HelterPhase = 1
    GroundCrates = 0
    HelterCrates = 0
    
    AddStrike = 0
    SpawnGround()
    SpawnHelter()
    SpawnTriggers()
    
    CameraFly = 1
    TextGoing = 0
    AnimGoing = 0
    CurrentWormIndex = 0
    deadcpu = 0
    GameOver = false
    Switch = 0
    
    spark1 = 0
    spark2 = 0
    spark3 = 0
    spark4 = 0
    spark5 = 0
    spark6 = 0
    spark7 = 0
    spark8 = 0
    CamLoop = 0
    
    HatWormMove = 0
    
    Sparks()
    SelectRandomWind()
    SetupWormsAndTeams()
    SetupInventories() 
    PanHelter()
end


function Camera_Path_Stopped()
    if CameraFly == 1 then
        if TextGoing == 1 then
            TextGoing = 0
        end
        if AnimGoing == 1 then
            AnimGoing = 0
        end
        SendMessage("Commentary.Clear")
        SendMessage("EFMV.End")
        CameraFly = 0
        CancelTimer(CamLoop)
        StartFirstTurn()
    end
end

function CameraFinished()
    SendMessage("EFMV.End")
    CameraFly = 0
    StartFirstTurn()
end

function PanHelter()
    SetData("Camera.Path.Knots.Position", "PanSkelterCam,PanSkelterCam2")
    SetData("Camera.Path.Knots.LookAt", "PanSkelterLook,PanSkelterLook2")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("ZoomFromScene", 4000)
end

function ZoomFromScene()
    SetData("Camera.Path.Knots.Position", "ZoomFSCam,ZoomFSCam2")
    SetData("Camera.Path.Knots.LookAt", "ZoomFSLook")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("ScaleHelter", 3000)
end

function ScaleHelter()
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Bored1")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Camera.Path.Knots.Position", "HeltCam,HeltCam2")
    SetData("Camera.Path.Knots.LookAt", "HeltLook,HeltLook2")
    SetData("Camera.Path.Steps.Position",550)
    SetData("Camera.Path.Steps.LookAt",550) 
    SendMessage("Camera.Path.Start")
    TextLoop = StartTimer("TopText", 4500)
    TextGoing = 1
    AnimLoop = StartTimer("WaveAnim", 5200)
    AnimGoing = 1
    CamLoop = StartTimer("LookBaddie1", 7700)
end

function TopText()
    TextGoing = 0
    SetData("CommentaryPanel.Comment", "Miss.Helter.game1")
    SetData("CommentaryPanel.Delay",2600)
    SendMessage("CommentaryPanel.TimedText")
end

function WaveAnim()
    AnimGoing = 0
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Wave_Right")
    SendIntMessage("Worm.QueueAnim", 1)
end

function LookBaddie1()
    SetData("GameLogic.WeaponName", "kWeaponBaseballBat")
    SendMessage("GameLogic.RequestWeaponIndex")
    WIndex = GetData("GameLogic.WeaponIndex")

    SetData("CommentaryPanel.Comment", "Miss.Helter.game2")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
    
    SetData("Camera.Path.Knots.Position", "Bad1Cam")
    SetData("Camera.Path.Knots.LookAt", "Bad1Look")
    SetData("Camera.Path.Steps.Position",250)
    SetData("Camera.Path.Steps.LookAt",250) 
    SendMessage("Camera.Path.Start")

    lock, worm = EditContainer("Worm.Data03")
    worm.WeaponIndex = WIndex
    worm.LogicAnimState = 10
    CloseContainer(lock)
    SendIntMessage("Worm.ScriptDrawAnim", 3)
    SendMessage("Weapon.CreateGraphic")
    
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "DrawBat")
    SendIntMessage("Worm.QueueAnim", 3)
    SetData("Worm.ScriptAnim", "FireBat")
    SendIntMessage("Worm.QueueAnim", 3)
    CamLoop = StartTimer("LookBaddie2", 1300)
end

function LookBaddie2()
    SetData("GameLogic.WeaponName", "kWeaponFirePunch")
    SendMessage("GameLogic.RequestWeaponIndex")
    WIndex = GetData("GameLogic.WeaponIndex")

    SetData("Camera.Path.Knots.Position", "Bad2Cam")
    SetData("Camera.Path.Knots.LookAt", "Bad2Look")
    SetData("Camera.Path.Steps.Position",250)
    SetData("Camera.Path.Steps.LookAt",250) 
    SendMessage("Camera.Path.Start")
    
    lock, worm = EditContainer("Worm.Data02")
    worm.WeaponIndex = WIndex
    worm.LogicAnimState = 10
    CloseContainer(lock)
    SendIntMessage("Worm.ScriptDrawAnim", 2) 
    SendMessage("Weapon.CreateGraphic")
    
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "DrawFirepunch")
    SendIntMessage("Worm.QueueAnim", 2)
    SetData("Worm.ScriptAnim", "FireFirepunch")
    SendIntMessage("Worm.QueueAnim", 2)
    CamLoop = StartTimer("LookBaddie3", 1300)
end

function LookBaddie3() 
    SetData("GameLogic.WeaponName", "kWeaponShotgun")
    SendMessage("GameLogic.RequestWeaponIndex")
    WIndex = GetData("GameLogic.WeaponIndex")

    SetData("Camera.Path.Knots.Position", "Bad3Cam")
    SetData("Camera.Path.Knots.LookAt", "Bad3Look")
    SetData("Camera.Path.Steps.Position",250)
    SetData("Camera.Path.Steps.LookAt",250) 
    SendMessage("Camera.Path.Start")
    
    lock, worm = EditContainer("Worm.Data04")
    worm.WeaponIndex = WIndex
    worm.LogicAnimState = 10
    CloseContainer(lock)
    SendIntMessage("Worm.ScriptDrawAnim", 4) 
    SendMessage("Weapon.CreateGraphic")
    
    SendIntMessage("Worm.ResetAnim", 4)
    SetData("Worm.ScriptAnim", "DrawShotgun")
    SendIntMessage("Worm.QueueAnim", 4)
    SetData("Worm.ScriptAnim", "FireShotgun")
    SendIntMessage("Worm.QueueAnim", 4)
    CamLoop = StartTimer("EmbHatCam", 1500)
end

function EmbHatCam()
    SetData("Camera.Path.Knots.Position", "EmbHatCam")
    SetData("Camera.Path.Knots.LookAt", "EmbHatLook") 
    SendMessage("Camera.Path.Start")
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Scared1")
    SendIntMessage("Worm.QueueAnim", 1)
    CamLoop = StartTimer("EmbWormCam", 2000)
end

function EmbWormCam()
    SetData("Camera.Path.Knots.Position", "EmbCam")
    SetData("Camera.Path.Knots.LookAt", "EmbLook") 
    SendMessage("Camera.Path.Start")
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Embarrassed2")
    SendIntMessage("Worm.QueueAnim", 0)
    CamLoop = StartTimer("Collect1", 4000)
end

function Collect1()
    SetData("Camera.Path.Knots.Position", "Collect1Cam,Collect1Cam2")
    SetData("Camera.Path.Knots.LookAt", "Collect1Look")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game3")
    SetData("CommentaryPanel.Delay",3400)
    SendMessage("CommentaryPanel.TimedText")
    CamLoop = StartTimer("Collect2", 2000)
end

function Collect2()
    SetData("Camera.Path.Knots.Position", "Collect2Cam,Collect2Cam2")
    SetData("Camera.Path.Knots.LookAt", "Collect2Look")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game4")
    SendMessage("CommentaryPanel.ScriptText")
    CamLoop = StartTimer("Collect3", 2000)
end

function Collect3()
    SetData("Camera.Path.Knots.Position", "Collect3Cam,Collect3Cam2")
    SetData("Camera.Path.Knots.LookAt", "Collect3Look")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("AllLook", 2000)
end

function AllLook()
    SetData("Camera.Path.Knots.Position", "AllSceneCam")
    SetData("Camera.Path.Knots.LookAt", "AllSceneLook")
    SendMessage("Camera.Path.Start")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game5")
    SetData("CommentaryPanel.Delay",2500)
    SendMessage("CommentaryPanel.TimedText")
    CamLoop = StartTimer("AllLook2", 3000)
end

function AllLook2()
    SetData("CommentaryPanel.Comment", "Miss.Helter.game6")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "AllScene2Cam")
    SetData("Camera.Path.Knots.LookAt", "AllScene2Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("CameraFinished", 3000)
end
-- cameraend
function SpawnGround()
    if GroundPhase == 1 then
        SetData("Crate.Spawn", "Cluster")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponClusterGrenade")
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.TeamDestructible", -1)
        SetData("Crate.Index", 100)
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "Cluster2")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "Cluster3")
        SendMessage("GameLogic.CreateCrate")

        SetData("Crate.Spawn", "Cluster4")
        SendMessage("GameLogic.CreateCrate")
        GroundPhase = 2
    elseif GroundPhase == 2 then
        SetData("Crate.Spawn", "ClusterA")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponClusterGrenade")
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.TeamDestructible", -1)
        SetData("Crate.Index", 100)
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "Cluster2A")
        SendMessage("GameLogic.CreateCrate")
    
        SetData("Crate.Spawn", "Cluster3A")
        SendMessage("GameLogic.CreateCrate")

        SetData("Crate.Spawn", "Cluster4A")
        SendMessage("GameLogic.CreateCrate")
        GroundPhase = 1
    end
end

function SpawnHelter()
    if HelterPhase == 1 then
        SetData("Crate.Spawn", "Grenade")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponBazooka")
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.TeamDestructible", -1)
        SetData("Crate.Index", 101)
        SendMessage("GameLogic.CreateCrate")
        
        SetData("Crate.Spawn", "Grenade2")
        SendMessage("GameLogic.CreateCrate")
        
        SetData("Crate.Spawn", "Bazooka")
        SendMessage("GameLogic.CreateCrate")
        
        SetData("Crate.Spawn", "Bazooka2")
        SetData("Crate.Contents", "kWeaponBazooka")
        SendMessage("GameLogic.CreateCrate")
        HelterPhase = 2
    elseif HelterPhase == 2 then
        SetData("Crate.Spawn", "GrenadeA")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 1)
        SetData("Crate.Contents", "kWeaponGrenade")
        SetData("Crate.GroundSnap", 1)
        SetData("Crate.TeamDestructible", -1)
        SetData("Crate.Index", 101)
        SendMessage("GameLogic.CreateCrate")
        
        SetData("Crate.Spawn", "Grenade2A")
        SendMessage("GameLogic.CreateCrate")
        
        SetData("Crate.Spawn", "BazookaA")
        SendMessage("GameLogic.CreateCrate")
        
        SetData("Crate.Spawn", "Bazooka2A")
        SetData("Crate.Contents", "kWeaponBazooka")
        SendMessage("GameLogic.CreateCrate")
        HelterPhase = 1
    end
end

function Crate_Collected()
    CrateIndex = GetData("Crate.Index")
    if CrateIndex == 100 then
        GroundCrates = GroundCrates + 1
        if GroundCrates == 4 then
            GroundCrates = 0
            SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
            SendMessage("CommentaryPanel.ScriptText")
            SpawnGround()
        end
    elseif CrateIndex == 101 then
        HelterCrates = HelterCrates + 1
        if HelterCrates == 4 then
            HelterCrates = 0
            SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
            SendMessage("CommentaryPanel.ScriptText")
            SpawnHelter()
        end
    end
end

function Crate_Destroyed()
    CrateIndex = GetData("Crate.Index")
    if CrateIndex == 100 then
        GroundCrates = GroundCrates + 1
        if GroundCrates == 4 then
            GroundCrates = 0
            SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
            SendMessage("CommentaryPanel.ScriptText")
            SpawnGround()
        end
    elseif CrateIndex == 101 then
        HelterCrates = HelterCrates + 1
        if HelterCrates == 4 then
            HelterCrates = 0
            SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
            SendMessage("CommentaryPanel.ScriptText")
            SpawnHelter()
        end
    end
end

function SpawnTriggers()
    SetData("Trigger.Spawn", "Protect_Trigger")
    SetData("Trigger.Radius", 30)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Knock_Detect")
    SetData("Trigger.Radius", 30)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy", -1)
    SetData("Trigger.AffectsAI",0)
    SetData("Trigger.Index", 10)
    SendMessage("GameLogic.CreateTrigger")
end

function Trigger_Destroyed()
    TriggerIndex = GetData("Trigger.Index")
    if TriggerIndex == 10 then
        HatWormMove = 1
    end
end

function Sparks()
    MakeOtherRandomNumber()
    if MyOtherRandomNumber == 1 then
        SetData("Particle.DetailObject", "spark1")
        SetData("Particle.Name", "Part_ElectricSpark")
        SendMessage("Particle.NewEmitter")
	spark1 = GetData("Particle.Handle")
	SendIntMessage("Particle.DeleteEmitter",spark2)
	SendIntMessage("Particle.DeleteEmitter",spark3)
	SendIntMessage("Particle.DeleteEmitter",spark4)
	SendIntMessage("Particle.DeleteEmitter",spark5)
	SendIntMessage("Particle.DeleteEmitter",spark6)
	SendIntMessage("Particle.DeleteEmitter",spark7)
	SendIntMessage("Particle.DeleteEmitter",spark8)
    elseif MyOtherRandomNumber == 2 then
        SetData("Particle.DetailObject", "spark2")
        SetData("Particle.Name", "Part_ElectricSpark")
        SendMessage("Particle.NewEmitter")
	spark2 = GetData("Particle.Handle")
	SendIntMessage("Particle.DeleteEmitter",spark1)
	SendIntMessage("Particle.DeleteEmitter",spark3)
	SendIntMessage("Particle.DeleteEmitter",spark4)
	SendIntMessage("Particle.DeleteEmitter",spark5)
	SendIntMessage("Particle.DeleteEmitter",spark6)
	SendIntMessage("Particle.DeleteEmitter",spark7)
	SendIntMessage("Particle.DeleteEmitter",spark8)
    elseif MyOtherRandomNumber == 3 then
        SetData("Particle.DetailObject", "spark3")
        SetData("Particle.Name", "Part_ElectricSpark")
        SendMessage("Particle.NewEmitter")
	spark3 = GetData("Particle.Handle")
	SendIntMessage("Particle.DeleteEmitter",spark1)
	SendIntMessage("Particle.DeleteEmitter",spark2)
	SendIntMessage("Particle.DeleteEmitter",spark4)
	SendIntMessage("Particle.DeleteEmitter",spark5)
	SendIntMessage("Particle.DeleteEmitter",spark6)
	SendIntMessage("Particle.DeleteEmitter",spark7)
	SendIntMessage("Particle.DeleteEmitter",spark8)
    elseif MyOtherRandomNumber == 4 then
        SetData("Particle.DetailObject", "spark4")
        SetData("Particle.Name", "Part_ElectricSpark")
        SendMessage("Particle.NewEmitter")
	spark4 = GetData("Particle.Handle")
	SendIntMessage("Particle.DeleteEmitter",spark1)
	SendIntMessage("Particle.DeleteEmitter",spark2)
	SendIntMessage("Particle.DeleteEmitter",spark3)
	SendIntMessage("Particle.DeleteEmitter",spark5)
	SendIntMessage("Particle.DeleteEmitter",spark6)
	SendIntMessage("Particle.DeleteEmitter",spark7)
	SendIntMessage("Particle.DeleteEmitter",spark8)
    elseif MyOtherRandomNumber == 5 then
        SetData("Particle.DetailObject", "spark5")
        SetData("Particle.Name", "Part_ElectricSpark")
        SendMessage("Particle.NewEmitter")
	spark5 = GetData("Particle.Handle")
	SendIntMessage("Particle.DeleteEmitter",spark1)
	SendIntMessage("Particle.DeleteEmitter",spark2)
	SendIntMessage("Particle.DeleteEmitter",spark3)
	SendIntMessage("Particle.DeleteEmitter",spark4)
	SendIntMessage("Particle.DeleteEmitter",spark6)
	SendIntMessage("Particle.DeleteEmitter",spark7)
	SendIntMessage("Particle.DeleteEmitter",spark8)
    elseif MyOtherRandomNumber == 6 then
        SetData("Particle.DetailObject", "spark6")
        SetData("Particle.Name", "Part_ElectricSpark")
        SendMessage("Particle.NewEmitter")
	spark6 = GetData("Particle.Handle")
	SendIntMessage("Particle.DeleteEmitter",spark1)
	SendIntMessage("Particle.DeleteEmitter",spark2)
	SendIntMessage("Particle.DeleteEmitter",spark3)
	SendIntMessage("Particle.DeleteEmitter",spark4)
	SendIntMessage("Particle.DeleteEmitter",spark5)
	SendIntMessage("Particle.DeleteEmitter",spark7)
	SendIntMessage("Particle.DeleteEmitter",spark8)
    elseif MyOtherRandomNumber == 7 then
        SetData("Particle.DetailObject", "spark7")
        SetData("Particle.Name", "Part_ElectricSpark")
        SendMessage("Particle.NewEmitter")
	spark7 = GetData("Particle.Handle")
	SendIntMessage("Particle.DeleteEmitter",spark1)
	SendIntMessage("Particle.DeleteEmitter",spark2)
	SendIntMessage("Particle.DeleteEmitter",spark3)
	SendIntMessage("Particle.DeleteEmitter",spark4)
	SendIntMessage("Particle.DeleteEmitter",spark5)
	SendIntMessage("Particle.DeleteEmitter",spark6)
	SendIntMessage("Particle.DeleteEmitter",spark8)
    elseif MyOtherRandomNumber == 8 then
        SetData("Particle.DetailObject", "spark8")
        SetData("Particle.Name", "Part_ElectricSpark")
        SendMessage("Particle.NewEmitter")
	spark8 = GetData("Particle.Handle")
	SendIntMessage("Particle.DeleteEmitter",spark1)
	SendIntMessage("Particle.DeleteEmitter",spark2)
	SendIntMessage("Particle.DeleteEmitter",spark3)
	SendIntMessage("Particle.DeleteEmitter",spark4)
	SendIntMessage("Particle.DeleteEmitter",spark5)
	SendIntMessage("Particle.DeleteEmitter",spark6)
	SendIntMessage("Particle.DeleteEmitter",spark7)
    end

    StartTimer("Sparks", 2500)
end

function MakeOtherRandomNumber()
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyOtherRandomNumber = math.mod(RandomNumber, 8) + 1
end

function TurnStarted()
    Team = GetData("CurrentTeamIndex")
    CurrentWorm = GetData("ActiveWormIndex")
    if Team == 1 then
        AddStrike = AddStrike + 1
        if AddStrike == 10 then
            lock, inventory = EditContainer("Inventory.Team01") 
            inventory.Airstrike = 1
            AddStrike = 0
            CloseContainer(lock)
        end
        MakeRandomNumber()
        ThreatText()
    end
end

function TurnEnded()

    if AddStrike == 9 and GameOver == false then
        SetData("CommentaryPanel.Comment", "Miss.Helter.game14")
        SendMessage("CommentaryPanel.ScriptText")
    end
    
    -- if the game is not over (dependant on Worm_Died() )
    -- if its over we are waiting on time end of game cameras/timers to kick in
    if GameOver == false then
        StartTurn()
    end
end

function MakeRandomNumber()
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 3) + 1
end

function ThreatText()
    if AddStrike >= 5 and MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Helter.game7")
        SendMessage("CommentaryPanel.ScriptText")
    elseif AddStrike >= 5 and MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Helter.game8")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function Worm_Died()
    deadworm = GetData("DeadWorm.Id")
    if deadworm == 0 then
        GameOver = true
        if Switch == 0 then
            if HatWormMove == 0 then
                StartTimer("EFMVfailed", 2000)
            else
                StartTimer("noEFMVfailed", 2000)
            end
            Switch = 1
        end
    elseif deadworm == 1 then
        if Switch == 0 then
            GameOver = true
            SetData("CommentaryPanel.Comment", "Miss.Helter.game13")
            SendMessage("CommentaryPanel.ScriptText")
            endmissionfail()
            Switch = 1
        end
    elseif deadworm == 2 or deadworm == 3 or deadworm == 4 then
        deadcpu = deadcpu + 1
        if deadcpu == 3 then
            GameOver = true
            SendStringMessage("Camera.Disable", "Track")       
            if HatWormMove == 0 then
                StartTimer("EFMVsuccess", 1000)
            else
                StartTimer("noEFMVsuccess", 1000)
            end
        end
    end
end

function EFMVsuccess()
    SendMessage("EFMV.Start")
    SendMessage("Commentary.NoDefault")
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game9")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "OtherHatCam")
    SetData("Camera.Path.Knots.LookAt", "OtherHatLook")
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Happy3")
    SendIntMessage("Worm.QueueAnim", 1)
    StartTimer("EFMVsuccess2", 3700)
end

function EFMVsuccess2()
    SetData("Worm.ScriptAnim", "Smile")
    SendIntMessage("Worm.QueueAnim", 1)
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game10")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "ZoomToCam,ZoomToCam2")
    SetData("Camera.Path.Knots.LookAt", "ZoomToLook")
    SetData("Camera.Path.Steps.Position",20)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("endmissionsuccess", 1000)
end

function noEFMVsuccess()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game9")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game10")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("endmissionsuccess", 1000)
end

function EFMVfailed()
    SendMessage("EFMV.Start")
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game11")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game12")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "OtherHatCam")
    SetData("Camera.Path.Knots.LookAt", "OtherHatLook")
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Scared1")
    SendIntMessage("Worm.QueueAnim", 1)
    SetData("Worm.ScriptAnim", "Pray")
    SendIntMessage("Worm.QueueAnim", 1)
    StartTimer("endmissionfail", 1500)
end

function noEFMVfailed()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game11")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Helter.game12")
    SendMessage("CommentaryPanel.ScriptText")
    StartTimer("endmissionfail", 1500)
end

function endmissionsuccess()

    Result()
    
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Helter")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Helter")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","Bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","Silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","Gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function endmissionfail()
    SendMessage("GameLogic.Mission.Failure")
end

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.IsAIControlled = true
    team.Active = true
    team.Name = "Tough Guys"
    team.FlagGfxName = "97"
    team.TeamColour = 1
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.Energy = 125
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.SfxBankName = GM.T1_Speech
   -- worm.SfxBankName = "Pirate"
    worm.Spawn = "HumanWorm1"
    CloseContainer(lock)

    --this is a hat worm
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01")
    worm.IsHatWearer = true
    worm.IsAllowedToTakeTurn = false
    worm.Name = "Tom Courtney"
    worm.Spawn = "HatWorm1"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02")
    worm.Energy = 65 
    worm.Name = "Ira"
    worm.TeamIndex = 1
    worm.SfxBankName = "Classic"
    worm.Spawn = "CPUWorm1"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU1", "AIParams.Worm02")
    lock, worm = EditContainer("AIParams.Worm02") 
    worm.ForbidShotsWhenMightAffectAITrigger = 1
    CloseContainer(lock) 

    CopyContainer("Worm.Data02", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03")
    worm.Energy = 65  
    worm.Name = "Georgia"
    worm.Spawn = "CPUWorm2"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU2", "AIParams.Worm03")

    CopyContainer("Worm.Data03", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 65  
    worm.Name = "James"
    worm.Spawn = "CPUWorm3"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm03", "AIParams.Worm04")
    
    --CopyContainer("Worm.Data04", "Worm.Data05")
    --lock, worm = EditContainer("Worm.Data05")
    --worm.Energy = 80  
    --worm.Name = "CPUWorm4"
    --worm.Spawn = "CPUWorm4"
    --CloseContainer(lock)
    --CopyContainer("AIParams.Worm02", "AIParams.Worm05")
    
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Parachute = 3
    inventory.SkipGo = -1
    --inventory.Surrender = -1
    CloseContainer(lock)
    
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.FirePunch = -1
    inventory.BaseballBat = -1
    inventory.Shotgun = -1
    inventory.ClusterGrenade = -1
    inventory.Grenade = 3
    inventory.Bazooka = 2
    --inventory.Uzi = -1 --maybe add this back in when uzi is powered down a touch
    inventory.SkipGo = -1
    CloseContainer(lock)
end


