
-- Jetpack Challenge Deux

function Initialise()
    SendMessage("Commentary.NoDefault")
    SendStringMessage("Camera.Disable", "Track")
    
    NewCrate = 1
    camdone = 0
    Switch = 0
    DeleteWeapon = 0
    ExtraFuel = 10000
    EndGame = 0
    Time = 7000
    
    RoundTimeRemaining = 0
    SetData("RoundTime", RoundTimeRemaining) 
    warn = StartTimer("warning", RoundTimeRemaining -10000)
    
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("TurnTime", 0) -- no game timer
    SetData("RoundTime", 60000)
    SendMessage("HUD.HideTurnTime")
    SetData("Jetpack.InitFuel", 10000)
    SendMessage("EFMV.Start") 
    CameraFly = 0
    SendMessage("GameLogic.PlaceObjects")
    SetData("Land.Indestructable", 1)
    
    MakeNewCrate()
    
    SetData("Crate.Spawn", "Bad1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Scale", 4)
    SetData("Crate.Contents", "kWeaponProd")
    SetData("Crate.Index", 201)
    --SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    SetData("Crate.Spawn", "Bad2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.Scale", 4)
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponProd")
    SetData("Crate.Index", 202)
   -- SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    SetData("Crate.Spawn", "Bad3")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.Scale", 4)
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponProd")
    SetData("Crate.Index", 203)
  --  SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")

    SetupWormsAndTeams()
    SetupInventories()
    Camera()
end

function Weapon_PoweringUpStart()
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
end

function Crate_Collected()
    RoundTimeRemaining = GetData("RoundTimeRemaining")

    if Switch == 0 then
        if RoundTimeRemaining > 5000 then
            CrateNumber = GetData("Crate.Index")
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
            if CrateNumber == 201 then
                SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
                SendMessage("CommentaryPanel.ScriptText") 
                SetData("RoundTimeRemaining", RoundTimeRemaining-5000)
                DeleteWeapon = 1
            elseif CrateNumber == 202 then
                SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
                SendMessage("CommentaryPanel.ScriptText")
                SetData("RoundTimeRemaining", RoundTimeRemaining-5000)
                DeleteWeapon = 1
            elseif CrateNumber == 203 then
                SetData("CommentaryPanel.Comment", "Miss.Crop.fail")
                SendMessage("CommentaryPanel.ScriptText") 
                SetData("RoundTimeRemaining", RoundTimeRemaining-5000)
                DeleteWeapon = 1
            else
                SetData("CommentaryPanel.Comment", "missrum.game5")
                SendMessage("CommentaryPanel.ScriptText") 
                MakeNewCrate()
            end
        end
    end
    
    if DeleteWeapon == 1 then
        lock, inventory = EditContainer("Inventory.Team00") 
        inventory.Prod = 0    
        CloseContainer(lock) -- must close the container ASAP
        DeleteWeapon = 0
    end
end


function Timer_GameTimedOut()
    Switch = 1
    DeleteWeapon = 1
    
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")

    SetData("CommentaryPanel.Comment", "Chall.Generic.Win3")
    SendMessage("CommentaryPanel.ScriptText")

    Result()
end

function TurnEnded()
    Switch = 1
    DeleteWeapon = 1
end

function SelectRandomWind()
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.1*MaxWind)

   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", 3.3) 
end


function Worm_Died()
    deadWorm = GetData("DeadWorm.Id")
    
    if deadWorm == 0 then
        Switch = 1
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText") 
    end
    
    DeleteWeapon = 1
    Result()
end

function Crate_Destroyed()
    if Switch == 0 then
        MakeNewCrate()
    end
end

function MakeNewCrate()
    if EndGame == 0 then
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining + Time)
    end

    if NewCrate == 1 then
	SetData("Crate.Spawn", "crate1")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 1)
        SetData("Crate.Scale", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 2 then
	SetData("Crate.Spawn", "crate2")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 2)
        SetData("Crate.Scale", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 3 then
	SetData("Crate.Spawn", "crate3")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 3)
        SetData("Crate.Scale", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 4 then
	SetData("Crate.Spawn", "crate4")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 4)
        SetData("Crate.Scale", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 5 then
	SetData("Crate.Spawn", "crate5")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 5)
        SetData("Crate.Scale", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 6 then
	SetData("Crate.Spawn", "crate6")
        SetData("Crate.Type", "Target")
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 7 then
	SetData("Crate.Spawn", "crate7")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 7)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
     elseif NewCrate == 8 then
	SetData("Crate.Spawn", "crate8")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 8)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 9 then
	SetData("Crate.Spawn", "crate9")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 9)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 10 then
	SetData("Crate.Spawn", "crate10")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 11 then
	SetData("Crate.Spawn", "crate11")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 11)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 12 then
	SetData("Crate.Spawn", "crate12")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 12)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 13 then
	SetData("Crate.Spawn", "crate13")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 13)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 14 then
	SetData("Crate.Spawn", "crate14")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 14)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 15 then
	SetData("Crate.Spawn", "crate15")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 15)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)

        NewCrate = 0
        
        if Time > 1000 then
            Time = Time - 1000
        end
        
        if ExtraFuel == 10000 then
            ExtraFuel = 7500
        elseif ExtraFuel == 7500 then
            ExtraFuel = 5000
        end
    end
    
    NewCrate = NewCrate + 1
end

function Camera()
    CameraFly = 1
    SetData("CommentaryPanel.Comment", "Chall.Jetpack2.Intro1")
    SendMessage("CommentaryPanel.ScriptText") 
    FunLoop = StartTimer("ExtraText", 3500)
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2")
    SetData("Camera.Path.Knots.LookAt", "Look1")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",800)  
    SetData("Camera.Path.Steps.LookAt",850)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera2", 8000)
end

function ExtraText()
    SetData("CommentaryPanel.Comment", "Chall.Jetpack2.Intro2")
    SendMessage("CommentaryPanel.ScriptText") 
end

function Camera2()
    SetData("Camera.Path.Knots.Position", "Pos4,Pos5")
    SetData("Camera.Path.Knots.LookAt", "Look2,Look3")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",500)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera3", 5000)
    FunLoop = StartTimer("Whiteout", 4700)
end

function Camera3()
    SetData("CommentaryPanel.Comment", "Chall.Jetpack2.Intro3")
    SendMessage("CommentaryPanel.ScriptText") 
    SetData("Camera.Path.Knots.Position", "Pos6,Pos7")
    SetData("Camera.Path.Knots.LookAt", "Look4,Look5")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",500)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera4", 5000)
    FunLoop = StartTimer("Whiteout", 4700)
end

function Camera4()
    SetData("Camera.Path.Knots.Position", "PosT,PosS")
    SetData("Camera.Path.Knots.LookAt", "LookT,LookS")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",350)  
    SetData("Camera.Path.Steps.LookAt",320)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("endy", 3500)
end

function Whiteout()
    SetData("Particle.DetailObject", "white1")
    SetData("Particle.Name", "ParticleWhiteout")
    
    SendMessage("Particle.NewEmitter")
    id2 = GetData("Particle.Handle")
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
        CancelTimer(FunLoop)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        endy()
    end
end

function endy()
    camdone = 1
    StartFirstTurn()
    SendMessage("EFMV.End")               
end

function Result()
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText") 

    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")
     
    if timetook > bronzetime then
        Movie = 1
        if timetook > silvertime then
            Movie = 2
            if timetook > goldtime then
                Movie = 3
            end
        end
    end
    
    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Challenge.Result")
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.Name = GM.T1_Name
    team.TeamColour = 0
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Energy = 1
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "spawn1"
    CloseContainer(lock) 
 
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Jetpack = 1
    CloseContainer(lock)

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
end