
-- Jetpack Challenge Three

function Initialise()
    SendMessage("Commentary.NoDefault")
    FunLoopRunning = 0
    CumLoopRunning = 0
    SendStringMessage("Camera.Disable", "Track")
    
    NewCrate = 1
    camdone = 0
    Switch = 0
    MyResult = 0
    Time = 8000
    ExtraFuel = 10000
    EndGame = 0
    
    RoundTimeRemaining = 0
    SetData("RoundTime", RoundTimeRemaining) 
    warn = StartTimer("warning", RoundTimeRemaining -10000)
    
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("RoundTime", 60000) 
    SetData("TurnTime", 0) 
    SendMessage("HUD.HideTurnTime")
    SetData("Jetpack.InitFuel", 20000)
    SendMessage("EFMV.Start") 
   
    SendMessage("GameLogic.PlaceObjects")
    SetData("Land.Indestructable", 1)
    
    SetData("Crate.Spawn", "JetpackSpawn")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityJetpack")
    SetData("Crate.Index", 666)
    SetData("Crate.Scale", 1)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    
    SendMessage("GameLogic.RoundTime.Pause")
    SendMessage("GameLogic.TurnTime.Pause")
    
    SetupWormsAndTeams()
    SetupInventories()
    Camera()
end

function Camera()
    CameraFly = 1

    CamFun = StartTimer("ExtraText", 5500)
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2,Pos3,Pos4,Pos5,Pos6,Pos7")
    SetData("Camera.Path.Knots.LookAt", "Look1,Look1b,Look2,Look2a,Look3,Look3a,Look4,Look4a,Look5,Look6")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Steps.LookAt",400)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Whiteout", 36250)
    CamLoop2 = StartTimer("Camera2", 36500)
    CumLoopRunning = 1
end

function ExtraText()
    StartTimer("Extra2", 10000)
end

function Extra2()
    StartTimer("Extra3", 10000)
end

function Extra3()
end

function Camera2()
    SetData("CommentaryPanel.Comment", "Chall.Jetpack3.Intro5")
    SendMessage("CommentaryPanel.ScriptText") 
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Shocked1")
    SetData("Worm.ScriptAnim", "Horror")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Camera.Path.Knots.Position", "WormPos")
    SetData("Camera.Path.Knots.LookAt", "WormLook")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Steps.LookAt",400)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
   CamLoop = StartTimer("Camera3", 1800)
end

function Camera3()
    SetData("CommentaryPanel.Comment", "Chall.Jetpack3.Intro6")
    SendMessage("CommentaryPanel.ScriptText") 
    SetData("Camera.Path.Knots.Position", "Pos8")
    SetData("Camera.Path.Knots.LookAt", "Look7,Look9,Look10")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Steps.LookAt",400)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera4", 7750)
    FunLoop = StartTimer("Whiteout", 7500)
    FunLoopRunning = 1
end

function Camera4()
    SetData("CommentaryPanel.Comment", "Chall.Jetpack3.Intro7")
    SendMessage("CommentaryPanel.ScriptText") 
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Shocked1")
    SetData("Worm.ScriptAnim", "Horror")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Camera.Path.Knots.Position", "WormPos")
    SetData("Camera.Path.Knots.LookAt", "WormLook")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",550)  
    SetData("Camera.Path.Steps.LookAt",400)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Camera5", 2000)
end

function Camera5()
    SetData("CommentaryPanel.Comment", "Chall.Jetpack3.Intro8")
    SetData("CommentaryPanel.Delay",3500)
    SendMessage("CommentaryPanel.TimedText")
    SetData("CommentaryPanel.Comment", "Chall.Jetpack3.Intro9")
    SetData("CommentaryPanel.Delay",3500)
    SendMessage("CommentaryPanel.TimedText")
    SetData("Camera.Path.Knots.Position", "Pos9,Pos10")
    SetData("Camera.Path.Knots.LookAt", "Look11")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",400)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("endy", 3000)
end

function Whiteout()
    FunLoopRunning = 0

    SetData("Particle.DetailObject", "white1")
    SetData("Particle.Name", "ParticleWhiteout")
    
    SendMessage("Particle.NewEmitter")
    id2 = GetData("Particle.Handle")
end

function Camera_Path_Reached_Knot()
    knot = GetData("Camera.Path.Knot")

    if knot == "Pos2" then 
        SetData("CommentaryPanel.Comment", "Chall.Jetpack3.Intro1")
        SetData("CommentaryPanel.Delay",2500)
        SendMessage("CommentaryPanel.TimedText")
    end 
        
    if knot == "Pos3" then 
        SetData("CommentaryPanel.Comment", "Chall.Jetpack3.Intro2")
        SetData("CommentaryPanel.Delay",3000)
        SendMessage("CommentaryPanel.TimedText")
    end
    
    if knot == "Pos4" then 
        SetData("CommentaryPanel.Comment", "Chall.Jetpack3.Intro2b")
        SetData("CommentaryPanel.Delay",3000)
        SendMessage("CommentaryPanel.TimedText")
        SetData("CommentaryPanel.Comment", "Chall.Jetpack3.Intro2c")
        SetData("CommentaryPanel.Delay",3000)
        SendMessage("CommentaryPanel.TimedText")
    end
  
    if knot == "Pos6" then 
        SetData("CommentaryPanel.Comment", "Chall.Jetpack3.Intro3")
        SetData("CommentaryPanel.Delay",3000)
        SendMessage("CommentaryPanel.TimedText")
        SetData("CommentaryPanel.Comment", "Chall.Jetpack3.Intro4")
        SetData("CommentaryPanel.Delay",3000)
        SendMessage("CommentaryPanel.TimedText")
    end  
end

function Camera_Path_Stopped()
SendMessage("Commentary.Clear")
    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
        CancelTimer(CamLoop2)
        
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        
        if FunLoopRunning == 1 then
            CancelTimer(FunLoop)

        end
        
        if CumLoopRunning == 1 then
            CancelTimer(CamFun)
        end
        
        SendMessage("EFMV.End")
        StartFirstTurn()
    end
end

function endy()
    camdone =  1
    StartFirstTurn()
    SendMessage("EFMV.End")               
end
-- cameras end here

function Timer_GameTimedOut()
    Switch = 1
    MyResult = 1
    EndGame = 1

    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win3")
    SendMessage("CommentaryPanel.ScriptText")
 
    ToResult()
end

function Worm_Died()
    deadWorm = GetData("DeadWorm.Id")
    if deadWorm == 0 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText") 
    end
end

function Weapon_PoweringUpStart()
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
end

function TurnEnded()
    ToResult()
end

function ToResult()
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText") 

    if MyResult == 1 then
        Result()
    else
        Result()
    end
end

function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.3*MaxWind)
   SetData("Wind.Direction", 4.3) 
end

function Crate_Collected()
    CrateIndex = GetData("Crate.Index")
    if CrateIndex == 666 then
        SendMessage("GameLogic.RoundTime.Resume")
        SendMessage("GameLogic.TurnTime.Resume")
        MakeNewCrate()
    elseif CrateIndex == 10 then
        if Switch == 0 then
            SetData("CommentaryPanel.Comment", "missrum.game5")
            SendMessage("CommentaryPanel.ScriptText") 
            MakeNewCrate()
        end
    end
end

function Crate_Destroyed()
    if Switch == 0 then
        MakeNewCrate()
    end
end

function timelow()
    --CancelTimer(warn)
    --RoundTimeRemaining = GetData("RoundTimeRemaining")
    --warn = StartTimer("warning", RoundTimeRemaining -10000)
end

function MakeNewCrate()
    if EndGame == 0 and CrateIndex == 10 then
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining + Time)
    end

    if NewCrate == 1 then
	SetData("Crate.Spawn", "crate1")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 2 then
	SetData("Crate.Spawn", "crate2")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 3 then
	SetData("Crate.Spawn", "crate3")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 4 then
	SetData("Crate.Spawn", "crate4")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 5 then
	SetData("Crate.Spawn", "crate5")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 3)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 6 then
	SetData("Crate.Spawn", "crate6")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 7 then
	SetData("Crate.Spawn", "crate7")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 8 then
	SetData("Crate.Spawn", "crate8")
        SetData("Crate.Type", "Target")
        SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 9 then
	SetData("Crate.Spawn", "crate9")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 10 then
	SetData("Crate.Spawn", "crate10")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 11 then
	SetData("Crate.Spawn", "crate11")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 12 then
	SetData("Crate.Spawn", "crate12")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 13 then
	SetData("Crate.Spawn", "crate13")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 14 then
	SetData("Crate.Spawn", "crate14")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
    elseif NewCrate == 15 then
	SetData("Crate.Spawn", "crate15")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 2.5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        Fuel = GetData("Jetpack.Fuel")
        SetData("Jetpack.Fuel", Fuel + ExtraFuel)
        NewCrate = 0
        
        if Time > 1000 then
            Time = Time - 1000
        end
        
        if ExtraFuel == 10000 then
            ExtraFuel = 7500
        elseif ExtraFuel == 7500 then
            ExtraFuel = 5000
        end
    end

    NewCrate = NewCrate + 1
end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////

function Result()
    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")
     
    if timetook > bronzetime then
        Movie = 1
        if timetook > silvertime then
            Movie = 2
            if timetook > goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.W.EQuake")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.W.EQuake")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Challenge.Result")
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock) -- must close the container ASAP

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 1
    worm.Spawn = "spawn1"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
 
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Parachute = -1
    CloseContainer(lock)
end
