
-- Mission Movie Mayhem

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 5
    goldtime = (60 * 1000) * 4.5

    SetData("TurnTime", 30000)
    SetData("HotSeatTime", 3000)
    SetData("RoundTime", 600000)
    
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SendMessage("GameLogic.PlaceObjects")
    
    SetData("Particle.DetailObject", "Part_ElectricSpark1")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    Spark1 = GetData("Particle.Handle")
    
    SetData("Particle.DetailObject", "Part_ElectricSpark2")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    Spark2 = GetData("Particle.Handle")

    SetData("Particle.DetailObject", "Part_ElectricSpark3")
    SetData("Particle.Name", "Part_ElectricSpark")
    SendMessage("Particle.NewEmitter")
    Spark3 = GetData("Particle.Handle")
    SetData("Camera.StartOfTurnCamera","Default")

    turn = 0
    Switch = 0
    
    camdone = 0
    SendMessage("EFMV.Start")
    SetupWormsAndTeams()
    SetupInventories()
    First()
end

function First()
    SetData("Camera.Path.Knots.Position", "FirstCam,FirstCam2")
    SetData("Camera.Path.Knots.LookAt", "FirstLook,FirstLook2")
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",400)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Second", 4000)
end

function Second()
    SetData("Camera.Path.Knots.Position", "SecondCam,SecondCam2")
    SetData("Camera.Path.Knots.LookAt", "SecondLook,SecondLook2")
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",400)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Third", 4000)
end

function Third()
    SetData("Camera.Path.Knots.Position", "ThirdCam,ThirdCam2")
    SetData("Camera.Path.Knots.LookAt", "ThirdLook")
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",400)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Fourth", 3000)
end

function Fourth()
    SetData("Camera.Path.Knots.Position", "FourthCam,FourthCam2")
    SetData("Camera.Path.Knots.LookAt", "FourthLook")
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",400)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera", 3000)
end

function camera()
    CameraFly = 1
    SetData("CommentaryPanel.Comment", "Miss.SpaceNEW.game1")
    SendMessage("CommentaryPanel.ScriptText")
    
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Idle_3_Tash")    
    SendIntMessage("Worm.QueueAnim", 1)
    
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Scared1")    
    SendIntMessage("Worm.QueueAnim", 2)
    
    SetData("Camera.Path.Knots.Position", "Pos1,Pos3")
    SetData("Camera.Path.Knots.LookAt", "Look1")
    SetData("Camera.Path.Steps.Position",400)  
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera2", 4000)
end

function camera2()
    SetData("CommentaryPanel.Comment", "Miss.MovieNEW.game2")
    SendMessage("CommentaryPanel.ScriptText")
    
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 0)
    
    SetData("Camera.Path.Knots.Position", "Pos4,Pos5")
    SetData("Camera.Path.Knots.LookAt", "Look2")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",400)  
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera3", 2000)
end

function camera3()
    SetData("CommentaryPanel.Comment", "Miss.MovieNEW.game3")
    SendMessage("CommentaryPanel.ScriptText")
    SendIntMessage("Worm.ResetAnim", 7)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 7)
    SetData("Camera.Path.Knots.Position", "Pos6,Pos7")
    SetData("Camera.Path.Knots.LookAt", "Look3")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera4", 2500)
end

function camera4()
    SetData("CommentaryPanel.Comment", "Miss.MovieNEW.game4")
    SendMessage("CommentaryPanel.ScriptText")
    
    SendIntMessage("Worm.ResetAnim", 5)
    SetData("Worm.ScriptAnim", "Happy2")
    SendIntMessage("Worm.QueueAnim", 5)
    
    SetData("Camera.Path.Knots.Position", "Look4Cam")
    SetData("Camera.Path.Knots.LookAt", "Look4")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SendMessage("Camera.Path.Start")
    
    StartTimer("startt", 5000)
end

function CheckOneTeamVictory()
    TeamCount = GetData("TeamCount")
    -- PC: use SurvivingTeamIndex to get the last team with any worms alive on.
    WhichTeam = GetData("SurvivingTeamIndex")
    if TeamCount == 0 then
        if Switch == 0 then
        -- all the teams have just snuffed it - mission is over:
            SendMessage("Commentary.NoDefault")
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            SendMessage("Commentary.NoDefault")
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 0 then
        Switch = 1
        Awardss()
    else
        StartTurn()
    end
end

function Awardss()
    SendMessage("Commentary.Clear")
    SuccessMessages()
    Result()
    
end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()

    SetData("Camera.Path.IgnoreInput", 1)
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
        Key,Lock = EditContainer("L.C.Shotgun3")
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName3","L.C.Shotgun3")
        end
        CloseContainer(Key)
 
        if timetook < silvertime then
            Movie = 2
            Key,Lock = EditContainer("L.P.Tapper")
            if Lock.Locked == true then
                Lock.Locked = false
                SetData("MCa.LockedName2","L.P.Tapper")
            end     
            CloseContainer(Key)
        
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Landing")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Landing")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function SelectRandomWind()
    -- First the speed
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    MaxWind = GetData("Wind.MaxSpeed")
    -- The line below controls the strength in this case it will be no more than 3
    SetData("Wind.Speed", RandomNumber*MaxWind * 3 /10)

    -- Now a direction
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    Direction = RandomNumber * 2 * 3.14
    SetData("Wind.Direction", Direction)   
end


function SuccessMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function FailureMessages()
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function startt()
    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    SendMessage("EFMV.End")
    camdone =  1
    StartFirstTurn()
end

function Camera_Path_Stopped()
    if camdone == 0 then
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        CancelTimer(CamLoop)
        camdone =  1
	startt()
    end
end

function TurnEnded()

    CheckOneTeamVictory()
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end

end


function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
   
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Film Crew"
    team.TeamColour = 1
    team.FlagGfxName = "76"
    team.IsAIControlled = true
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 75
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "spawn1"
    CloseContainer(lock) 
    
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn2"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GM.T1_W3_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn3"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = GM.T1_W4_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn4"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    CopyContainer("AIParams.CPU3", "AIParams.Worm04")
    worm.Energy = 100 
    worm.SfxBankName = "Cyberworms"
    worm.Name = "Gaffer"
    worm.TeamIndex = 1
    worm.Spawn = "spawn5"
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    CopyContainer("AIParams.Worm04", "AIParams.Worm05")
    worm.Energy = 100  
    worm.SfxBankName = "Cyberworms"
    worm.Name = "Key Grip"
    worm.Spawn = "spawn6"
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    CopyContainer("AIParams.Worm04", "AIParams.Worm06")
    worm.Energy = 100  
    worm.SfxBankName = "Cyberworms"
    worm.Name = "Boom Boy"
    worm.Spawn = "spawn7"
    CloseContainer(lock)

    CopyContainer("Worm.Data04", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    CopyContainer("AIParams.Worm04", "AIParams.Worm07")
    worm.Energy = 100  
    worm.SfxBankName = "Cyberworms"
    worm.Name = "Cameraman"
    worm.Spawn = "spawn8"
    CloseContainer(lock)
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade = 5
    inventory.Landmine = 3
    inventory.HomingMissile = 1
    inventory.Sheep = 1
    inventory.Parachute = 3
    inventory.Teleport = 2
    inventory.Jetpack = 2
    inventory.SkipGo = -1
    inventory.Shotgun = 2
    inventory.NinjaRope = 1
    inventory.FirePunch = 2
    inventory.Prod = -1
    CloseContainer(lock)
    
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.Shotgun = 3
    inventory.HomingMissile = 1
    inventory.Parachute = 3
    inventory.Teleport = 1
    inventory.Jetpack = 2
    inventory.SkipGo = -1
    inventory.FirePunch = -1
    inventory.BaseballBat = 1
    CloseContainer(lock)
    
    lock, delays = EditContainer("Inventory.WeaponDelays") 
    delays.Landmine = 2
    delays.Shotgun = 3
    delays.Bazooka = 4
    delays.ClusterGrenade = 4
    delays.Sheep = 8
    delays.HomingMissile = 9
    CloseContainer(lock)
end

