
-- Mission Jetpack challenge

function Initialise()

bronzetime = (60 * 1000) * 999
silvertime = (60 * 1000) * 3
goldtime = (60 * 1000) * 2

id1 = 0
id1b = 0
id2b = 0
id3b = 0
id4b = 0
Switch = 0
AnotherSwitch = 0

cdestroy = 0
CrateDead = 0
gotone = 0
camdone = 0

--////////////////////////////////////////////////////////
--// Particles                                          //
--////////////////////////////////////////////////////////

    SetData("Particle.DetailObject", "ripple1")
    SetData("Particle.Name", "Part_IslandRipples")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "ripple3")
    SetData("Particle.Name", "Part_IslandRipples")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "ripple4")
    SetData("Particle.Name", "Part_IslandRipples")
    SendMessage("Particle.NewEmitter")
    
   SendMessage("GameLogic.PlaceObjects")

-- Sets up mines and turn time
   SetData("Mine.DudProbabilty", 0.0)
   SetData("Mine.MinFuse", 2000)
   SetData("Mine.MaxFuse", 3000)
   SetData("HotSeatTime", 0) -- no hotseat time
   SetData("RoundTime", 240000) -- no Game timer
   SetData("TurnTime", 0) -- no game timer
    SendMessage("HUD.HideTurnTime")
   SetData("Jetpack.InitFuel", 50000)
   SendStringMessage("Camera.Disable", "Track")
   
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
   

   SendMessage("EFMV.Start")


    MakeNewCrateq()
    SetupWormsAndTeams()
    SetupInventories()
    --StartFirstTurn()
    camera()
    spout()
end


-- stops weapons from ending turns
function Weapon_PoweringUpStart()
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
end

function spout()
-- if the random number is 1 then this particle appears
    if MyRandomNumber == 1 then
	SetData("Particle.DetailObject", "spout1")
	SetData("Particle.Name", "Part_Geyser")
	SendMessage("Particle.NewEmitter")
        --below sets this particle emitter to have id1
	id1 = GetData("Particle.Handle")
    end
-- waits 6 secs before picking another particle (in function spoutend)	
    StartTimer("spoutend", 6000)		
end	

function spoutend()
    SendIntMessage("Particle.DeleteEmitter",id1)
    -- makes up a random number between 1 and 3
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 3)

-- executes the spout function
spout()

end

-- /////////////////////////////////////////////////////////////

function TurnEnded()

    SendMessage("WormManager.GetActiveTeamCount")
    TeamCount = GetData("TeamCount")
    
    if TeamCount == 0 then
        SendMessage("Commentary.Clear")
        Switch = 1
      -- all the worms have just snuffed it
        FailureMessages()
        StartTimer("Failed", 250)
    else
        -- still at least some worms left
        StartTurn()
    end
end

function Failed()
        SendMessage("GameLogic.Mission.Failure")
end

function Timer_GameTimedOut()

    RoundTimeRemaining = GetData("RoundTimeRemaining")

    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end

end


-- //////////////////////////////////////////////////////////////////

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = GM.T1_Name
   team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
   team.TeamColour = 0
   CloseContainer(lock) -- must close the container ASAP


   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
   worm.Energy = 100
   worm.Spawn = "spawn1"
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 
 

    -- Worm 1, Team 0
   lock, worm = EditContainer("Worm.Data01") 
   worm.Active = true
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
   worm.Energy = 100
    worm.Spawn = "spawn2"
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 
 

     -- Worm 2, Team 0 DUMMY
   lock, worm = EditContainer("Worm.Data02") 
   worm.Active = true
   worm.Name = "HELP"
   worm.Energy = 100
   worm.Spawn = "spawn3"
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false   
   worm.TeamIndex = 0   
   CloseContainer(lock) 
  
   SendMessage("WormManager.Reinitialise")

end

-- //////////////////////////////////////////////////////////////////

function SetupInventories()
    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Jetpack = -1    
    
    CloseContainer(lock) -- must close the container ASAP

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")

end

-- ///////////////////////////////////////////////////////////////////

-- When MakeNewCrate is called It runs through this below and adds 1 each time so it knows which crate it is on
function MakeNewCrateq()


	SetData("Crate.Spawn", "crate1")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.Pushable", 0)
	SetData("Crate.Index", 1)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "crate2")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.Pushable", 0)
	SetData("Crate.Index", 2)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "crate3")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.Pushable", 0)
	SetData("Crate.Index", 3)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "crate4")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.Pushable", 0)
	SetData("Crate.Index", 4)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "crate5")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.Pushable", 0)
	SetData("Crate.Index", 5)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "crate6")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.Pushable", 0)
	SetData("Crate.Index", 6)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "crate7")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.Pushable", 0)
	SetData("Crate.Index", 7)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "crate8")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.Pushable", 0)
	SetData("Crate.Index", 8)
	SendMessage("GameLogic.CreateCrate")


	SetData("Crate.Spawn", "crate9")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.Pushable", 0)
	SetData("Crate.Index", 9)
	SendMessage("GameLogic.CreateCrate")

	SetData("Crate.Spawn", "crate10")
        SetData("Crate.Type", "Weapon")
        SetData("Crate.NumContents", 0)
        SetData("Crate.Contents", "kWeaponPetrolBomb")
        SetData("Crate.TeamDestructible", 10)
        SetData("Crate.Pushable", 0)
	SetData("Crate.Index", 10)
	SendMessage("GameLogic.CreateCrate")

end

-- //////////////////////////////////////////////////////////////////////


function Crate_Sunk()
    Crate_Destroyed()
end


function Crate_Destroyed()
    cdestroy = cdestroy + 1
        
    SetData("CommentaryPanel.Comment", "rum.lostone")
    SendMessage("CommentaryPanel.ScriptText")

   
    if cdestroy == 3 then
        if Switch == 0 then
            SendMessage("Commentary.Clear")
            SendMessage("Commentary.NoDefault")
            SetData("CommentaryPanel.Comment", "rum.toomany")
            SendMessage("CommentaryPanel.ScriptText")
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end 
end


--///////////////////////////////////////////////////////////////////////

function Crate_Collected()
       
        gotone = gotone + 1

        
        CrateNumber = GetData("Crate.Index")
         if CrateNumber == 1 then
        	SetData("Particle.DetailObject", "spray1")
                SetData("Particle.Name", "Part_Champagne")
                SendMessage("Particle.NewEmitter")
        
        elseif CrateNumber == 2 then
        	SetData("Particle.DetailObject", "spray2")
                SetData("Particle.Name", "Part_Champagne")
                SendMessage("Particle.NewEmitter")    

        elseif CrateNumber == 3 then
        	SetData("Particle.DetailObject", "spray3")
                SetData("Particle.Name", "Part_Champagne")
                SendMessage("Particle.NewEmitter")    

        elseif CrateNumber == 4 then
        	SetData("Particle.DetailObject", "spray4")
                SetData("Particle.Name", "Part_Champagne")
                SendMessage("Particle.NewEmitter")    

        elseif CrateNumber == 5 then
        	SetData("Particle.DetailObject", "spray5")
                SetData("Particle.Name", "Part_Champagne")
                SendMessage("Particle.NewEmitter")    

        elseif CrateNumber == 6 then
        	SetData("Particle.DetailObject", "spray6")
                SetData("Particle.Name", "Part_Champagne")
                SendMessage("Particle.NewEmitter")    

        elseif CrateNumber == 7 then
        	SetData("Particle.DetailObject", "spray7")
                SetData("Particle.Name", "Part_Champagne")
                SendMessage("Particle.NewEmitter")    

        elseif CrateNumber == 8 then
        	SetData("Particle.DetailObject", "spray8")
                SetData("Particle.Name", "Part_Champagne")
                SendMessage("Particle.NewEmitter")    

        elseif CrateNumber == 9 then
        	SetData("Particle.DetailObject", "spray9")
                SetData("Particle.Name", "Part_Champagne")
                SendMessage("Particle.NewEmitter")    

         elseif CrateNumber == 10 then
        	SetData("Particle.DetailObject", "spray10")
                SetData("Particle.Name", "Part_Champagne")
                SendMessage("Particle.NewEmitter")                 
    end
    
        SendMessage("Commentary.Clear")
    
       -- next two lines just display 'test' text so I know it's working
        SetData("CommentaryPanel.Comment", "missrum.game5")
        SendMessage("CommentaryPanel.ScriptText")
        
        SetData("Camera.Shake.Length",3000)
	SetData("Camera.Shake.Magnitude",0.10)
	SendMessage("Camera.ShakeStart")

	TimerID = StartTimer("EndShake", 3000)
        
        if gotone == 4 then
        SetData("CommentaryPanel.Comment", "missrum.game1")
        SendMessage("CommentaryPanel.ScriptText")
         
        elseif gotone == 6 then
        SetData("CommentaryPanel.Comment", "missrum.game3")
        SendMessage("CommentaryPanel.ScriptText")
        
        elseif gotone == 7 then
        SetData("CommentaryPanel.Comment", "missrum.game4")
        SendMessage("CommentaryPanel.ScriptText") 
        win()
        end
end


function win()

    SuccessMessages()
    Result()
    
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        Key,Lock = EditContainer("L.C.JP1") --unlock jetpack challenge 1
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName2","L.C.JP1")
        end
        CloseContainer(Key)
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.P.Beatbox") --unlock Beatbox Wormapedia entry
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.P.Beatbox")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function EndShake()
	SendMessage("Camera.ShakeEnd")
end



function camera()


    SetData("CommentaryPanel.Comment", "Miss.rum.extra1")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("CommentaryPanel.Comment", "Miss.rum.extra2")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("CommentaryPanel.Comment", "Miss.rum.extra3")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("CommentaryPanel.Comment", "Miss.rum.extra4")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("CommentaryPanel.Comment", "Miss.rum.extra5")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("CommentaryPanel.Comment", "Miss.rum.extra6")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("CommentaryPanel.Comment", "Miss.rum.extra7")
    SendMessage("CommentaryPanel.ScriptText")
    
    
    SetData("Camera.Path.Knots.Position", "cam1,cam3,cam4,cam5,cam6")
    SetData("Camera.Path.Knots.LookAt", "look1")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    StartTimer("deadworm", 990)
        
end



function Camera_Path_Reached_Knot()
   knot = GetData("Camera.Path.Knot")


    if knot == "cam5" then
    
   	SetData("Particle.DetailObject", "spout1")
	SetData("Particle.Name", "Part_Geyser")
	SendMessage("Particle.NewEmitter")
   
   end   
   
   if knot == "cam6" then
   
       SetData("Camera.Path.Knots.Position", "cam6,cam7,cam8,OrbitStart")
       SetData("Camera.Path.Knots.LookAt", "look1,look2,OrbitCentre")
       SendMessage("Camera.Path.Start")
   
   end
   
    if knot == "cam8" then
        SetData("CommentaryPanel.Comment", "Chall.Sheep3.Intro8")
        SendMessage("CommentaryPanel.ScriptText")
    end

   
   
    if knot == "OrbitStart" then
    
        SetData("Camera.Orbit.Speed",-0.2)
        camdone = 1
        startt()
       
    end

end


function deadworm()

    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Horror")
    SetData("Worm.ScriptAnim", "Scared1")    
    SetData("Worm.ScriptAnim", "Horror")
    SendIntMessage("Worm.QueueAnim", 2)

end


function startt()
    SendIntMessage("Worm.DieQuietly",2)
    SendMessage("EFMV.End") 
    StartFirstTurn()
   
end


function Camera_Path_Stopped()

    if camdone == 0 then
        camdone =  1
        SendMessage("Commentary.Clear")
        startt()
    end

end


--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end

function SuccessMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win5")
        SendMessage("CommentaryPanel.ScriptText")        
    end

end
