-- Tree Village Trouble: The player must kill the two enemy Worms.
-- * The player begins the mission with no weapons, everything they use must be collected in crates.
--   The player must make use of the parachutes they collect early on in order to negotiate the
--   landscape and get to where they need to get.
-- ! This mission needs text finalising in main file and translation.
-- ! This mission needs camera some sort of intro with camera fly-bys.
-- ! This mission needs CPU AI.  (after AI this mission needs playtesting to balance the enemy Worms
--   weapon set)
-- ! This mission needs detail objects adding to the landscape.
-- ! This mission needs particle emitters adding to the landscape.

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 6
    goldtime = (60 * 1000) * 5.5
    
    SendMessage("EFMV.Start")
    SetData("Camera.GameOverCamera", "")
    SetData("Camera.StartOfTurnCamera","Default")
    SendMessage("GameLogic.ResetTriggerParams")    
    SendMessage("Commentary.NoDefault")
    
    SetData("HUD.Clock.DisplayRoundTime", 0)
    
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
    SendMessage("GameLogic.PlaceObjects")

    SetData("TurnTime", 45000)
    SetData("HotSeatTime", 3000)
    SetData("RoundTime", 0)
   
    SetData("Crate.Spawn", "Parachute5")
    SetData("Crate.Type", "Utility")
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.NumContents", 2)
    SetData("Crate.Contents", "kUtilityGirder")
    SendMessage("GameLogic.CreateCrate")   
   
    SetData("Crate.Spawn", "Parachute5a")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.NumContents", 2)
    SetData("Crate.Contents", "kWeaponProd")
    SendMessage("GameLogic.CreateCrate")   
   
    SetData("Crate.Spawn", "NinjaRope")
    SetData("Crate.Type", "Utility")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kUtilityNinjaRope")
    SendMessage("GameLogic.CreateCrate") 
   
    SetData("Crate.Spawn", "FirePunch")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 10)
    SetData("Crate.Contents", "kWeaponFirePunch")
    SendMessage("GameLogic.CreateCrate")     
   
    SetData("Crate.Spawn", "FirePunch_2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 10)
    SetData("Crate.Contents", "kWeaponFirePunch")
    SendMessage("GameLogic.CreateCrate")      
   
    SetData("Crate.Spawn", "BaseballBat")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 10)
    SetData("Crate.Contents", "kWeaponBaseballBat")
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Trigger.Spawn", "Trig1")
    SetData("Trigger.Radius", 40)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SendMessage("GameLogic.CreateTrigger")
   
    SetData("Particle.DetailObject", "Leaf1")
    SetData("Particle.Name", "Part_Leafdrop")
    SendMessage("Particle.NewEmitter")
   
    SetData("Particle.DetailObject", "Leaf2")
    SetData("Particle.Name", "Part_Leafdrop")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Leaf3")
    SetData("Particle.Name", "Part_Leafdrop")
    SendMessage("Particle.NewEmitter")
   
    SetData("Particle.DetailObject", "Leaf4")
    SetData("Particle.Name", "Part_Leafdrop")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Fireflies1")
    SetData("Particle.Name", "Part_Firefly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Fireflies1a")
    SetData("Particle.Name", "Part_Firefly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Fireflies2")
    SetData("Particle.Name", "Part_Firefly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Fireflies2a")
    SetData("Particle.Name", "Part_Firefly")
    SendMessage("Particle.NewEmitter")
   
    SetData("Particle.DetailObject", "Fireflies3")
    SetData("Particle.Name", "Part_Firefly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Fireflies3a")
    SetData("Particle.Name", "Part_Firefly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Fireflies3b")
    SetData("Particle.Name", "Part_Firefly")
    SendMessage("Particle.NewEmitter")

    SetData("Particle.DetailObject", "Fireflies4")
    SetData("Particle.Name", "Part_Firefly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Fireflies4a")
    SetData("Particle.Name", "Part_Firefly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Fireflies5")
    SetData("Particle.Name", "Part_Firefly")
    SendMessage("Particle.NewEmitter")
    
    SetData("Particle.DetailObject", "Ropey2")
    SetData("Particle.Name", "Part_Swingrope")
    SendMessage("Particle.NewEmitter")
    
    SetData("Trigger.Spawn", "Protect1")
    SetData("Trigger.Radius", 40)
    SetData("Trigger.Index", 2)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
   
    SetData("Trigger.Spawn", "Protect2")
    SetData("Trigger.Radius", 40)
    SetData("Trigger.Index", 3)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
   
    CPUDiedSoFar = 0
    HumanDiedSoFar = 0
    HatDiedSoFar = 0
    AddStrikes = 0
    CameraFly = 1
    CratesCollected = 0
    VillagerDead = 0
    Switch = 0
   
    --SelectRandomWind()
    SetupWormsAndTeams()
    SetupInventories()
    CloseZoom()
end


function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   -- The line below controls the strength in this case it will be no more than 3
   SetData("Wind.Speed", RandomNumber*MaxWind * 0 /10)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", Direction)   
end










function Camera_Path_Stopped()
    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
        CameraFinished()
    end
end

function CloseZoom()
    SetData("Camera.Path.Knots.Position", "CloseZoomCam,CloseZoomCam2")
    SetData("Camera.Path.Knots.LookAt", "CloseZoomLook")
    SetData("Camera.Path.Steps.Position",450)
    SetData("Camera.Path.Steps.LookAt",450) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("NiceAngle", 4000)
end

function NiceAngle()
    SetData("Camera.Path.Knots.Position", "NiceAngleCam,NiceAngleCam2")
    SetData("Camera.Path.Knots.LookAt", "NiceAngleLook")
    SetData("Camera.Path.Steps.Position",450)
    SetData("Camera.Path.Steps.LookAt",450) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line1", 3000)
end

function Line1()
    -- "Horror" is good for the villager
    SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line1Cam")
    SetData("Camera.Path.Knots.LookAt", "Line1Look")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line2A", 3000)
end

function Line2A()
    SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game2")
    SendMessage("CommentaryPanel.ScriptText")

    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Smile3")
    SendIntMessage("Worm.QueueAnim", 1)
    
    SetData("Camera.Path.Knots.Position", "Line2ACam")
    SetData("Camera.Path.Knots.LookAt", "Line2ALook")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line2B", 1300)
end

function Line2B()
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Scowl2")
    SendIntMessage("Worm.QueueAnim", 3)
    -- Taunt2
    SetData("Camera.Path.Knots.Position", "Line2BCam")
    SetData("Camera.Path.Knots.LookAt", "Line2BLook")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line2C", 1300)
end

function Line2C()
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Taunt2")
    SendIntMessage("Worm.QueueAnim", 2)
    -- Scowl2
    SetData("Camera.Path.Knots.Position", "Line2CCam")
    SetData("Camera.Path.Knots.LookAt", "Line2CLook")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line3", 1300)
end

function Line3()
    SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line3Cam,Line3EndCam")
    SetData("Camera.Path.Knots.LookAt", "Line3Look,Line3EndLook")
    SetData("Camera.Path.Steps.Position",450)
    SetData("Camera.Path.Steps.LookAt",450) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line4", 4000)
end

function Line4()
    SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game4")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line4Cam,Line4EndCam")
    SetData("Camera.Path.Knots.LookAt", "Line4Look,Line4EndLook")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line5A", 2500)
end

function Line5A()
    SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game5")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line5ACam,Line5ACam2")
    SetData("Camera.Path.Knots.LookAt", "Line5ALook")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line5B", 2500)
end

function Line5B()
    SetData("Camera.Path.Knots.Position", "Line5BCam,Line5BCam2")
    SetData("Camera.Path.Knots.LookAt", "Line5BLook")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line6", 2500)
end

function Line6()
    SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game6")
    SendMessage("CommentaryPanel.ScriptText")
    
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Bored1")
    SendIntMessage("Worm.QueueAnim", 3)
    
    SetData("Camera.Path.Knots.Position", "Line6Cam,Line6EndCam")
    SetData("Camera.Path.Knots.LookAt", "Line6Look,Line6EndLook")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line7", 3000)
end

function Line7()
    SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game7")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Line7Cam")
    SetData("Camera.Path.Knots.LookAt", "Line7Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("CameraFinished", 4000)
    
    SendIntMessage("Worm.ResetAnim", 6)
    SetData("Worm.ScriptAnim", "Worried1")
    SendIntMessage("Worm.QueueAnim", 6)
end

function CameraFinished()
    SendMessage("EFMV.End")
    CameraFly = 0
    StartFirstTurn()
end
-- cameras end here
function TurnStarted()
    Team = GetData("CurrentTeamIndex")
    CurrentWorm = GetData("ActiveWormIndex")
    if Team == 1 then
        AddStrikes = AddStrikes + 1
        if AddStrikes == 5 then
            lock, inventory = EditContainer("Inventory.Team01")
            inventory.Airstrike = 1
            CloseContainer(lock)
            AddStrikes = 0
        end
    end
end

function Trigger_Collected()
    TriggerIndex = GetData("Trigger.Index")    
    if TriggerIndex == 1 then
        SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game8")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function Crate_Collected()
    CrateIndex = GetData("Crate.Index")    
    if CrateIndex == 10 then
        CratesCollected = CratesCollected + 1
        if CratesCollected == 3 then
            CratesCollected = 0
            SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game9")
            SendMessage("CommentaryPanel.ScriptText")
            SpawnReinforcements()
        end
    elseif CrateIndex == 20 then
        CratesCollected = CratesCollected + 1
        if CratesCollected == 2 then
            CratesCollected = 0
            SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game9")
            SendMessage("CommentaryPanel.ScriptText")
            SpawnReinforcements2()
        end
    elseif CrateIndex == 30 then
        CratesCollected = CratesCollected + 1
        if CratesCollected == 2 then
            CratesCollected = 0
            SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game9")
            SendMessage("CommentaryPanel.ScriptText")
            SpawnReinforcements()
        end
    end
end

function SpawnReinforcements()
    SetData("Crate.Spawn", "DragonballR")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 20)
    SetData("Crate.Contents", "kWeaponFirePunch")
    SendMessage("GameLogic.CreateCrate")      
   
    SetData("Crate.Spawn", "BaseballBatR")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 20)
    SetData("Crate.Contents", "kWeaponBaseballBat")
    SendMessage("GameLogic.CreateCrate")
end

function SpawnReinforcements2()
    SetData("Crate.Spawn", "DragonballR2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Index", 30)
    SetData("Crate.Contents", "kWeaponBaseballBat")
    SendMessage("GameLogic.CreateCrate")      
   
    SetData("Crate.Spawn", "FirePunchR2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", -1)
    SetData("Crate.Index", 30)
    SetData("Crate.Contents", "kWeaponProd")
    SendMessage("GameLogic.CreateCrate")
end
--bm1
function Worm_Died()
    deadworm = GetData("DeadWorm.Id")
    if deadworm == 1 or deadworm == 2 or deadworm == 3 then
        CPUDiedSoFar = CPUDiedSoFar + 1
        if CPUDiedSoFar == 3 then
            Switch = 1
            SuccessCam()
            -- here u wanna play end camera and anims
        end
    elseif deadworm == 0 or deadworm == 4 then
        HumanDiedSoFar = HumanDiedSoFar + 1
        if HumanDiedSoFar == 2 then
            if Switch == 0 then
                SendMessage("Commentary.Clear")
                SetData("CommentaryPanel.Comment", "Miss.TreeVillage.fail")
                SendMessage("CommentaryPanel.ScriptText")
                endmissionfail()
                Switch = 1
            end
        end
    elseif deadworm == 5 then
        HatDiedSoFar = HatDiedSoFar + 1
        VillagerDead = 1
        if HatDiedSoFar == 2 then
            if Switch == 0 then
                --both villagers have been killed
                SendMessage("Commentary.Clear")
                SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game10")
                SendMessage("CommentaryPanel.ScriptText")
                SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game11")
                SendMessage("CommentaryPanel.ScriptText")
                endmissionfail()
                Switch = 1
            end
        end
    elseif deadworm == 6 then
        HatDiedSoFar = HatDiedSoFar + 1
        VillagerDead = 2
        if HatDiedSoFar == 2 then
            if Switch == 0 then
                --both villagers have been killed
                SendMessage("Commentary.Clear")
                SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game10")
                SendMessage("CommentaryPanel.ScriptText")
                SetData("CommentaryPanel.Comment", "Miss.TreeVillage.game11")
                SendMessage("CommentaryPanel.ScriptText")
                endmissionfail()
                Switch = 1
            end
        end
    end
end

function CheckOneTeamVictory()
   -- Changed to use alliances rather than teams so 2 teams vs 1 can end correctly
   SendMessage("WormManager.GetActiveAlliances")
   AllianceCount = GetData("AllianceCount")
   if AllianceCount == 0 then
      -- all the teams have just snuffed it
      --SendMessage("GameLogic.Draw")
   elseif AllianceCount == 1 then
      -- only one team remains
      -- PC: changed this call to catch naughty use of GetActiveTeamIndex usage. Use the new 
      -- call to get the last team with a worm thats alive on it.
--      SendMessage("WormManager.GetSurvivingTeam")
--      WinningTeam = GetData("SurvivingTeamIndex")
      --SendIntMessage("GameLogic.Win", WinningTeam)
   else
      StartTurn()
   end
end

function SuccessCam()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.TreeVillage.success")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.TreeVillage.success2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.generic.success")
    SendMessage("CommentaryPanel.ScriptText")

    SendMessage("GameLogic.PauseGame")
    SendStringMessage("Camera.Disable", "Track")

    if VillagerDead == 0 or VillagerDead == 2 then
        SendMessage("EFMV.Start")
        SetData("Camera.Path.Knots.Position", "SuccessCam,SuccessCam2")
        SetData("Camera.Path.Knots.LookAt", "SuccessLook")
        SetData("Camera.Path.Steps.Position",800)
        SetData("Camera.Path.Steps.LookAt",800)
        SetData("Camera.Path.IgnoreInput", 1)
        SendMessage("Camera.Path.Start")
        StartTimer("endmissionsuccess", 3000)
        
        SendIntMessage("Worm.ResetAnim", 5)
        SetData("Worm.ScriptAnim", "Happy3")
        SendIntMessage("Worm.QueueAnim", 5)
        SetData("Worm.ScriptAnim", "Happy1")
        SendIntMessage("Worm.QueueAnim", 5)
        SetData("Worm.ScriptAnim", "Happy3")
        SendIntMessage("Worm.QueueAnim", 5)
    elseif VillagerDead == 1 then
        SendMessage("EFMV.Start")
        SetData("Camera.Path.Knots.Position", "OtherSuccessCam,OtherSuccessCam2")
        SetData("Camera.Path.Knots.LookAt", "OtherSuccessLook")
        SetData("Camera.Path.Steps.Position",800)
        SetData("Camera.Path.Steps.LookAt",800)
        SetData("Camera.Path.IgnoreInput", 1)
        SendMessage("Camera.Path.Start")
        StartTimer("endmissionsuccess", 3000)
        
        SendIntMessage("Worm.ResetAnim", 6)
        SetData("Worm.ScriptAnim", "Happy3")
        SendIntMessage("Worm.QueueAnim", 6)
        SetData("Worm.ScriptAnim", "Happy1")
        SendIntMessage("Worm.QueueAnim", 6)
        SetData("Worm.ScriptAnim", "Happy3")
        SendIntMessage("Worm.QueueAnim", 6)
    end
end

function FailCam()
end

function endmissionsuccess()
    Result()
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Tree")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Tree")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")
end



function endmissionfail()
    SendMessage("GameLogic.Mission.Failure")
end

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    team.AlliedGroup = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Bullies"
    team.FlagGfxName = "97"
    team.TeamColour = 1
    team.AlliedGroup = 1
    team.IsAIControlled = true
    CloseContainer(lock)
    
    lock, team = EditContainer("Team.Data02") 
    team.IsAIControlled = true
    team.Active = true
    team.Name = "The Villagers"
    team.FlagGfxName = "54"
    team.AlliedGroup = 0
    team.TeamColour = 2
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.Energy = 50
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm1"
    CloseContainer(lock) 
    
    CopyContainer("Worm.Data00", "Worm.Data00")
    lock, worm = EditContainer("Worm.Data04")    
    worm.Active = true
    worm.Name = GM.T1_W2_Name
    worm.Energy = 50
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm2"
    CloseContainer(lock) 

    lock, worm = EditContainer("Worm.Data01") 
    worm.Active = true
    worm.Name = "Kiwi Kie"
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    worm.SfxBankName = "Pirate"
    worm.Spawn = "CPUWorm1"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU1", "AIParams.Worm01")
    lock, worm = EditContainer("AIParams.Worm01") 
    worm.ForbidShotsWhenMightAffectAITrigger = 1
    CloseContainer(lock) 

    CopyContainer("Worm.Data01", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = "Dangerous Dale"
    worm.Spawn = "CPUWorm2"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm01", "AIParams.Worm02")

    CopyContainer("Worm.Data01", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = "Naughty Nic"
    worm.Spawn = "CPUWorm3"
    CloseContainer(lock)
    CopyContainer("AIParams.Worm01", "AIParams.Worm03")
    
-- The Villager Worms are below

    CopyContainer("Worm.Data02", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.IsHatWearer = true
    worm.IsAllowedToTakeTurn = false
    worm.TeamIndex = 2
    worm.Energy = 50
    worm.Name = "Danny"
    worm.Spawn = "Vspawn1"
    worm.SfxBankName = "Hippy"
    CloseContainer(lock)    
    
    CopyContainer("Worm.Data02", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    worm.IsHatWearer = true
    worm.IsAllowedToTakeTurn = false
    worm.TeamIndex = 2
    worm.Energy = 50
    worm.Name = "Karl"
    worm.Spawn = "Vspawn2"
    worm.SfxBankName = "Hippy"
    CloseContainer(lock)    
    
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.SkipGo = -1
    inventory.Parachute = -1
    --inventory.Surrender = -1
    CloseContainer(lock)
   
    lock, inventory = EditContainer("Inventory.Team01")
    inventory.Grenade = 5
    inventory.Shotgun = 1
    inventory.BaseballBat = -1
    inventory.FirePunch = -1
    inventory.SkipGo = -1
    CloseContainer(lock)   
end
