
-- Tut 1 

function Initialise()

NewCrate = 1
camdone = 0
diewhere = 1
Target = 0
Switch = 0

-- Sets up mines and turn time
   SetData("Mine.DudProbabilty", 0.1)
   SetData("Mine.MinFuse", 3000)
   SetData("Mine.MaxFuse", 4000)
   SetData("HotSeatTime", 0) -- no hotseat time
   SetData("RoundTime", 0) -- no Game timer
   SetData("TurnTime", 0) -- no game timer

    SendMessage("HUD.HideTurnTime")
    SetData("HUD.Clock.DisplayRoundTime", 0)
    SendMessage("Commentary.NoDefault")
    SendMessage("EFMV.Start")

    SendMessage("GameLogic.PlaceObjects")

    SetData("Land.Indestructable", 1)
    SendStringMessage("Camera.Disable", "Track")
    SetData("Camera.StartOfTurnCamera","Default")
    MakeNewCrate()

    SetupWormsAndTeams()
    SetupInventories()
    --StartFirstTurn()
    camera()


end

function Weapon_PoweringUpStart()
   SendMessage("Timer.EndTurn")
   SendMessage("Weapon.DisableWeaponChange")
end


function Weapon_Fired_Start()
   -- Called when powering up finishes or fire button presses
   SendMessage("Timer.EndTurn") 
   SendMessage("Weapon.DisableWeaponChange")
end


function Weapon_Fired_End()
   -- called after the short delay which plays the fire animation after which the missile is actually launched
   SendMessage("Timer.StartRetreatTimer")
   SendMessage("Weapon.Delete")
end





function TurnEnded()
   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
   if TeamCount == 0 then
      -- all the worms have just snuffed it
      
       lock, worm = EditContainer("Worm.Data00") 
       worm.Active = true
        worm.Name = GM.T1_W1_Name
        worm.SfxBankName = GM.T1_Speech
       worm.Energy = 100
       worm.Spawn = "Spawn1"
       worm.WeaponFuse = 3
       worm.WeaponIsBounceMax = false
       worm.TeamIndex = 0
       CloseContainer(lock) 
      
    SendIntMessage("Worm.Respawn", 00)
    StartTurn()

    dietext()
    
   else
      -- still at least some worms left
      StartTurn()
   end
end

function dietext()

    if diewhere == 1 then
    
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.retrymove")
       SendBriefingMessage()
    elseif diewhere == 2 then
    
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.retryjump")
       SendBriefingMessage()    
    elseif diewhere == 3 then
    
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.retrybackflipa")
       SendBriefingMessage() 
       
    elseif diewhere == 4 then
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.retryBazooka")
        SendBriefingMessage() 

    elseif diewhere == 5 then
    
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.retrysecret")
       SendBriefingMessage()    
       end
end



-- //////////////////////////////////////////////////////////////////

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = GM.T1_Name
   team.TeamColour = 0
   team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
   CloseContainer(lock) -- must close the container ASAP



   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
    worm.Name = GM.T1_W1_Name
   worm.Energy = 100
   worm.Spawn = "Spawn1"
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   worm.SfxBankName = GM.T1_Speech
   CloseContainer(lock) 
 

   SendMessage("WormManager.Reinitialise")

end

-- //////////////////////////////////////////////////////////////////

function SetupInventories()
    -- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
   inventory.SkipGo = 0

    CloseContainer(lock) -- must close the container ASAP

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   
end


function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.1*MaxWind)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", 3.3) 

end

function Crate_Collected()
    MakeNewCrate()
end

function Crate_Destroyed()
    MakeNewCrate()
end

-- When MakeNewCrate is called It runs through this below and adds 1 each time so it knows which crate it is on

function MakeNewCrate()


    if NewCrate == 1 then
	SetData("Crate.Spawn", "crate1")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 1)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 2 then
	SetData("Crate.Spawn", "crate2")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 2)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
        
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.game2a")
        SendBriefingMessage() 
    
        

     elseif NewCrate == 3 then
	SetData("Crate.Spawn", "crate3")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 3)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 4 then
	SetData("Crate.Spawn", "crate4")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 4)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 5 then
	SetData("Crate.Spawn", "crate5")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 5)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 6 then
	SetData("Crate.Spawn", "crate6")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 6)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 7 then
	SetData("Crate.Spawn", "crate7")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 7)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 8 then
	SetData("Crate.Spawn", "crate8")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 8)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 9 then
     
    SetData("CommentaryPanel.Comment", "Tut.Atlantis.game2b")
    SendBriefingMessage()      
     
     
     
     
	SetData("Crate.Spawn", "crate9")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 9)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 10 then
	SetData("Crate.Spawn", "crate10")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 10)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 11 then
	SetData("Crate.Spawn", "crate11")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 11)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 12 then
	SetData("Crate.Spawn", "crate12")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 12)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 13 then
	SetData("Crate.Spawn", "crate13")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 13)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 14 then
	SetData("Crate.Spawn", "crate14")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 14)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
        
     elseif NewCrate == 15 then
	SetData("Crate.Spawn", "crate15")
	SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 15)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
        
       SetData("CommentaryPanel.Comment", "Tut.Atlantis.game3")
       SendBriefingMessage()
       
       SetData("CommentaryPanel.Comment", "Tut.Atlantis.game4")
       SendBriefingMessage()
       
       diewhere = 2    
        
        elseif NewCrate == 16 then
     	SetData("Crate.Spawn", "crate16")
        SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 16)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")

     elseif NewCrate == 17 then
     	SetData("Crate.Spawn", "crate17")
        SetData("Crate.Type", "Health")
	SetData("Crate.NumContents", 1)
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 17)
        SetData("Crate.Scale", 1.2)
	SendMessage("GameLogic.CreateCrate")
      
        diewhere = 3

     elseif NewCrate == 18 then
     
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.game5")
        SendBriefingMessage()
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.game6a")
        SendBriefingMessage() 

        SetData("CommentaryPanel.Comment", "Tut.Atlantis.game7")
        SendBriefingMessage()  

        
        SetData("Camera.Path.IgnoreInput", 1)
        SetData("GameLogic.ArtilleryMode", 1)
        SendMessage("Commentary.Clear")
        SetData("Camera.Path.Knots.Position", "gamecam1, gamecam2")
        SetData("Camera.Path.Knots.LookAt", "gamelook1")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",500)  
        SetData("Camera.Path.Steps.LookAt",500)
        SetData("Camera.Path.Tension.Position", 0.2) 
        SetData("Camera.Path.IgnoreInput", 1)
        SendMessage("Camera.Path.Start")
        StartTimer("ResetCamera", 5000)
        StartTimer("readyCamera", 2000) 
         
         
         
       SetData("Crate.Spawn", "crate20")
       SetData("Crate.Type", "Weapon")
       SetData("Crate.NumContents", -1)
       SetData("Crate.GroundSnap", 1)
       SetData("Crate.Contents", "kWeaponBazooka")
       SetData("Crate.Index", 20)
       SetData("Crate.Scale", 1.2)
       SendMessage("GameLogic.CreateCrate")
       

     elseif NewCrate == 19 then
     	SetData("Crate.Spawn", "crate21")
        SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 21)
        SetData("Crate.Pushable", 0)
        SetData("Crate.Scale", 1.5)
	SendMessage("GameLogic.CreateCrate")
        
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.game8")
       SendBriefingMessage()
       SetData("CommentaryPanel.Comment", "Tut.Atlantis.game9")
       SendBriefingMessage()
       SetData("CommentaryPanel.Comment", "Tut.Atlantis.game10")
       SendBriefingMessage()
       diewhere = 4
        SetData("Camera.Path.IgnoreInput", 1)
        SetData("GameLogic.ArtilleryMode", 1)
        SetData("Camera.Path.Knots.Position", "TargetCam1,TargetCam2")
        SetData("Camera.Path.Knots.LookAt", "TargetLook")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",380)  
        SetData("Camera.Path.Tension.Position", -0.5) 

        SendMessage("Camera.Path.Start")
        StartTimer("ResetCamera", 5000)
        StartTimer("readyCamera", 2000) 

     elseif NewCrate == 20 then
     
        --lock, inventory = EditContainer("Inventory.Alliance00")   
        --inventory.Bazooka = 0
        --CloseContainer(lock)
        --StartTimer("weaponsback", 1000)
     
     	SetData("Crate.Spawn", "crate22")
        SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 22)
        SetData("Crate.Pushable", 0)
        SetData("Crate.Scale", 1.5)
	SendMessage("GameLogic.CreateCrate")
        
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.game11")
        SendBriefingMessage()
        

     elseif NewCrate == 21 then
     	SetData("Crate.Spawn", "crate23")
        SetData("Crate.Type", "Target")
        SetData("Crate.GroundSnap", 1)
	SetData("Crate.Index", 23)
        SetData("Crate.Pushable", 0) 
        SetData("Crate.Scale", 1.5)
	SendMessage("GameLogic.CreateCrate")
        trigger()
        

    
    elseif NewCrate == 22 then
        
        --lock, inventory = EditContainer("Inventory.Alliance00")   
        --inventory.Bazooka = 0
        --CloseContainer(lock)
       -- StartTimer("weaponsback", 1000)
        
        
        
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.game12")
        SendBriefingMessage()
        diewhere = 5
        SendMessage("Camera.SetDefault")
        SetData("Camera.Path.IgnoreInput", 1)
        SetData("GameLogic.ArtilleryMode", 1)
        SetData("Camera.Path.Knots.Position", "gamecam1a, gamecam2a")
        SetData("Camera.Path.Knots.LookAt", "gamelook2")
        SetData("Camera.Path.Loop.LookAt", 0)
        SetData("Camera.Path.Steps.Position",500)  
        SetData("Camera.Path.Steps.LookAt",500)
        SetData("Camera.Path.Tension.Position", 0.2) 

        SendMessage("Camera.Path.Start")
        StartTimer("ResetCamera", 5000)
        StartTimer("readyCamera", 2000) 
        secrettrigger()
    
    end
     
     
         NewCrate = NewCrate + 1
end

function weaponsback()

        lock, inventory = EditContainer("Inventory.Alliance00")   
        inventory.Bazooka = -1
        CloseContainer(lock)
        SendMessage("Weapon.Delete")
        SendMessage("Weapon.Create")

end

function trigger()

    SetData("Trigger.Spawn", "exit")
    SetData("Trigger.Radius", 165)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", -1)
    SetData("Trigger.TeamDestroy", 3)    
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
end

function secrettrigger()

    SetData("Trigger.Spawn", "secret1")
    SetData("Trigger.Radius", 40)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", -1)
    SetData("Trigger.TeamDestroy", 3)   
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
end

function Trigger_Collected()

	TriggerIndex = GetData("Trigger.Index")
	if TriggerIndex == 1 then
    SetData("GameOver.AwardMovie","DeathMatchDraw")
    SendMessage("GameLogic.Tutorial.Success")
            
            
        SetData("CommentaryPanel.Comment", "Miss.Generic.Win1")
        SendBriefingMessage() 
            
	end
        
      	if TriggerIndex == 2 then
        --This little section below unlocks the map for multiplayer!
    Key,Lock = EditContainer("L.L.Atlantis")
    if Lock.Locked == true then
        Lock.Locked = false
        SetData("MCa.LockedName","L.L.Atlantis")
    end
    CloseContainer(Key)
    
        
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.secret")
       SendBriefingMessage()        
	end  
        
end

function anims()

     if Switch == 0 then
        SendIntMessage("Worm.ResetAnim", 0)
        SetData("Worm.ScriptAnim", "Wave_Left")
        SendIntMessage("Worm.QueueAnim", 0)
        SetData("Worm.ScriptAnim", "Wave_Right")
        SendIntMessage("Worm.QueueAnim", 0)
        SetData("Worm.ScriptAnim", "Wave_Left")
        SendIntMessage("Worm.QueueAnim", 0)
        SetData("Worm.ScriptAnim", "Wave_Right")
        SendIntMessage("Worm.QueueAnim", 0)
        SetData("Worm.ScriptSpeech", "Hello")
        SendIntMessage("Worm.Talk", 0)
    end
        
end


function camera()
    SetData("Camera.Path.Knots.Position", "cam1,cam2,cam3,cam4,cam5,OrbitStart")
    SetData("Camera.Path.Knots.LookAt", "look1,look2,OrbitCentre")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",480)  
    SetData("Camera.Path.Steps.LookAt",490)
    SetData("Camera.Path.Tension.Position", -0.5) 
    SendMessage("Camera.Path.Start")
    
    StartTimer("anims", 5500)
end

function Camera_Path_Reached_Knot()
   knot = GetData("Camera.Path.Knot")
    
-- ends camera   
   
   if knot == "OrbitStart" then 
   
    SetData("Camera.Orbit.Speed",-0.2)
       camdone = 1
       StartFirstTurn()

       SendMessage("EFMV.End") 
       SetData("CommentaryPanel.Comment", "Tut.Atlantis.game1")
       --SendMessage("FE.InGameDialogText")
       SendBriefingMessage()
   end
end


function SendBriefingMessage()
    SendStringMessage("FE.QueuePopUpLight","Game.BriefDialog")
    
end

function Input_SomeInput()
    if camdone == 0 then
        SendIntMessage("Worm.ResetAnim", 0)
        camdone =  1
        StartFirstTurn()
        Switch = 1
        SendMessage("EFMV.End") 
               
        SetData("CommentaryPanel.Comment", "Tut.Atlantis.game1")
       --SendMessage("FE.InGameDialogText")
       SendBriefingMessage()
    end
end

function ResetCamera()

   SendMessage("Camera.SetDefault")
   
end


function readyCamera()

    SendMessage("EFMV.End")
    SetData("Camera.Path.IgnoreInput", 0)
    SetData("GameLogic.ArtilleryMode", 0)
end

function CheckOneTeamVictory()

end
